using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE134_Externally_Controlled_Format_String
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_01");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_02");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_03");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_04");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_05");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_06");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_07");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_08");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_09");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_10");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_11");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_12");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_13");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_14");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_15");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_16");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_17");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_21");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_31");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_41");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_42");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_45");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Connect_tcp_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__Database_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_01");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_02");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_03");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_04");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_05");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_06");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_07");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_08");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_09");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_10");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_11");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_12");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_13");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_14");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_15");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_16");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_17");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_21");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_31");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_41");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_42");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_45");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__Database_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Database_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_01");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_02");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_03");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_04");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_05");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_06");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_07");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_08");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_09");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_10");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_11");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_12");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_13");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_14");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_15");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_16");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_17");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_21");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_31");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_41");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_42");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_45");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__Environment_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Environment_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__File_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__File_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_01");
			(new CWE134_Externally_Controlled_Format_String__File_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_02");
			(new CWE134_Externally_Controlled_Format_String__File_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_03");
			(new CWE134_Externally_Controlled_Format_String__File_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_04");
			(new CWE134_Externally_Controlled_Format_String__File_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_05");
			(new CWE134_Externally_Controlled_Format_String__File_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_06");
			(new CWE134_Externally_Controlled_Format_String__File_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_07");
			(new CWE134_Externally_Controlled_Format_String__File_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_08");
			(new CWE134_Externally_Controlled_Format_String__File_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_09");
			(new CWE134_Externally_Controlled_Format_String__File_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_10");
			(new CWE134_Externally_Controlled_Format_String__File_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_11");
			(new CWE134_Externally_Controlled_Format_String__File_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_12");
			(new CWE134_Externally_Controlled_Format_String__File_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_13");
			(new CWE134_Externally_Controlled_Format_String__File_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_14");
			(new CWE134_Externally_Controlled_Format_String__File_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_15");
			(new CWE134_Externally_Controlled_Format_String__File_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_16");
			(new CWE134_Externally_Controlled_Format_String__File_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_17");
			(new CWE134_Externally_Controlled_Format_String__File_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_21");
			(new CWE134_Externally_Controlled_Format_String__File_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_31");
			(new CWE134_Externally_Controlled_Format_String__File_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_41");
			(new CWE134_Externally_Controlled_Format_String__File_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_42");
			(new CWE134_Externally_Controlled_Format_String__File_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_45");
			(new CWE134_Externally_Controlled_Format_String__File_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__File_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__File_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_01");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_02");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_03");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_04");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_05");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_06");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_07");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_08");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_09");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_10");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_11");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_12");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_13");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_14");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_15");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_16");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_17");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_21");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_31");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_41");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_42");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_45");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__Listen_tcp_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_01");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_02");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_03");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_04");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_05");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_06");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_07");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_08");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_09");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_10");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_11");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_12");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_13");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_14");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_15");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_16");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_17");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_21");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_31");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_41");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_42");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_45");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__NetClient_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__NetClient_Format_81a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_01()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_01");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_02()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_02");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_03()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_03");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_04()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_04");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_05()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_05");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_06()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_06");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_07()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_07");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_08()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_08");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_09()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_09");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_10()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_10");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_11()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_11");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_12()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_12");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_13()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_13");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_14()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_14");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_15()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_15");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_16()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_16");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_17()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_17");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_21()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_21");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_22a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_22a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_31()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_31");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_41()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_41");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_42()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_42");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_45()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_45");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_51a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_51a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_52a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_52a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_53a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_53a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_54a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_54a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_61a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_61a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_66a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_66a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_67a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_67a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_68a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_68a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_71a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_71a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_72a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_72a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_73a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_73a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_74a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_74a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_75a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_75a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_81a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_console_interpolation_81a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_01()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_01");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_02()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_02");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_03()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_03");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_04()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_04");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_05()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_05");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_06()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_06");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_07()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_07");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_08()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_08");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_09()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_09");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_10()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_10");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_11()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_11");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_12()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_12");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_13()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_13");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_14()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_14");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_15()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_15");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_16()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_16");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_17()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_17");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_21()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_21");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_22a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_22a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_31()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_31");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_41()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_41");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_42()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_42");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_45()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_45");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_51a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_51a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_52a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_52a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_53a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_53a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_54a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_54a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_61a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_61a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_66a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_66a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_67a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_67a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_68a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_68a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_71a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_71a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_72a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_72a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_73a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_73a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_74a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_74a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_75a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_75a");
			(new CWE134_Externally_Controlled_Format_String__ReadLine_Format_81a()).RunTest("CWE134_Externally_Controlled_Format_String__ReadLine_Format_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}