using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE190_Integer_Overflow
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE190_Integer_Overflow__int_Environment_multiply_01()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_01");
			(new CWE190_Integer_Overflow__int_Environment_multiply_02()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_02");
			(new CWE190_Integer_Overflow__int_Environment_multiply_03()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_03");
			(new CWE190_Integer_Overflow__int_Environment_multiply_04()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_04");
			(new CWE190_Integer_Overflow__int_Environment_multiply_05()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_05");
			(new CWE190_Integer_Overflow__int_Environment_multiply_06()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_06");
			(new CWE190_Integer_Overflow__int_Environment_multiply_07()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_07");
			(new CWE190_Integer_Overflow__int_Environment_multiply_08()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_08");
			(new CWE190_Integer_Overflow__int_Environment_multiply_09()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_09");
			(new CWE190_Integer_Overflow__int_Environment_multiply_10()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_10");
			(new CWE190_Integer_Overflow__int_Environment_multiply_11()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_11");
			(new CWE190_Integer_Overflow__int_Environment_multiply_12()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_12");
			(new CWE190_Integer_Overflow__int_Environment_multiply_13()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_13");
			(new CWE190_Integer_Overflow__int_Environment_multiply_14()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_14");
			(new CWE190_Integer_Overflow__int_Environment_multiply_15()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_15");
			(new CWE190_Integer_Overflow__int_Environment_multiply_16()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_16");
			(new CWE190_Integer_Overflow__int_Environment_multiply_17()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_17");
			(new CWE190_Integer_Overflow__int_Environment_multiply_21()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_21");
			(new CWE190_Integer_Overflow__int_Environment_multiply_22a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_22a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_31()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_31");
			(new CWE190_Integer_Overflow__int_Environment_multiply_41()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_41");
			(new CWE190_Integer_Overflow__int_Environment_multiply_42()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_42");
			(new CWE190_Integer_Overflow__int_Environment_multiply_45()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_45");
			(new CWE190_Integer_Overflow__int_Environment_multiply_51a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_51a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_52a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_52a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_53a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_53a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_54a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_54a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_61a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_61a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_66a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_66a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_67a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_67a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_68a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_68a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_71a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_71a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_72a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_72a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_73a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_73a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_74a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_74a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_75a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_75a");
			(new CWE190_Integer_Overflow__int_Environment_multiply_81a()).RunTest("CWE190_Integer_Overflow__int_Environment_multiply_81a");
			(new CWE190_Integer_Overflow__int_Environment_square_01()).RunTest("CWE190_Integer_Overflow__int_Environment_square_01");
			(new CWE190_Integer_Overflow__int_Environment_square_02()).RunTest("CWE190_Integer_Overflow__int_Environment_square_02");
			(new CWE190_Integer_Overflow__int_Environment_square_03()).RunTest("CWE190_Integer_Overflow__int_Environment_square_03");
			(new CWE190_Integer_Overflow__int_Environment_square_04()).RunTest("CWE190_Integer_Overflow__int_Environment_square_04");
			(new CWE190_Integer_Overflow__int_Environment_square_05()).RunTest("CWE190_Integer_Overflow__int_Environment_square_05");
			(new CWE190_Integer_Overflow__int_Environment_square_06()).RunTest("CWE190_Integer_Overflow__int_Environment_square_06");
			(new CWE190_Integer_Overflow__int_Environment_square_07()).RunTest("CWE190_Integer_Overflow__int_Environment_square_07");
			(new CWE190_Integer_Overflow__int_Environment_square_08()).RunTest("CWE190_Integer_Overflow__int_Environment_square_08");
			(new CWE190_Integer_Overflow__int_Environment_square_09()).RunTest("CWE190_Integer_Overflow__int_Environment_square_09");
			(new CWE190_Integer_Overflow__int_Environment_square_10()).RunTest("CWE190_Integer_Overflow__int_Environment_square_10");
			(new CWE190_Integer_Overflow__int_Environment_square_11()).RunTest("CWE190_Integer_Overflow__int_Environment_square_11");
			(new CWE190_Integer_Overflow__int_Environment_square_12()).RunTest("CWE190_Integer_Overflow__int_Environment_square_12");
			(new CWE190_Integer_Overflow__int_Environment_square_13()).RunTest("CWE190_Integer_Overflow__int_Environment_square_13");
			(new CWE190_Integer_Overflow__int_Environment_square_14()).RunTest("CWE190_Integer_Overflow__int_Environment_square_14");
			(new CWE190_Integer_Overflow__int_Environment_square_15()).RunTest("CWE190_Integer_Overflow__int_Environment_square_15");
			(new CWE190_Integer_Overflow__int_Environment_square_16()).RunTest("CWE190_Integer_Overflow__int_Environment_square_16");
			(new CWE190_Integer_Overflow__int_Environment_square_17()).RunTest("CWE190_Integer_Overflow__int_Environment_square_17");
			(new CWE190_Integer_Overflow__int_Environment_square_21()).RunTest("CWE190_Integer_Overflow__int_Environment_square_21");
			(new CWE190_Integer_Overflow__int_Environment_square_22a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_22a");
			(new CWE190_Integer_Overflow__int_Environment_square_31()).RunTest("CWE190_Integer_Overflow__int_Environment_square_31");
			(new CWE190_Integer_Overflow__int_Environment_square_41()).RunTest("CWE190_Integer_Overflow__int_Environment_square_41");
			(new CWE190_Integer_Overflow__int_Environment_square_42()).RunTest("CWE190_Integer_Overflow__int_Environment_square_42");
			(new CWE190_Integer_Overflow__int_Environment_square_45()).RunTest("CWE190_Integer_Overflow__int_Environment_square_45");
			(new CWE190_Integer_Overflow__int_Environment_square_51a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_51a");
			(new CWE190_Integer_Overflow__int_Environment_square_52a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_52a");
			(new CWE190_Integer_Overflow__int_Environment_square_53a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_53a");
			(new CWE190_Integer_Overflow__int_Environment_square_54a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_54a");
			(new CWE190_Integer_Overflow__int_Environment_square_61a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_61a");
			(new CWE190_Integer_Overflow__int_Environment_square_66a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_66a");
			(new CWE190_Integer_Overflow__int_Environment_square_67a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_67a");
			(new CWE190_Integer_Overflow__int_Environment_square_68a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_68a");
			(new CWE190_Integer_Overflow__int_Environment_square_71a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_71a");
			(new CWE190_Integer_Overflow__int_Environment_square_72a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_72a");
			(new CWE190_Integer_Overflow__int_Environment_square_73a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_73a");
			(new CWE190_Integer_Overflow__int_Environment_square_74a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_74a");
			(new CWE190_Integer_Overflow__int_Environment_square_75a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_75a");
			(new CWE190_Integer_Overflow__int_Environment_square_81a()).RunTest("CWE190_Integer_Overflow__int_Environment_square_81a");
			(new CWE190_Integer_Overflow__int_File_add_01()).RunTest("CWE190_Integer_Overflow__int_File_add_01");
			(new CWE190_Integer_Overflow__int_File_add_02()).RunTest("CWE190_Integer_Overflow__int_File_add_02");
			(new CWE190_Integer_Overflow__int_File_add_03()).RunTest("CWE190_Integer_Overflow__int_File_add_03");
			(new CWE190_Integer_Overflow__int_File_add_04()).RunTest("CWE190_Integer_Overflow__int_File_add_04");
			(new CWE190_Integer_Overflow__int_File_add_05()).RunTest("CWE190_Integer_Overflow__int_File_add_05");
			(new CWE190_Integer_Overflow__int_File_add_06()).RunTest("CWE190_Integer_Overflow__int_File_add_06");
			(new CWE190_Integer_Overflow__int_File_add_07()).RunTest("CWE190_Integer_Overflow__int_File_add_07");
			(new CWE190_Integer_Overflow__int_File_add_08()).RunTest("CWE190_Integer_Overflow__int_File_add_08");
			(new CWE190_Integer_Overflow__int_File_add_09()).RunTest("CWE190_Integer_Overflow__int_File_add_09");
			(new CWE190_Integer_Overflow__int_File_add_10()).RunTest("CWE190_Integer_Overflow__int_File_add_10");
			(new CWE190_Integer_Overflow__int_File_add_11()).RunTest("CWE190_Integer_Overflow__int_File_add_11");
			(new CWE190_Integer_Overflow__int_File_add_12()).RunTest("CWE190_Integer_Overflow__int_File_add_12");
			(new CWE190_Integer_Overflow__int_File_add_13()).RunTest("CWE190_Integer_Overflow__int_File_add_13");
			(new CWE190_Integer_Overflow__int_File_add_14()).RunTest("CWE190_Integer_Overflow__int_File_add_14");
			(new CWE190_Integer_Overflow__int_File_add_15()).RunTest("CWE190_Integer_Overflow__int_File_add_15");
			(new CWE190_Integer_Overflow__int_File_add_16()).RunTest("CWE190_Integer_Overflow__int_File_add_16");
			(new CWE190_Integer_Overflow__int_File_add_17()).RunTest("CWE190_Integer_Overflow__int_File_add_17");
			(new CWE190_Integer_Overflow__int_File_add_21()).RunTest("CWE190_Integer_Overflow__int_File_add_21");
			(new CWE190_Integer_Overflow__int_File_add_22a()).RunTest("CWE190_Integer_Overflow__int_File_add_22a");
			(new CWE190_Integer_Overflow__int_File_add_31()).RunTest("CWE190_Integer_Overflow__int_File_add_31");
			(new CWE190_Integer_Overflow__int_File_add_41()).RunTest("CWE190_Integer_Overflow__int_File_add_41");
			(new CWE190_Integer_Overflow__int_File_add_42()).RunTest("CWE190_Integer_Overflow__int_File_add_42");
			(new CWE190_Integer_Overflow__int_File_add_45()).RunTest("CWE190_Integer_Overflow__int_File_add_45");
			(new CWE190_Integer_Overflow__int_File_add_51a()).RunTest("CWE190_Integer_Overflow__int_File_add_51a");
			(new CWE190_Integer_Overflow__int_File_add_52a()).RunTest("CWE190_Integer_Overflow__int_File_add_52a");
			(new CWE190_Integer_Overflow__int_File_add_53a()).RunTest("CWE190_Integer_Overflow__int_File_add_53a");
			(new CWE190_Integer_Overflow__int_File_add_54a()).RunTest("CWE190_Integer_Overflow__int_File_add_54a");
			(new CWE190_Integer_Overflow__int_File_add_61a()).RunTest("CWE190_Integer_Overflow__int_File_add_61a");
			(new CWE190_Integer_Overflow__int_File_add_66a()).RunTest("CWE190_Integer_Overflow__int_File_add_66a");
			(new CWE190_Integer_Overflow__int_File_add_67a()).RunTest("CWE190_Integer_Overflow__int_File_add_67a");
			(new CWE190_Integer_Overflow__int_File_add_68a()).RunTest("CWE190_Integer_Overflow__int_File_add_68a");
			(new CWE190_Integer_Overflow__int_File_add_71a()).RunTest("CWE190_Integer_Overflow__int_File_add_71a");
			(new CWE190_Integer_Overflow__int_File_add_72a()).RunTest("CWE190_Integer_Overflow__int_File_add_72a");
			(new CWE190_Integer_Overflow__int_File_add_73a()).RunTest("CWE190_Integer_Overflow__int_File_add_73a");
			(new CWE190_Integer_Overflow__int_File_add_74a()).RunTest("CWE190_Integer_Overflow__int_File_add_74a");
			(new CWE190_Integer_Overflow__int_File_add_75a()).RunTest("CWE190_Integer_Overflow__int_File_add_75a");
			(new CWE190_Integer_Overflow__int_File_add_81a()).RunTest("CWE190_Integer_Overflow__int_File_add_81a");
			(new CWE190_Integer_Overflow__int_File_multiply_01()).RunTest("CWE190_Integer_Overflow__int_File_multiply_01");
			(new CWE190_Integer_Overflow__int_File_multiply_02()).RunTest("CWE190_Integer_Overflow__int_File_multiply_02");
			(new CWE190_Integer_Overflow__int_File_multiply_03()).RunTest("CWE190_Integer_Overflow__int_File_multiply_03");
			(new CWE190_Integer_Overflow__int_File_multiply_04()).RunTest("CWE190_Integer_Overflow__int_File_multiply_04");
			(new CWE190_Integer_Overflow__int_File_multiply_05()).RunTest("CWE190_Integer_Overflow__int_File_multiply_05");
			(new CWE190_Integer_Overflow__int_File_multiply_06()).RunTest("CWE190_Integer_Overflow__int_File_multiply_06");
			(new CWE190_Integer_Overflow__int_File_multiply_07()).RunTest("CWE190_Integer_Overflow__int_File_multiply_07");
			(new CWE190_Integer_Overflow__int_File_multiply_08()).RunTest("CWE190_Integer_Overflow__int_File_multiply_08");
			(new CWE190_Integer_Overflow__int_File_multiply_09()).RunTest("CWE190_Integer_Overflow__int_File_multiply_09");
			(new CWE190_Integer_Overflow__int_File_multiply_10()).RunTest("CWE190_Integer_Overflow__int_File_multiply_10");
			(new CWE190_Integer_Overflow__int_File_multiply_11()).RunTest("CWE190_Integer_Overflow__int_File_multiply_11");
			(new CWE190_Integer_Overflow__int_File_multiply_12()).RunTest("CWE190_Integer_Overflow__int_File_multiply_12");
			(new CWE190_Integer_Overflow__int_File_multiply_13()).RunTest("CWE190_Integer_Overflow__int_File_multiply_13");
			(new CWE190_Integer_Overflow__int_File_multiply_14()).RunTest("CWE190_Integer_Overflow__int_File_multiply_14");
			(new CWE190_Integer_Overflow__int_File_multiply_15()).RunTest("CWE190_Integer_Overflow__int_File_multiply_15");
			(new CWE190_Integer_Overflow__int_File_multiply_16()).RunTest("CWE190_Integer_Overflow__int_File_multiply_16");
			(new CWE190_Integer_Overflow__int_File_multiply_17()).RunTest("CWE190_Integer_Overflow__int_File_multiply_17");
			(new CWE190_Integer_Overflow__int_File_multiply_21()).RunTest("CWE190_Integer_Overflow__int_File_multiply_21");
			(new CWE190_Integer_Overflow__int_File_multiply_22a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_22a");
			(new CWE190_Integer_Overflow__int_File_multiply_31()).RunTest("CWE190_Integer_Overflow__int_File_multiply_31");
			(new CWE190_Integer_Overflow__int_File_multiply_41()).RunTest("CWE190_Integer_Overflow__int_File_multiply_41");
			(new CWE190_Integer_Overflow__int_File_multiply_42()).RunTest("CWE190_Integer_Overflow__int_File_multiply_42");
			(new CWE190_Integer_Overflow__int_File_multiply_45()).RunTest("CWE190_Integer_Overflow__int_File_multiply_45");
			(new CWE190_Integer_Overflow__int_File_multiply_51a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_51a");
			(new CWE190_Integer_Overflow__int_File_multiply_52a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_52a");
			(new CWE190_Integer_Overflow__int_File_multiply_53a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_53a");
			(new CWE190_Integer_Overflow__int_File_multiply_54a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_54a");
			(new CWE190_Integer_Overflow__int_File_multiply_61a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_61a");
			(new CWE190_Integer_Overflow__int_File_multiply_66a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_66a");
			(new CWE190_Integer_Overflow__int_File_multiply_67a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_67a");
			(new CWE190_Integer_Overflow__int_File_multiply_68a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_68a");
			(new CWE190_Integer_Overflow__int_File_multiply_71a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_71a");
			(new CWE190_Integer_Overflow__int_File_multiply_72a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_72a");
			(new CWE190_Integer_Overflow__int_File_multiply_73a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_73a");
			(new CWE190_Integer_Overflow__int_File_multiply_74a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_74a");
			(new CWE190_Integer_Overflow__int_File_multiply_75a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_75a");
			(new CWE190_Integer_Overflow__int_File_multiply_81a()).RunTest("CWE190_Integer_Overflow__int_File_multiply_81a");
			(new CWE190_Integer_Overflow__int_File_square_01()).RunTest("CWE190_Integer_Overflow__int_File_square_01");
			(new CWE190_Integer_Overflow__int_File_square_02()).RunTest("CWE190_Integer_Overflow__int_File_square_02");
			(new CWE190_Integer_Overflow__int_File_square_03()).RunTest("CWE190_Integer_Overflow__int_File_square_03");
			(new CWE190_Integer_Overflow__int_File_square_04()).RunTest("CWE190_Integer_Overflow__int_File_square_04");
			(new CWE190_Integer_Overflow__int_File_square_05()).RunTest("CWE190_Integer_Overflow__int_File_square_05");
			(new CWE190_Integer_Overflow__int_File_square_06()).RunTest("CWE190_Integer_Overflow__int_File_square_06");
			(new CWE190_Integer_Overflow__int_File_square_07()).RunTest("CWE190_Integer_Overflow__int_File_square_07");
			(new CWE190_Integer_Overflow__int_File_square_08()).RunTest("CWE190_Integer_Overflow__int_File_square_08");
			(new CWE190_Integer_Overflow__int_File_square_09()).RunTest("CWE190_Integer_Overflow__int_File_square_09");
			(new CWE190_Integer_Overflow__int_File_square_10()).RunTest("CWE190_Integer_Overflow__int_File_square_10");
			(new CWE190_Integer_Overflow__int_File_square_11()).RunTest("CWE190_Integer_Overflow__int_File_square_11");
			(new CWE190_Integer_Overflow__int_File_square_12()).RunTest("CWE190_Integer_Overflow__int_File_square_12");
			(new CWE190_Integer_Overflow__int_File_square_13()).RunTest("CWE190_Integer_Overflow__int_File_square_13");
			(new CWE190_Integer_Overflow__int_File_square_14()).RunTest("CWE190_Integer_Overflow__int_File_square_14");
			(new CWE190_Integer_Overflow__int_File_square_15()).RunTest("CWE190_Integer_Overflow__int_File_square_15");
			(new CWE190_Integer_Overflow__int_File_square_16()).RunTest("CWE190_Integer_Overflow__int_File_square_16");
			(new CWE190_Integer_Overflow__int_File_square_17()).RunTest("CWE190_Integer_Overflow__int_File_square_17");
			(new CWE190_Integer_Overflow__int_File_square_21()).RunTest("CWE190_Integer_Overflow__int_File_square_21");
			(new CWE190_Integer_Overflow__int_File_square_22a()).RunTest("CWE190_Integer_Overflow__int_File_square_22a");
			(new CWE190_Integer_Overflow__int_File_square_31()).RunTest("CWE190_Integer_Overflow__int_File_square_31");
			(new CWE190_Integer_Overflow__int_File_square_41()).RunTest("CWE190_Integer_Overflow__int_File_square_41");
			(new CWE190_Integer_Overflow__int_File_square_42()).RunTest("CWE190_Integer_Overflow__int_File_square_42");
			(new CWE190_Integer_Overflow__int_File_square_45()).RunTest("CWE190_Integer_Overflow__int_File_square_45");
			(new CWE190_Integer_Overflow__int_File_square_51a()).RunTest("CWE190_Integer_Overflow__int_File_square_51a");
			(new CWE190_Integer_Overflow__int_File_square_52a()).RunTest("CWE190_Integer_Overflow__int_File_square_52a");
			(new CWE190_Integer_Overflow__int_File_square_53a()).RunTest("CWE190_Integer_Overflow__int_File_square_53a");
			(new CWE190_Integer_Overflow__int_File_square_54a()).RunTest("CWE190_Integer_Overflow__int_File_square_54a");
			(new CWE190_Integer_Overflow__int_File_square_61a()).RunTest("CWE190_Integer_Overflow__int_File_square_61a");
			(new CWE190_Integer_Overflow__int_File_square_66a()).RunTest("CWE190_Integer_Overflow__int_File_square_66a");
			(new CWE190_Integer_Overflow__int_File_square_67a()).RunTest("CWE190_Integer_Overflow__int_File_square_67a");
			(new CWE190_Integer_Overflow__int_File_square_68a()).RunTest("CWE190_Integer_Overflow__int_File_square_68a");
			(new CWE190_Integer_Overflow__int_File_square_71a()).RunTest("CWE190_Integer_Overflow__int_File_square_71a");
			(new CWE190_Integer_Overflow__int_File_square_72a()).RunTest("CWE190_Integer_Overflow__int_File_square_72a");
			(new CWE190_Integer_Overflow__int_File_square_73a()).RunTest("CWE190_Integer_Overflow__int_File_square_73a");
			(new CWE190_Integer_Overflow__int_File_square_74a()).RunTest("CWE190_Integer_Overflow__int_File_square_74a");
			(new CWE190_Integer_Overflow__int_File_square_75a()).RunTest("CWE190_Integer_Overflow__int_File_square_75a");
			(new CWE190_Integer_Overflow__int_File_square_81a()).RunTest("CWE190_Integer_Overflow__int_File_square_81a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_01()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_01");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_02()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_02");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_03()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_03");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_04()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_04");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_05()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_05");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_06()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_06");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_07()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_07");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_08()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_08");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_09()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_09");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_10()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_10");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_11()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_11");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_12()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_12");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_13()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_13");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_14()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_14");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_15()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_15");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_16()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_16");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_17()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_17");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_21()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_21");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_22a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_22a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_31()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_31");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_41()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_41");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_42()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_42");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_45()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_45");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_51a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_51a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_52a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_52a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_53a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_53a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_54a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_54a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_61a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_61a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_66a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_66a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_67a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_67a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_68a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_68a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_71a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_71a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_72a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_72a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_73a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_73a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_74a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_74a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_75a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_75a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_add_81a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_add_81a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_01()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_01");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_02()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_02");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_03()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_03");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_04()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_04");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_05()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_05");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_06()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_06");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_07()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_07");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_08()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_08");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_09()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_09");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_10()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_10");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_11()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_11");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_12()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_12");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_13()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_13");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_14()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_14");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_15()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_15");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_16()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_16");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_17()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_17");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_21()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_21");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_22a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_22a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_31()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_31");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_41()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_41");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_42()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_42");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_45()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_45");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_51a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_51a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_52a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_52a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_53a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_53a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_54a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_54a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_61a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_61a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_66a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_66a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_67a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_67a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_68a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_68a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_71a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_71a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_72a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_72a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_73a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_73a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_74a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_74a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_75a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_75a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_multiply_81a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_multiply_81a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_01()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_01");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_02()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_02");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_03()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_03");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_04()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_04");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_05()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_05");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_06()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_06");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_07()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_07");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_08()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_08");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_09()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_09");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_10()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_10");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_11()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_11");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_12()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_12");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_13()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_13");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_14()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_14");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_15()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_15");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_16()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_16");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_17()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_17");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_21()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_21");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_22a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_22a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_31()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_31");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_41()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_41");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_42()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_42");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_45()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_45");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_51a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_51a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_52a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_52a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_53a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_53a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_54a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_54a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_61a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_61a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_66a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_66a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_67a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_67a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_68a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_68a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_71a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_71a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_72a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_72a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_73a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_73a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_74a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_74a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_75a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_75a");
			(new CWE190_Integer_Overflow__int_Listen_tcp_square_81a()).RunTest("CWE190_Integer_Overflow__int_Listen_tcp_square_81a");
			(new CWE190_Integer_Overflow__int_max_add_01()).RunTest("CWE190_Integer_Overflow__int_max_add_01");
			(new CWE190_Integer_Overflow__int_max_add_02()).RunTest("CWE190_Integer_Overflow__int_max_add_02");
			(new CWE190_Integer_Overflow__int_max_add_03()).RunTest("CWE190_Integer_Overflow__int_max_add_03");
			(new CWE190_Integer_Overflow__int_max_add_04()).RunTest("CWE190_Integer_Overflow__int_max_add_04");
			(new CWE190_Integer_Overflow__int_max_add_05()).RunTest("CWE190_Integer_Overflow__int_max_add_05");
			(new CWE190_Integer_Overflow__int_max_add_06()).RunTest("CWE190_Integer_Overflow__int_max_add_06");
			(new CWE190_Integer_Overflow__int_max_add_07()).RunTest("CWE190_Integer_Overflow__int_max_add_07");
			(new CWE190_Integer_Overflow__int_max_add_08()).RunTest("CWE190_Integer_Overflow__int_max_add_08");
			(new CWE190_Integer_Overflow__int_max_add_09()).RunTest("CWE190_Integer_Overflow__int_max_add_09");
			(new CWE190_Integer_Overflow__int_max_add_10()).RunTest("CWE190_Integer_Overflow__int_max_add_10");
			(new CWE190_Integer_Overflow__int_max_add_11()).RunTest("CWE190_Integer_Overflow__int_max_add_11");
			(new CWE190_Integer_Overflow__int_max_add_12()).RunTest("CWE190_Integer_Overflow__int_max_add_12");
			(new CWE190_Integer_Overflow__int_max_add_13()).RunTest("CWE190_Integer_Overflow__int_max_add_13");
			(new CWE190_Integer_Overflow__int_max_add_14()).RunTest("CWE190_Integer_Overflow__int_max_add_14");
			(new CWE190_Integer_Overflow__int_max_add_15()).RunTest("CWE190_Integer_Overflow__int_max_add_15");
			(new CWE190_Integer_Overflow__int_max_add_16()).RunTest("CWE190_Integer_Overflow__int_max_add_16");
			(new CWE190_Integer_Overflow__int_max_add_17()).RunTest("CWE190_Integer_Overflow__int_max_add_17");
			(new CWE190_Integer_Overflow__int_max_add_21()).RunTest("CWE190_Integer_Overflow__int_max_add_21");
			(new CWE190_Integer_Overflow__int_max_add_22a()).RunTest("CWE190_Integer_Overflow__int_max_add_22a");
			(new CWE190_Integer_Overflow__int_max_add_31()).RunTest("CWE190_Integer_Overflow__int_max_add_31");
			(new CWE190_Integer_Overflow__int_max_add_41()).RunTest("CWE190_Integer_Overflow__int_max_add_41");
			(new CWE190_Integer_Overflow__int_max_add_42()).RunTest("CWE190_Integer_Overflow__int_max_add_42");
			(new CWE190_Integer_Overflow__int_max_add_45()).RunTest("CWE190_Integer_Overflow__int_max_add_45");
			(new CWE190_Integer_Overflow__int_max_add_51a()).RunTest("CWE190_Integer_Overflow__int_max_add_51a");
			(new CWE190_Integer_Overflow__int_max_add_52a()).RunTest("CWE190_Integer_Overflow__int_max_add_52a");
			(new CWE190_Integer_Overflow__int_max_add_53a()).RunTest("CWE190_Integer_Overflow__int_max_add_53a");
			(new CWE190_Integer_Overflow__int_max_add_54a()).RunTest("CWE190_Integer_Overflow__int_max_add_54a");
			(new CWE190_Integer_Overflow__int_max_add_61a()).RunTest("CWE190_Integer_Overflow__int_max_add_61a");
			(new CWE190_Integer_Overflow__int_max_add_66a()).RunTest("CWE190_Integer_Overflow__int_max_add_66a");
			(new CWE190_Integer_Overflow__int_max_add_67a()).RunTest("CWE190_Integer_Overflow__int_max_add_67a");
			(new CWE190_Integer_Overflow__int_max_add_68a()).RunTest("CWE190_Integer_Overflow__int_max_add_68a");
			(new CWE190_Integer_Overflow__int_max_add_71a()).RunTest("CWE190_Integer_Overflow__int_max_add_71a");
			(new CWE190_Integer_Overflow__int_max_add_72a()).RunTest("CWE190_Integer_Overflow__int_max_add_72a");
			(new CWE190_Integer_Overflow__int_max_add_73a()).RunTest("CWE190_Integer_Overflow__int_max_add_73a");
			(new CWE190_Integer_Overflow__int_max_add_74a()).RunTest("CWE190_Integer_Overflow__int_max_add_74a");
			(new CWE190_Integer_Overflow__int_max_add_75a()).RunTest("CWE190_Integer_Overflow__int_max_add_75a");
			(new CWE190_Integer_Overflow__int_max_add_81a()).RunTest("CWE190_Integer_Overflow__int_max_add_81a");
			(new CWE190_Integer_Overflow__int_max_multiply_01()).RunTest("CWE190_Integer_Overflow__int_max_multiply_01");
			(new CWE190_Integer_Overflow__int_max_multiply_02()).RunTest("CWE190_Integer_Overflow__int_max_multiply_02");
			(new CWE190_Integer_Overflow__int_max_multiply_03()).RunTest("CWE190_Integer_Overflow__int_max_multiply_03");
			(new CWE190_Integer_Overflow__int_max_multiply_04()).RunTest("CWE190_Integer_Overflow__int_max_multiply_04");
			(new CWE190_Integer_Overflow__int_max_multiply_05()).RunTest("CWE190_Integer_Overflow__int_max_multiply_05");
			(new CWE190_Integer_Overflow__int_max_multiply_06()).RunTest("CWE190_Integer_Overflow__int_max_multiply_06");
			(new CWE190_Integer_Overflow__int_max_multiply_07()).RunTest("CWE190_Integer_Overflow__int_max_multiply_07");
			(new CWE190_Integer_Overflow__int_max_multiply_08()).RunTest("CWE190_Integer_Overflow__int_max_multiply_08");
			(new CWE190_Integer_Overflow__int_max_multiply_09()).RunTest("CWE190_Integer_Overflow__int_max_multiply_09");
			(new CWE190_Integer_Overflow__int_max_multiply_10()).RunTest("CWE190_Integer_Overflow__int_max_multiply_10");
			(new CWE190_Integer_Overflow__int_max_multiply_11()).RunTest("CWE190_Integer_Overflow__int_max_multiply_11");
			(new CWE190_Integer_Overflow__int_max_multiply_12()).RunTest("CWE190_Integer_Overflow__int_max_multiply_12");
			(new CWE190_Integer_Overflow__int_max_multiply_13()).RunTest("CWE190_Integer_Overflow__int_max_multiply_13");
			(new CWE190_Integer_Overflow__int_max_multiply_14()).RunTest("CWE190_Integer_Overflow__int_max_multiply_14");
			(new CWE190_Integer_Overflow__int_max_multiply_15()).RunTest("CWE190_Integer_Overflow__int_max_multiply_15");
			(new CWE190_Integer_Overflow__int_max_multiply_16()).RunTest("CWE190_Integer_Overflow__int_max_multiply_16");
			(new CWE190_Integer_Overflow__int_max_multiply_17()).RunTest("CWE190_Integer_Overflow__int_max_multiply_17");
			(new CWE190_Integer_Overflow__int_max_multiply_21()).RunTest("CWE190_Integer_Overflow__int_max_multiply_21");
			(new CWE190_Integer_Overflow__int_max_multiply_22a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_22a");
			(new CWE190_Integer_Overflow__int_max_multiply_31()).RunTest("CWE190_Integer_Overflow__int_max_multiply_31");
			(new CWE190_Integer_Overflow__int_max_multiply_41()).RunTest("CWE190_Integer_Overflow__int_max_multiply_41");
			(new CWE190_Integer_Overflow__int_max_multiply_42()).RunTest("CWE190_Integer_Overflow__int_max_multiply_42");
			(new CWE190_Integer_Overflow__int_max_multiply_45()).RunTest("CWE190_Integer_Overflow__int_max_multiply_45");
			(new CWE190_Integer_Overflow__int_max_multiply_51a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_51a");
			(new CWE190_Integer_Overflow__int_max_multiply_52a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_52a");
			(new CWE190_Integer_Overflow__int_max_multiply_53a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_53a");
			(new CWE190_Integer_Overflow__int_max_multiply_54a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_54a");
			(new CWE190_Integer_Overflow__int_max_multiply_61a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_61a");
			(new CWE190_Integer_Overflow__int_max_multiply_66a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_66a");
			(new CWE190_Integer_Overflow__int_max_multiply_67a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_67a");
			(new CWE190_Integer_Overflow__int_max_multiply_68a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_68a");
			(new CWE190_Integer_Overflow__int_max_multiply_71a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_71a");
			(new CWE190_Integer_Overflow__int_max_multiply_72a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_72a");
			(new CWE190_Integer_Overflow__int_max_multiply_73a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_73a");
			(new CWE190_Integer_Overflow__int_max_multiply_74a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_74a");
			(new CWE190_Integer_Overflow__int_max_multiply_75a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_75a");
			(new CWE190_Integer_Overflow__int_max_multiply_81a()).RunTest("CWE190_Integer_Overflow__int_max_multiply_81a");
			(new CWE190_Integer_Overflow__int_max_square_01()).RunTest("CWE190_Integer_Overflow__int_max_square_01");
			(new CWE190_Integer_Overflow__int_max_square_02()).RunTest("CWE190_Integer_Overflow__int_max_square_02");
			(new CWE190_Integer_Overflow__int_max_square_03()).RunTest("CWE190_Integer_Overflow__int_max_square_03");
			(new CWE190_Integer_Overflow__int_max_square_04()).RunTest("CWE190_Integer_Overflow__int_max_square_04");
			(new CWE190_Integer_Overflow__int_max_square_05()).RunTest("CWE190_Integer_Overflow__int_max_square_05");
			(new CWE190_Integer_Overflow__int_max_square_06()).RunTest("CWE190_Integer_Overflow__int_max_square_06");
			(new CWE190_Integer_Overflow__int_max_square_07()).RunTest("CWE190_Integer_Overflow__int_max_square_07");
			(new CWE190_Integer_Overflow__int_max_square_08()).RunTest("CWE190_Integer_Overflow__int_max_square_08");
			(new CWE190_Integer_Overflow__int_max_square_09()).RunTest("CWE190_Integer_Overflow__int_max_square_09");
			(new CWE190_Integer_Overflow__int_max_square_10()).RunTest("CWE190_Integer_Overflow__int_max_square_10");
			(new CWE190_Integer_Overflow__int_max_square_11()).RunTest("CWE190_Integer_Overflow__int_max_square_11");
			(new CWE190_Integer_Overflow__int_max_square_12()).RunTest("CWE190_Integer_Overflow__int_max_square_12");
			(new CWE190_Integer_Overflow__int_max_square_13()).RunTest("CWE190_Integer_Overflow__int_max_square_13");
			(new CWE190_Integer_Overflow__int_max_square_14()).RunTest("CWE190_Integer_Overflow__int_max_square_14");
			(new CWE190_Integer_Overflow__int_max_square_15()).RunTest("CWE190_Integer_Overflow__int_max_square_15");
			(new CWE190_Integer_Overflow__int_max_square_16()).RunTest("CWE190_Integer_Overflow__int_max_square_16");
			(new CWE190_Integer_Overflow__int_max_square_17()).RunTest("CWE190_Integer_Overflow__int_max_square_17");
			(new CWE190_Integer_Overflow__int_max_square_21()).RunTest("CWE190_Integer_Overflow__int_max_square_21");
			(new CWE190_Integer_Overflow__int_max_square_22a()).RunTest("CWE190_Integer_Overflow__int_max_square_22a");
			(new CWE190_Integer_Overflow__int_max_square_31()).RunTest("CWE190_Integer_Overflow__int_max_square_31");
			(new CWE190_Integer_Overflow__int_max_square_41()).RunTest("CWE190_Integer_Overflow__int_max_square_41");
			(new CWE190_Integer_Overflow__int_max_square_42()).RunTest("CWE190_Integer_Overflow__int_max_square_42");
			(new CWE190_Integer_Overflow__int_max_square_45()).RunTest("CWE190_Integer_Overflow__int_max_square_45");
			(new CWE190_Integer_Overflow__int_max_square_51a()).RunTest("CWE190_Integer_Overflow__int_max_square_51a");
			(new CWE190_Integer_Overflow__int_max_square_52a()).RunTest("CWE190_Integer_Overflow__int_max_square_52a");
			(new CWE190_Integer_Overflow__int_max_square_53a()).RunTest("CWE190_Integer_Overflow__int_max_square_53a");
			(new CWE190_Integer_Overflow__int_max_square_54a()).RunTest("CWE190_Integer_Overflow__int_max_square_54a");
			(new CWE190_Integer_Overflow__int_max_square_61a()).RunTest("CWE190_Integer_Overflow__int_max_square_61a");
			(new CWE190_Integer_Overflow__int_max_square_66a()).RunTest("CWE190_Integer_Overflow__int_max_square_66a");
			(new CWE190_Integer_Overflow__int_max_square_67a()).RunTest("CWE190_Integer_Overflow__int_max_square_67a");
			(new CWE190_Integer_Overflow__int_max_square_68a()).RunTest("CWE190_Integer_Overflow__int_max_square_68a");
			(new CWE190_Integer_Overflow__int_max_square_71a()).RunTest("CWE190_Integer_Overflow__int_max_square_71a");
			(new CWE190_Integer_Overflow__int_max_square_72a()).RunTest("CWE190_Integer_Overflow__int_max_square_72a");
			(new CWE190_Integer_Overflow__int_max_square_73a()).RunTest("CWE190_Integer_Overflow__int_max_square_73a");
			(new CWE190_Integer_Overflow__int_max_square_74a()).RunTest("CWE190_Integer_Overflow__int_max_square_74a");
			(new CWE190_Integer_Overflow__int_max_square_75a()).RunTest("CWE190_Integer_Overflow__int_max_square_75a");
			(new CWE190_Integer_Overflow__int_max_square_81a()).RunTest("CWE190_Integer_Overflow__int_max_square_81a");
			(new CWE190_Integer_Overflow__int_NetClient_add_01()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_01");
			(new CWE190_Integer_Overflow__int_NetClient_add_02()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_02");
			(new CWE190_Integer_Overflow__int_NetClient_add_03()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_03");
			(new CWE190_Integer_Overflow__int_NetClient_add_04()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_04");
			(new CWE190_Integer_Overflow__int_NetClient_add_05()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_05");
			(new CWE190_Integer_Overflow__int_NetClient_add_06()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_06");
			(new CWE190_Integer_Overflow__int_NetClient_add_07()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_07");
			(new CWE190_Integer_Overflow__int_NetClient_add_08()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_08");
			(new CWE190_Integer_Overflow__int_NetClient_add_09()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_09");
			(new CWE190_Integer_Overflow__int_NetClient_add_10()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_10");
			(new CWE190_Integer_Overflow__int_NetClient_add_11()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_11");
			(new CWE190_Integer_Overflow__int_NetClient_add_12()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_12");
			(new CWE190_Integer_Overflow__int_NetClient_add_13()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_13");
			(new CWE190_Integer_Overflow__int_NetClient_add_14()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_14");
			(new CWE190_Integer_Overflow__int_NetClient_add_15()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_15");
			(new CWE190_Integer_Overflow__int_NetClient_add_16()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_16");
			(new CWE190_Integer_Overflow__int_NetClient_add_17()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_17");
			(new CWE190_Integer_Overflow__int_NetClient_add_21()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_21");
			(new CWE190_Integer_Overflow__int_NetClient_add_22a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_22a");
			(new CWE190_Integer_Overflow__int_NetClient_add_31()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_31");
			(new CWE190_Integer_Overflow__int_NetClient_add_41()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_41");
			(new CWE190_Integer_Overflow__int_NetClient_add_42()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_42");
			(new CWE190_Integer_Overflow__int_NetClient_add_45()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_45");
			(new CWE190_Integer_Overflow__int_NetClient_add_51a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_51a");
			(new CWE190_Integer_Overflow__int_NetClient_add_52a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_52a");
			(new CWE190_Integer_Overflow__int_NetClient_add_53a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_53a");
			(new CWE190_Integer_Overflow__int_NetClient_add_54a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_54a");
			(new CWE190_Integer_Overflow__int_NetClient_add_61a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_61a");
			(new CWE190_Integer_Overflow__int_NetClient_add_66a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_66a");
			(new CWE190_Integer_Overflow__int_NetClient_add_67a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_67a");
			(new CWE190_Integer_Overflow__int_NetClient_add_68a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_68a");
			(new CWE190_Integer_Overflow__int_NetClient_add_71a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_71a");
			(new CWE190_Integer_Overflow__int_NetClient_add_72a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_72a");
			(new CWE190_Integer_Overflow__int_NetClient_add_73a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_73a");
			(new CWE190_Integer_Overflow__int_NetClient_add_74a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_74a");
			(new CWE190_Integer_Overflow__int_NetClient_add_75a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_75a");
			(new CWE190_Integer_Overflow__int_NetClient_add_81a()).RunTest("CWE190_Integer_Overflow__int_NetClient_add_81a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_01()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_01");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_02()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_02");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_03()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_03");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_04()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_04");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_05()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_05");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_06()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_06");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_07()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_07");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_08()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_08");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_09()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_09");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_10()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_10");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_11()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_11");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_12()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_12");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_13()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_13");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_14()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_14");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_15()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_15");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_16()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_16");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_17()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_17");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_21()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_21");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_22a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_22a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_31()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_31");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_41()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_41");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_42()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_42");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_45()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_45");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_51a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_51a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_52a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_52a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_53a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_53a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_54a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_54a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_61a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_61a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_66a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_66a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_67a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_67a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_68a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_68a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_71a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_71a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_72a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_72a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_73a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_73a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_74a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_74a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_75a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_75a");
			(new CWE190_Integer_Overflow__int_NetClient_multiply_81a()).RunTest("CWE190_Integer_Overflow__int_NetClient_multiply_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}