using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE190_Integer_Overflow
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE190_Integer_Overflow__UInt64_rand_add_01()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_01");
			(new CWE190_Integer_Overflow__UInt64_rand_add_02()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_02");
			(new CWE190_Integer_Overflow__UInt64_rand_add_03()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_03");
			(new CWE190_Integer_Overflow__UInt64_rand_add_04()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_04");
			(new CWE190_Integer_Overflow__UInt64_rand_add_05()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_05");
			(new CWE190_Integer_Overflow__UInt64_rand_add_06()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_06");
			(new CWE190_Integer_Overflow__UInt64_rand_add_07()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_07");
			(new CWE190_Integer_Overflow__UInt64_rand_add_08()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_08");
			(new CWE190_Integer_Overflow__UInt64_rand_add_09()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_09");
			(new CWE190_Integer_Overflow__UInt64_rand_add_10()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_10");
			(new CWE190_Integer_Overflow__UInt64_rand_add_11()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_11");
			(new CWE190_Integer_Overflow__UInt64_rand_add_12()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_12");
			(new CWE190_Integer_Overflow__UInt64_rand_add_13()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_13");
			(new CWE190_Integer_Overflow__UInt64_rand_add_14()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_14");
			(new CWE190_Integer_Overflow__UInt64_rand_add_15()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_15");
			(new CWE190_Integer_Overflow__UInt64_rand_add_16()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_16");
			(new CWE190_Integer_Overflow__UInt64_rand_add_17()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_17");
			(new CWE190_Integer_Overflow__UInt64_rand_add_21()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_21");
			(new CWE190_Integer_Overflow__UInt64_rand_add_22a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_22a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_31()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_31");
			(new CWE190_Integer_Overflow__UInt64_rand_add_41()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_41");
			(new CWE190_Integer_Overflow__UInt64_rand_add_42()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_42");
			(new CWE190_Integer_Overflow__UInt64_rand_add_45()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_45");
			(new CWE190_Integer_Overflow__UInt64_rand_add_51a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_51a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_52a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_52a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_53a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_53a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_54a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_54a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_61a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_61a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_66a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_66a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_67a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_67a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_68a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_68a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_71a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_71a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_72a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_72a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_73a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_73a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_74a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_74a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_75a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_75a");
			(new CWE190_Integer_Overflow__UInt64_rand_add_81a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_add_81a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_01()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_01");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_02()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_02");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_03()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_03");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_04()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_04");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_05()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_05");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_06()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_06");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_07()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_07");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_08()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_08");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_09()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_09");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_10()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_10");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_11()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_11");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_12()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_12");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_13()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_13");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_14()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_14");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_15()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_15");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_16()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_16");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_17()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_17");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_21()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_21");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_22a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_22a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_31()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_31");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_41()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_41");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_42()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_42");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_45()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_45");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_51a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_51a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_52a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_52a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_53a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_53a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_54a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_54a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_61a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_61a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_66a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_66a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_67a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_67a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_68a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_68a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_71a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_71a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_72a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_72a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_73a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_73a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_74a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_74a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_75a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_75a");
			(new CWE190_Integer_Overflow__UInt64_rand_multiply_81a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_multiply_81a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_01()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_01");
			(new CWE190_Integer_Overflow__UInt64_rand_square_02()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_02");
			(new CWE190_Integer_Overflow__UInt64_rand_square_03()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_03");
			(new CWE190_Integer_Overflow__UInt64_rand_square_04()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_04");
			(new CWE190_Integer_Overflow__UInt64_rand_square_05()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_05");
			(new CWE190_Integer_Overflow__UInt64_rand_square_06()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_06");
			(new CWE190_Integer_Overflow__UInt64_rand_square_07()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_07");
			(new CWE190_Integer_Overflow__UInt64_rand_square_08()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_08");
			(new CWE190_Integer_Overflow__UInt64_rand_square_09()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_09");
			(new CWE190_Integer_Overflow__UInt64_rand_square_10()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_10");
			(new CWE190_Integer_Overflow__UInt64_rand_square_11()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_11");
			(new CWE190_Integer_Overflow__UInt64_rand_square_12()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_12");
			(new CWE190_Integer_Overflow__UInt64_rand_square_13()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_13");
			(new CWE190_Integer_Overflow__UInt64_rand_square_14()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_14");
			(new CWE190_Integer_Overflow__UInt64_rand_square_15()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_15");
			(new CWE190_Integer_Overflow__UInt64_rand_square_16()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_16");
			(new CWE190_Integer_Overflow__UInt64_rand_square_17()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_17");
			(new CWE190_Integer_Overflow__UInt64_rand_square_21()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_21");
			(new CWE190_Integer_Overflow__UInt64_rand_square_22a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_22a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_31()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_31");
			(new CWE190_Integer_Overflow__UInt64_rand_square_41()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_41");
			(new CWE190_Integer_Overflow__UInt64_rand_square_42()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_42");
			(new CWE190_Integer_Overflow__UInt64_rand_square_45()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_45");
			(new CWE190_Integer_Overflow__UInt64_rand_square_51a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_51a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_52a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_52a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_53a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_53a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_54a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_54a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_61a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_61a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_66a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_66a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_67a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_67a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_68a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_68a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_71a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_71a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_72a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_72a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_73a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_73a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_74a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_74a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_75a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_75a");
			(new CWE190_Integer_Overflow__UInt64_rand_square_81a()).RunTest("CWE190_Integer_Overflow__UInt64_rand_square_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}