using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE191_Integer_Underflow
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE191_Integer_Underflow__Long_min_multiply_01()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_01");
			(new CWE191_Integer_Underflow__Long_min_multiply_02()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_02");
			(new CWE191_Integer_Underflow__Long_min_multiply_03()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_03");
			(new CWE191_Integer_Underflow__Long_min_multiply_04()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_04");
			(new CWE191_Integer_Underflow__Long_min_multiply_05()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_05");
			(new CWE191_Integer_Underflow__Long_min_multiply_06()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_06");
			(new CWE191_Integer_Underflow__Long_min_multiply_07()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_07");
			(new CWE191_Integer_Underflow__Long_min_multiply_08()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_08");
			(new CWE191_Integer_Underflow__Long_min_multiply_09()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_09");
			(new CWE191_Integer_Underflow__Long_min_multiply_10()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_10");
			(new CWE191_Integer_Underflow__Long_min_multiply_11()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_11");
			(new CWE191_Integer_Underflow__Long_min_multiply_12()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_12");
			(new CWE191_Integer_Underflow__Long_min_multiply_13()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_13");
			(new CWE191_Integer_Underflow__Long_min_multiply_14()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_14");
			(new CWE191_Integer_Underflow__Long_min_multiply_15()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_15");
			(new CWE191_Integer_Underflow__Long_min_multiply_16()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_16");
			(new CWE191_Integer_Underflow__Long_min_multiply_17()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_17");
			(new CWE191_Integer_Underflow__Long_min_multiply_21()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_21");
			(new CWE191_Integer_Underflow__Long_min_multiply_22a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_22a");
			(new CWE191_Integer_Underflow__Long_min_multiply_31()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_31");
			(new CWE191_Integer_Underflow__Long_min_multiply_41()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_41");
			(new CWE191_Integer_Underflow__Long_min_multiply_42()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_42");
			(new CWE191_Integer_Underflow__Long_min_multiply_45()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_45");
			(new CWE191_Integer_Underflow__Long_min_multiply_51a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_51a");
			(new CWE191_Integer_Underflow__Long_min_multiply_52a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_52a");
			(new CWE191_Integer_Underflow__Long_min_multiply_53a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_53a");
			(new CWE191_Integer_Underflow__Long_min_multiply_54a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_54a");
			(new CWE191_Integer_Underflow__Long_min_multiply_61a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_61a");
			(new CWE191_Integer_Underflow__Long_min_multiply_66a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_66a");
			(new CWE191_Integer_Underflow__Long_min_multiply_67a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_67a");
			(new CWE191_Integer_Underflow__Long_min_multiply_68a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_68a");
			(new CWE191_Integer_Underflow__Long_min_multiply_71a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_71a");
			(new CWE191_Integer_Underflow__Long_min_multiply_72a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_72a");
			(new CWE191_Integer_Underflow__Long_min_multiply_73a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_73a");
			(new CWE191_Integer_Underflow__Long_min_multiply_74a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_74a");
			(new CWE191_Integer_Underflow__Long_min_multiply_75a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_75a");
			(new CWE191_Integer_Underflow__Long_min_multiply_81a()).RunTest("CWE191_Integer_Underflow__Long_min_multiply_81a");
			(new CWE191_Integer_Underflow__Long_min_sub_01()).RunTest("CWE191_Integer_Underflow__Long_min_sub_01");
			(new CWE191_Integer_Underflow__Long_min_sub_02()).RunTest("CWE191_Integer_Underflow__Long_min_sub_02");
			(new CWE191_Integer_Underflow__Long_min_sub_03()).RunTest("CWE191_Integer_Underflow__Long_min_sub_03");
			(new CWE191_Integer_Underflow__Long_min_sub_04()).RunTest("CWE191_Integer_Underflow__Long_min_sub_04");
			(new CWE191_Integer_Underflow__Long_min_sub_05()).RunTest("CWE191_Integer_Underflow__Long_min_sub_05");
			(new CWE191_Integer_Underflow__Long_min_sub_06()).RunTest("CWE191_Integer_Underflow__Long_min_sub_06");
			(new CWE191_Integer_Underflow__Long_min_sub_07()).RunTest("CWE191_Integer_Underflow__Long_min_sub_07");
			(new CWE191_Integer_Underflow__Long_min_sub_08()).RunTest("CWE191_Integer_Underflow__Long_min_sub_08");
			(new CWE191_Integer_Underflow__Long_min_sub_09()).RunTest("CWE191_Integer_Underflow__Long_min_sub_09");
			(new CWE191_Integer_Underflow__Long_min_sub_10()).RunTest("CWE191_Integer_Underflow__Long_min_sub_10");
			(new CWE191_Integer_Underflow__Long_min_sub_11()).RunTest("CWE191_Integer_Underflow__Long_min_sub_11");
			(new CWE191_Integer_Underflow__Long_min_sub_12()).RunTest("CWE191_Integer_Underflow__Long_min_sub_12");
			(new CWE191_Integer_Underflow__Long_min_sub_13()).RunTest("CWE191_Integer_Underflow__Long_min_sub_13");
			(new CWE191_Integer_Underflow__Long_min_sub_14()).RunTest("CWE191_Integer_Underflow__Long_min_sub_14");
			(new CWE191_Integer_Underflow__Long_min_sub_15()).RunTest("CWE191_Integer_Underflow__Long_min_sub_15");
			(new CWE191_Integer_Underflow__Long_min_sub_16()).RunTest("CWE191_Integer_Underflow__Long_min_sub_16");
			(new CWE191_Integer_Underflow__Long_min_sub_17()).RunTest("CWE191_Integer_Underflow__Long_min_sub_17");
			(new CWE191_Integer_Underflow__Long_min_sub_21()).RunTest("CWE191_Integer_Underflow__Long_min_sub_21");
			(new CWE191_Integer_Underflow__Long_min_sub_22a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_22a");
			(new CWE191_Integer_Underflow__Long_min_sub_31()).RunTest("CWE191_Integer_Underflow__Long_min_sub_31");
			(new CWE191_Integer_Underflow__Long_min_sub_41()).RunTest("CWE191_Integer_Underflow__Long_min_sub_41");
			(new CWE191_Integer_Underflow__Long_min_sub_42()).RunTest("CWE191_Integer_Underflow__Long_min_sub_42");
			(new CWE191_Integer_Underflow__Long_min_sub_45()).RunTest("CWE191_Integer_Underflow__Long_min_sub_45");
			(new CWE191_Integer_Underflow__Long_min_sub_51a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_51a");
			(new CWE191_Integer_Underflow__Long_min_sub_52a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_52a");
			(new CWE191_Integer_Underflow__Long_min_sub_53a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_53a");
			(new CWE191_Integer_Underflow__Long_min_sub_54a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_54a");
			(new CWE191_Integer_Underflow__Long_min_sub_61a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_61a");
			(new CWE191_Integer_Underflow__Long_min_sub_66a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_66a");
			(new CWE191_Integer_Underflow__Long_min_sub_67a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_67a");
			(new CWE191_Integer_Underflow__Long_min_sub_68a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_68a");
			(new CWE191_Integer_Underflow__Long_min_sub_71a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_71a");
			(new CWE191_Integer_Underflow__Long_min_sub_72a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_72a");
			(new CWE191_Integer_Underflow__Long_min_sub_73a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_73a");
			(new CWE191_Integer_Underflow__Long_min_sub_74a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_74a");
			(new CWE191_Integer_Underflow__Long_min_sub_75a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_75a");
			(new CWE191_Integer_Underflow__Long_min_sub_81a()).RunTest("CWE191_Integer_Underflow__Long_min_sub_81a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_01()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_01");
			(new CWE191_Integer_Underflow__Long_rand_multiply_02()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_02");
			(new CWE191_Integer_Underflow__Long_rand_multiply_03()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_03");
			(new CWE191_Integer_Underflow__Long_rand_multiply_04()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_04");
			(new CWE191_Integer_Underflow__Long_rand_multiply_05()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_05");
			(new CWE191_Integer_Underflow__Long_rand_multiply_06()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_06");
			(new CWE191_Integer_Underflow__Long_rand_multiply_07()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_07");
			(new CWE191_Integer_Underflow__Long_rand_multiply_08()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_08");
			(new CWE191_Integer_Underflow__Long_rand_multiply_09()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_09");
			(new CWE191_Integer_Underflow__Long_rand_multiply_10()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_10");
			(new CWE191_Integer_Underflow__Long_rand_multiply_11()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_11");
			(new CWE191_Integer_Underflow__Long_rand_multiply_12()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_12");
			(new CWE191_Integer_Underflow__Long_rand_multiply_13()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_13");
			(new CWE191_Integer_Underflow__Long_rand_multiply_14()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_14");
			(new CWE191_Integer_Underflow__Long_rand_multiply_15()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_15");
			(new CWE191_Integer_Underflow__Long_rand_multiply_16()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_16");
			(new CWE191_Integer_Underflow__Long_rand_multiply_17()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_17");
			(new CWE191_Integer_Underflow__Long_rand_multiply_21()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_21");
			(new CWE191_Integer_Underflow__Long_rand_multiply_22a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_22a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_31()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_31");
			(new CWE191_Integer_Underflow__Long_rand_multiply_41()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_41");
			(new CWE191_Integer_Underflow__Long_rand_multiply_42()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_42");
			(new CWE191_Integer_Underflow__Long_rand_multiply_45()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_45");
			(new CWE191_Integer_Underflow__Long_rand_multiply_51a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_51a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_52a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_52a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_53a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_53a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_54a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_54a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_61a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_61a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_66a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_66a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_67a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_67a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_68a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_68a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_71a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_71a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_72a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_72a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_73a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_73a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_74a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_74a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_75a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_75a");
			(new CWE191_Integer_Underflow__Long_rand_multiply_81a()).RunTest("CWE191_Integer_Underflow__Long_rand_multiply_81a");
			(new CWE191_Integer_Underflow__Long_rand_sub_01()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_01");
			(new CWE191_Integer_Underflow__Long_rand_sub_02()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_02");
			(new CWE191_Integer_Underflow__Long_rand_sub_03()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_03");
			(new CWE191_Integer_Underflow__Long_rand_sub_04()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_04");
			(new CWE191_Integer_Underflow__Long_rand_sub_05()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_05");
			(new CWE191_Integer_Underflow__Long_rand_sub_06()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_06");
			(new CWE191_Integer_Underflow__Long_rand_sub_07()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_07");
			(new CWE191_Integer_Underflow__Long_rand_sub_08()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_08");
			(new CWE191_Integer_Underflow__Long_rand_sub_09()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_09");
			(new CWE191_Integer_Underflow__Long_rand_sub_10()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_10");
			(new CWE191_Integer_Underflow__Long_rand_sub_11()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_11");
			(new CWE191_Integer_Underflow__Long_rand_sub_12()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_12");
			(new CWE191_Integer_Underflow__Long_rand_sub_13()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_13");
			(new CWE191_Integer_Underflow__Long_rand_sub_14()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_14");
			(new CWE191_Integer_Underflow__Long_rand_sub_15()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_15");
			(new CWE191_Integer_Underflow__Long_rand_sub_16()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_16");
			(new CWE191_Integer_Underflow__Long_rand_sub_17()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_17");
			(new CWE191_Integer_Underflow__Long_rand_sub_21()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_21");
			(new CWE191_Integer_Underflow__Long_rand_sub_22a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_22a");
			(new CWE191_Integer_Underflow__Long_rand_sub_31()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_31");
			(new CWE191_Integer_Underflow__Long_rand_sub_41()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_41");
			(new CWE191_Integer_Underflow__Long_rand_sub_42()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_42");
			(new CWE191_Integer_Underflow__Long_rand_sub_45()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_45");
			(new CWE191_Integer_Underflow__Long_rand_sub_51a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_51a");
			(new CWE191_Integer_Underflow__Long_rand_sub_52a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_52a");
			(new CWE191_Integer_Underflow__Long_rand_sub_53a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_53a");
			(new CWE191_Integer_Underflow__Long_rand_sub_54a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_54a");
			(new CWE191_Integer_Underflow__Long_rand_sub_61a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_61a");
			(new CWE191_Integer_Underflow__Long_rand_sub_66a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_66a");
			(new CWE191_Integer_Underflow__Long_rand_sub_67a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_67a");
			(new CWE191_Integer_Underflow__Long_rand_sub_68a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_68a");
			(new CWE191_Integer_Underflow__Long_rand_sub_71a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_71a");
			(new CWE191_Integer_Underflow__Long_rand_sub_72a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_72a");
			(new CWE191_Integer_Underflow__Long_rand_sub_73a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_73a");
			(new CWE191_Integer_Underflow__Long_rand_sub_74a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_74a");
			(new CWE191_Integer_Underflow__Long_rand_sub_75a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_75a");
			(new CWE191_Integer_Underflow__Long_rand_sub_81a()).RunTest("CWE191_Integer_Underflow__Long_rand_sub_81a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_01()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_01");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_02()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_02");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_03()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_03");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_04()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_04");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_05()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_05");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_06()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_06");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_07()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_07");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_08()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_08");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_09()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_09");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_10()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_10");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_11()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_11");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_12()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_12");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_13()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_13");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_14()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_14");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_15()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_15");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_16()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_16");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_17()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_17");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_21()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_21");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_22a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_22a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_31()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_31");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_41()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_41");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_42()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_42");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_45()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_45");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_51a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_51a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_52a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_52a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_53a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_53a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_54a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_54a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_61a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_61a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_66a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_66a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_67a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_67a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_68a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_68a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_71a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_71a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_72a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_72a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_73a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_73a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_74a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_74a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_75a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_75a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_81a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_multiply_81a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_01()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_01");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_02()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_02");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_03()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_03");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_04()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_04");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_05()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_05");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_06()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_06");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_07()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_07");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_08()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_08");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_09()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_09");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_10()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_10");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_11()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_11");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_12()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_12");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_13()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_13");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_14()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_14");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_15()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_15");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_16()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_16");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_17()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_17");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_21()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_21");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_22a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_22a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_31()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_31");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_41()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_41");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_42()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_42");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_45()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_45");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_51a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_51a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_52a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_52a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_53a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_53a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_54a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_54a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_61a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_61a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_66a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_66a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_67a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_67a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_68a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_68a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_71a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_71a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_72a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_72a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_73a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_73a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_74a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_74a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_75a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_75a");
			(new CWE191_Integer_Underflow__SByte_console_ReadLine_sub_81a()).RunTest("CWE191_Integer_Underflow__SByte_console_ReadLine_sub_81a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_01()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_01");
			(new CWE191_Integer_Underflow__SByte_min_multiply_02()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_02");
			(new CWE191_Integer_Underflow__SByte_min_multiply_03()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_03");
			(new CWE191_Integer_Underflow__SByte_min_multiply_04()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_04");
			(new CWE191_Integer_Underflow__SByte_min_multiply_05()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_05");
			(new CWE191_Integer_Underflow__SByte_min_multiply_06()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_06");
			(new CWE191_Integer_Underflow__SByte_min_multiply_07()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_07");
			(new CWE191_Integer_Underflow__SByte_min_multiply_08()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_08");
			(new CWE191_Integer_Underflow__SByte_min_multiply_09()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_09");
			(new CWE191_Integer_Underflow__SByte_min_multiply_10()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_10");
			(new CWE191_Integer_Underflow__SByte_min_multiply_11()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_11");
			(new CWE191_Integer_Underflow__SByte_min_multiply_12()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_12");
			(new CWE191_Integer_Underflow__SByte_min_multiply_13()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_13");
			(new CWE191_Integer_Underflow__SByte_min_multiply_14()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_14");
			(new CWE191_Integer_Underflow__SByte_min_multiply_15()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_15");
			(new CWE191_Integer_Underflow__SByte_min_multiply_16()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_16");
			(new CWE191_Integer_Underflow__SByte_min_multiply_17()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_17");
			(new CWE191_Integer_Underflow__SByte_min_multiply_21()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_21");
			(new CWE191_Integer_Underflow__SByte_min_multiply_22a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_22a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_31()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_31");
			(new CWE191_Integer_Underflow__SByte_min_multiply_41()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_41");
			(new CWE191_Integer_Underflow__SByte_min_multiply_42()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_42");
			(new CWE191_Integer_Underflow__SByte_min_multiply_45()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_45");
			(new CWE191_Integer_Underflow__SByte_min_multiply_51a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_51a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_52a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_52a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_53a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_53a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_54a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_54a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_61a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_61a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_66a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_66a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_67a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_67a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_68a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_68a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_71a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_71a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_72a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_72a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_73a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_73a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_74a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_74a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_75a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_75a");
			(new CWE191_Integer_Underflow__SByte_min_multiply_81a()).RunTest("CWE191_Integer_Underflow__SByte_min_multiply_81a");
			(new CWE191_Integer_Underflow__SByte_min_sub_01()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_01");
			(new CWE191_Integer_Underflow__SByte_min_sub_02()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_02");
			(new CWE191_Integer_Underflow__SByte_min_sub_03()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_03");
			(new CWE191_Integer_Underflow__SByte_min_sub_04()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_04");
			(new CWE191_Integer_Underflow__SByte_min_sub_05()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_05");
			(new CWE191_Integer_Underflow__SByte_min_sub_06()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_06");
			(new CWE191_Integer_Underflow__SByte_min_sub_07()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_07");
			(new CWE191_Integer_Underflow__SByte_min_sub_08()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_08");
			(new CWE191_Integer_Underflow__SByte_min_sub_09()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_09");
			(new CWE191_Integer_Underflow__SByte_min_sub_10()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_10");
			(new CWE191_Integer_Underflow__SByte_min_sub_11()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_11");
			(new CWE191_Integer_Underflow__SByte_min_sub_12()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_12");
			(new CWE191_Integer_Underflow__SByte_min_sub_13()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_13");
			(new CWE191_Integer_Underflow__SByte_min_sub_14()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_14");
			(new CWE191_Integer_Underflow__SByte_min_sub_15()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_15");
			(new CWE191_Integer_Underflow__SByte_min_sub_16()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_16");
			(new CWE191_Integer_Underflow__SByte_min_sub_17()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_17");
			(new CWE191_Integer_Underflow__SByte_min_sub_21()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_21");
			(new CWE191_Integer_Underflow__SByte_min_sub_22a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_22a");
			(new CWE191_Integer_Underflow__SByte_min_sub_31()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_31");
			(new CWE191_Integer_Underflow__SByte_min_sub_41()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_41");
			(new CWE191_Integer_Underflow__SByte_min_sub_42()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_42");
			(new CWE191_Integer_Underflow__SByte_min_sub_45()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_45");
			(new CWE191_Integer_Underflow__SByte_min_sub_51a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_51a");
			(new CWE191_Integer_Underflow__SByte_min_sub_52a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_52a");
			(new CWE191_Integer_Underflow__SByte_min_sub_53a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_53a");
			(new CWE191_Integer_Underflow__SByte_min_sub_54a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_54a");
			(new CWE191_Integer_Underflow__SByte_min_sub_61a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_61a");
			(new CWE191_Integer_Underflow__SByte_min_sub_66a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_66a");
			(new CWE191_Integer_Underflow__SByte_min_sub_67a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_67a");
			(new CWE191_Integer_Underflow__SByte_min_sub_68a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_68a");
			(new CWE191_Integer_Underflow__SByte_min_sub_71a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_71a");
			(new CWE191_Integer_Underflow__SByte_min_sub_72a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_72a");
			(new CWE191_Integer_Underflow__SByte_min_sub_73a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_73a");
			(new CWE191_Integer_Underflow__SByte_min_sub_74a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_74a");
			(new CWE191_Integer_Underflow__SByte_min_sub_75a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_75a");
			(new CWE191_Integer_Underflow__SByte_min_sub_81a()).RunTest("CWE191_Integer_Underflow__SByte_min_sub_81a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_01()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_01");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_02()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_02");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_03()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_03");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_04()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_04");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_05()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_05");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_06()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_06");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_07()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_07");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_08()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_08");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_09()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_09");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_10()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_10");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_11()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_11");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_12()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_12");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_13()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_13");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_14()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_14");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_15()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_15");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_16()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_16");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_17()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_17");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_21()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_21");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_22a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_22a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_31()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_31");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_41()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_41");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_42()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_42");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_45()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_45");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_51a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_51a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_52a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_52a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_53a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_53a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_54a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_54a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_61a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_61a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_66a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_66a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_67a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_67a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_68a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_68a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_71a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_71a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_72a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_72a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_73a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_73a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_74a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_74a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_75a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_75a");
			(new CWE191_Integer_Underflow__SByte_rand_multiply_81a()).RunTest("CWE191_Integer_Underflow__SByte_rand_multiply_81a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_01()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_01");
			(new CWE191_Integer_Underflow__SByte_rand_sub_02()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_02");
			(new CWE191_Integer_Underflow__SByte_rand_sub_03()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_03");
			(new CWE191_Integer_Underflow__SByte_rand_sub_04()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_04");
			(new CWE191_Integer_Underflow__SByte_rand_sub_05()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_05");
			(new CWE191_Integer_Underflow__SByte_rand_sub_06()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_06");
			(new CWE191_Integer_Underflow__SByte_rand_sub_07()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_07");
			(new CWE191_Integer_Underflow__SByte_rand_sub_08()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_08");
			(new CWE191_Integer_Underflow__SByte_rand_sub_09()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_09");
			(new CWE191_Integer_Underflow__SByte_rand_sub_10()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_10");
			(new CWE191_Integer_Underflow__SByte_rand_sub_11()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_11");
			(new CWE191_Integer_Underflow__SByte_rand_sub_12()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_12");
			(new CWE191_Integer_Underflow__SByte_rand_sub_13()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_13");
			(new CWE191_Integer_Underflow__SByte_rand_sub_14()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_14");
			(new CWE191_Integer_Underflow__SByte_rand_sub_15()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_15");
			(new CWE191_Integer_Underflow__SByte_rand_sub_16()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_16");
			(new CWE191_Integer_Underflow__SByte_rand_sub_17()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_17");
			(new CWE191_Integer_Underflow__SByte_rand_sub_21()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_21");
			(new CWE191_Integer_Underflow__SByte_rand_sub_22a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_22a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_31()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_31");
			(new CWE191_Integer_Underflow__SByte_rand_sub_41()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_41");
			(new CWE191_Integer_Underflow__SByte_rand_sub_42()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_42");
			(new CWE191_Integer_Underflow__SByte_rand_sub_45()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_45");
			(new CWE191_Integer_Underflow__SByte_rand_sub_51a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_51a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_52a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_52a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_53a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_53a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_54a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_54a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_61a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_61a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_66a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_66a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_67a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_67a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_68a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_68a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_71a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_71a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_72a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_72a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_73a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_73a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_74a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_74a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_75a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_75a");
			(new CWE191_Integer_Underflow__SByte_rand_sub_81a()).RunTest("CWE191_Integer_Underflow__SByte_rand_sub_81a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_01()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_01");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_02()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_02");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_03()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_03");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_04()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_04");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_05()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_05");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_06()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_06");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_07()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_07");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_08()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_08");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_09()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_09");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_10()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_10");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_11()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_11");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_12()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_12");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_13()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_13");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_14()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_14");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_15()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_15");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_16()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_16");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_17()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_17");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_21()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_21");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_22a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_22a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_31()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_31");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_41()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_41");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_42()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_42");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_45()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_45");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_51a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_51a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_52a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_52a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_53a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_53a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_54a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_54a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_61a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_61a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_66a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_66a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_67a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_67a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_68a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_68a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_71a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_71a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_72a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_72a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_73a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_73a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_74a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_74a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_75a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_75a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_multiply_81a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_multiply_81a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_01()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_01");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_02()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_02");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_03()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_03");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_04()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_04");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_05()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_05");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_06()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_06");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_07()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_07");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_08()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_08");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_09()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_09");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_10()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_10");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_11()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_11");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_12()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_12");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_13()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_13");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_14()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_14");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_15()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_15");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_16()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_16");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_17()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_17");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_21()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_21");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_22a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_22a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_31()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_31");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_41()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_41");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_42()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_42");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_45()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_45");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_51a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_51a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_52a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_52a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_53a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_53a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_54a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_54a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_61a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_61a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_66a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_66a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_67a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_67a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_68a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_68a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_71a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_71a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_72a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_72a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_73a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_73a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_74a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_74a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_75a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_75a");
			(new CWE191_Integer_Underflow__Short_console_ReadLine_sub_81a()).RunTest("CWE191_Integer_Underflow__Short_console_ReadLine_sub_81a");
			(new CWE191_Integer_Underflow__Short_min_multiply_01()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_01");
			(new CWE191_Integer_Underflow__Short_min_multiply_02()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_02");
			(new CWE191_Integer_Underflow__Short_min_multiply_03()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_03");
			(new CWE191_Integer_Underflow__Short_min_multiply_04()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_04");
			(new CWE191_Integer_Underflow__Short_min_multiply_05()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_05");
			(new CWE191_Integer_Underflow__Short_min_multiply_06()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_06");
			(new CWE191_Integer_Underflow__Short_min_multiply_07()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_07");
			(new CWE191_Integer_Underflow__Short_min_multiply_08()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_08");
			(new CWE191_Integer_Underflow__Short_min_multiply_09()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_09");
			(new CWE191_Integer_Underflow__Short_min_multiply_10()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_10");
			(new CWE191_Integer_Underflow__Short_min_multiply_11()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_11");
			(new CWE191_Integer_Underflow__Short_min_multiply_12()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_12");
			(new CWE191_Integer_Underflow__Short_min_multiply_13()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_13");
			(new CWE191_Integer_Underflow__Short_min_multiply_14()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_14");
			(new CWE191_Integer_Underflow__Short_min_multiply_15()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_15");
			(new CWE191_Integer_Underflow__Short_min_multiply_16()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_16");
			(new CWE191_Integer_Underflow__Short_min_multiply_17()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_17");
			(new CWE191_Integer_Underflow__Short_min_multiply_21()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_21");
			(new CWE191_Integer_Underflow__Short_min_multiply_22a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_22a");
			(new CWE191_Integer_Underflow__Short_min_multiply_31()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_31");
			(new CWE191_Integer_Underflow__Short_min_multiply_41()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_41");
			(new CWE191_Integer_Underflow__Short_min_multiply_42()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_42");
			(new CWE191_Integer_Underflow__Short_min_multiply_45()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_45");
			(new CWE191_Integer_Underflow__Short_min_multiply_51a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_51a");
			(new CWE191_Integer_Underflow__Short_min_multiply_52a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_52a");
			(new CWE191_Integer_Underflow__Short_min_multiply_53a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_53a");
			(new CWE191_Integer_Underflow__Short_min_multiply_54a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_54a");
			(new CWE191_Integer_Underflow__Short_min_multiply_61a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_61a");
			(new CWE191_Integer_Underflow__Short_min_multiply_66a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_66a");
			(new CWE191_Integer_Underflow__Short_min_multiply_67a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_67a");
			(new CWE191_Integer_Underflow__Short_min_multiply_68a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_68a");
			(new CWE191_Integer_Underflow__Short_min_multiply_71a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_71a");
			(new CWE191_Integer_Underflow__Short_min_multiply_72a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_72a");
			(new CWE191_Integer_Underflow__Short_min_multiply_73a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_73a");
			(new CWE191_Integer_Underflow__Short_min_multiply_74a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_74a");
			(new CWE191_Integer_Underflow__Short_min_multiply_75a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_75a");
			(new CWE191_Integer_Underflow__Short_min_multiply_81a()).RunTest("CWE191_Integer_Underflow__Short_min_multiply_81a");
			(new CWE191_Integer_Underflow__Short_min_sub_01()).RunTest("CWE191_Integer_Underflow__Short_min_sub_01");
			(new CWE191_Integer_Underflow__Short_min_sub_02()).RunTest("CWE191_Integer_Underflow__Short_min_sub_02");
			(new CWE191_Integer_Underflow__Short_min_sub_03()).RunTest("CWE191_Integer_Underflow__Short_min_sub_03");
			(new CWE191_Integer_Underflow__Short_min_sub_04()).RunTest("CWE191_Integer_Underflow__Short_min_sub_04");
			(new CWE191_Integer_Underflow__Short_min_sub_05()).RunTest("CWE191_Integer_Underflow__Short_min_sub_05");
			(new CWE191_Integer_Underflow__Short_min_sub_06()).RunTest("CWE191_Integer_Underflow__Short_min_sub_06");
			(new CWE191_Integer_Underflow__Short_min_sub_07()).RunTest("CWE191_Integer_Underflow__Short_min_sub_07");
			(new CWE191_Integer_Underflow__Short_min_sub_08()).RunTest("CWE191_Integer_Underflow__Short_min_sub_08");
			(new CWE191_Integer_Underflow__Short_min_sub_09()).RunTest("CWE191_Integer_Underflow__Short_min_sub_09");
			(new CWE191_Integer_Underflow__Short_min_sub_10()).RunTest("CWE191_Integer_Underflow__Short_min_sub_10");
			(new CWE191_Integer_Underflow__Short_min_sub_11()).RunTest("CWE191_Integer_Underflow__Short_min_sub_11");
			(new CWE191_Integer_Underflow__Short_min_sub_12()).RunTest("CWE191_Integer_Underflow__Short_min_sub_12");
			(new CWE191_Integer_Underflow__Short_min_sub_13()).RunTest("CWE191_Integer_Underflow__Short_min_sub_13");
			(new CWE191_Integer_Underflow__Short_min_sub_14()).RunTest("CWE191_Integer_Underflow__Short_min_sub_14");
			(new CWE191_Integer_Underflow__Short_min_sub_15()).RunTest("CWE191_Integer_Underflow__Short_min_sub_15");
			(new CWE191_Integer_Underflow__Short_min_sub_16()).RunTest("CWE191_Integer_Underflow__Short_min_sub_16");
			(new CWE191_Integer_Underflow__Short_min_sub_17()).RunTest("CWE191_Integer_Underflow__Short_min_sub_17");
			(new CWE191_Integer_Underflow__Short_min_sub_21()).RunTest("CWE191_Integer_Underflow__Short_min_sub_21");
			(new CWE191_Integer_Underflow__Short_min_sub_22a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_22a");
			(new CWE191_Integer_Underflow__Short_min_sub_31()).RunTest("CWE191_Integer_Underflow__Short_min_sub_31");
			(new CWE191_Integer_Underflow__Short_min_sub_41()).RunTest("CWE191_Integer_Underflow__Short_min_sub_41");
			(new CWE191_Integer_Underflow__Short_min_sub_42()).RunTest("CWE191_Integer_Underflow__Short_min_sub_42");
			(new CWE191_Integer_Underflow__Short_min_sub_45()).RunTest("CWE191_Integer_Underflow__Short_min_sub_45");
			(new CWE191_Integer_Underflow__Short_min_sub_51a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_51a");
			(new CWE191_Integer_Underflow__Short_min_sub_52a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_52a");
			(new CWE191_Integer_Underflow__Short_min_sub_53a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_53a");
			(new CWE191_Integer_Underflow__Short_min_sub_54a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_54a");
			(new CWE191_Integer_Underflow__Short_min_sub_61a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_61a");
			(new CWE191_Integer_Underflow__Short_min_sub_66a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_66a");
			(new CWE191_Integer_Underflow__Short_min_sub_67a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_67a");
			(new CWE191_Integer_Underflow__Short_min_sub_68a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_68a");
			(new CWE191_Integer_Underflow__Short_min_sub_71a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_71a");
			(new CWE191_Integer_Underflow__Short_min_sub_72a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_72a");
			(new CWE191_Integer_Underflow__Short_min_sub_73a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_73a");
			(new CWE191_Integer_Underflow__Short_min_sub_74a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_74a");
			(new CWE191_Integer_Underflow__Short_min_sub_75a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_75a");
			(new CWE191_Integer_Underflow__Short_min_sub_81a()).RunTest("CWE191_Integer_Underflow__Short_min_sub_81a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_01()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_01");
			(new CWE191_Integer_Underflow__Short_rand_multiply_02()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_02");
			(new CWE191_Integer_Underflow__Short_rand_multiply_03()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_03");
			(new CWE191_Integer_Underflow__Short_rand_multiply_04()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_04");
			(new CWE191_Integer_Underflow__Short_rand_multiply_05()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_05");
			(new CWE191_Integer_Underflow__Short_rand_multiply_06()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_06");
			(new CWE191_Integer_Underflow__Short_rand_multiply_07()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_07");
			(new CWE191_Integer_Underflow__Short_rand_multiply_08()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_08");
			(new CWE191_Integer_Underflow__Short_rand_multiply_09()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_09");
			(new CWE191_Integer_Underflow__Short_rand_multiply_10()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_10");
			(new CWE191_Integer_Underflow__Short_rand_multiply_11()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_11");
			(new CWE191_Integer_Underflow__Short_rand_multiply_12()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_12");
			(new CWE191_Integer_Underflow__Short_rand_multiply_13()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_13");
			(new CWE191_Integer_Underflow__Short_rand_multiply_14()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_14");
			(new CWE191_Integer_Underflow__Short_rand_multiply_15()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_15");
			(new CWE191_Integer_Underflow__Short_rand_multiply_16()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_16");
			(new CWE191_Integer_Underflow__Short_rand_multiply_17()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_17");
			(new CWE191_Integer_Underflow__Short_rand_multiply_21()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_21");
			(new CWE191_Integer_Underflow__Short_rand_multiply_22a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_22a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_31()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_31");
			(new CWE191_Integer_Underflow__Short_rand_multiply_41()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_41");
			(new CWE191_Integer_Underflow__Short_rand_multiply_42()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_42");
			(new CWE191_Integer_Underflow__Short_rand_multiply_45()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_45");
			(new CWE191_Integer_Underflow__Short_rand_multiply_51a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_51a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_52a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_52a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_53a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_53a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_54a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_54a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_61a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_61a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_66a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_66a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_67a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_67a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_68a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_68a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_71a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_71a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_72a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_72a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_73a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_73a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_74a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_74a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_75a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_75a");
			(new CWE191_Integer_Underflow__Short_rand_multiply_81a()).RunTest("CWE191_Integer_Underflow__Short_rand_multiply_81a");
			(new CWE191_Integer_Underflow__Short_rand_sub_01()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_01");
			(new CWE191_Integer_Underflow__Short_rand_sub_02()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_02");
			(new CWE191_Integer_Underflow__Short_rand_sub_03()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_03");
			(new CWE191_Integer_Underflow__Short_rand_sub_04()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_04");
			(new CWE191_Integer_Underflow__Short_rand_sub_05()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_05");
			(new CWE191_Integer_Underflow__Short_rand_sub_06()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_06");
			(new CWE191_Integer_Underflow__Short_rand_sub_07()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_07");
			(new CWE191_Integer_Underflow__Short_rand_sub_08()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_08");
			(new CWE191_Integer_Underflow__Short_rand_sub_09()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_09");
			(new CWE191_Integer_Underflow__Short_rand_sub_10()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_10");
			(new CWE191_Integer_Underflow__Short_rand_sub_11()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_11");
			(new CWE191_Integer_Underflow__Short_rand_sub_12()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_12");
			(new CWE191_Integer_Underflow__Short_rand_sub_13()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_13");
			(new CWE191_Integer_Underflow__Short_rand_sub_14()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_14");
			(new CWE191_Integer_Underflow__Short_rand_sub_15()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_15");
			(new CWE191_Integer_Underflow__Short_rand_sub_16()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_16");
			(new CWE191_Integer_Underflow__Short_rand_sub_17()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_17");
			(new CWE191_Integer_Underflow__Short_rand_sub_21()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_21");
			(new CWE191_Integer_Underflow__Short_rand_sub_22a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_22a");
			(new CWE191_Integer_Underflow__Short_rand_sub_31()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_31");
			(new CWE191_Integer_Underflow__Short_rand_sub_41()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_41");
			(new CWE191_Integer_Underflow__Short_rand_sub_42()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_42");
			(new CWE191_Integer_Underflow__Short_rand_sub_45()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_45");
			(new CWE191_Integer_Underflow__Short_rand_sub_51a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_51a");
			(new CWE191_Integer_Underflow__Short_rand_sub_52a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_52a");
			(new CWE191_Integer_Underflow__Short_rand_sub_53a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_53a");
			(new CWE191_Integer_Underflow__Short_rand_sub_54a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_54a");
			(new CWE191_Integer_Underflow__Short_rand_sub_61a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_61a");
			(new CWE191_Integer_Underflow__Short_rand_sub_66a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_66a");
			(new CWE191_Integer_Underflow__Short_rand_sub_67a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_67a");
			(new CWE191_Integer_Underflow__Short_rand_sub_68a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_68a");
			(new CWE191_Integer_Underflow__Short_rand_sub_71a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_71a");
			(new CWE191_Integer_Underflow__Short_rand_sub_72a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_72a");
			(new CWE191_Integer_Underflow__Short_rand_sub_73a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_73a");
			(new CWE191_Integer_Underflow__Short_rand_sub_74a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_74a");
			(new CWE191_Integer_Underflow__Short_rand_sub_75a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_75a");
			(new CWE191_Integer_Underflow__Short_rand_sub_81a()).RunTest("CWE191_Integer_Underflow__Short_rand_sub_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}