using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE193_Off_by_One_Error
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE193_Off_by_One_Error__do_01()).RunTest("CWE193_Off_by_One_Error__do_01");
			(new CWE193_Off_by_One_Error__do_02()).RunTest("CWE193_Off_by_One_Error__do_02");
			(new CWE193_Off_by_One_Error__do_03()).RunTest("CWE193_Off_by_One_Error__do_03");
			(new CWE193_Off_by_One_Error__do_04()).RunTest("CWE193_Off_by_One_Error__do_04");
			(new CWE193_Off_by_One_Error__do_05()).RunTest("CWE193_Off_by_One_Error__do_05");
			(new CWE193_Off_by_One_Error__do_06()).RunTest("CWE193_Off_by_One_Error__do_06");
			(new CWE193_Off_by_One_Error__do_07()).RunTest("CWE193_Off_by_One_Error__do_07");
			(new CWE193_Off_by_One_Error__do_08()).RunTest("CWE193_Off_by_One_Error__do_08");
			(new CWE193_Off_by_One_Error__do_09()).RunTest("CWE193_Off_by_One_Error__do_09");
			(new CWE193_Off_by_One_Error__do_10()).RunTest("CWE193_Off_by_One_Error__do_10");
			(new CWE193_Off_by_One_Error__do_11()).RunTest("CWE193_Off_by_One_Error__do_11");
			(new CWE193_Off_by_One_Error__do_12()).RunTest("CWE193_Off_by_One_Error__do_12");
			(new CWE193_Off_by_One_Error__do_13()).RunTest("CWE193_Off_by_One_Error__do_13");
			(new CWE193_Off_by_One_Error__do_14()).RunTest("CWE193_Off_by_One_Error__do_14");
			(new CWE193_Off_by_One_Error__do_15()).RunTest("CWE193_Off_by_One_Error__do_15");
			(new CWE193_Off_by_One_Error__do_16()).RunTest("CWE193_Off_by_One_Error__do_16");
			(new CWE193_Off_by_One_Error__do_17()).RunTest("CWE193_Off_by_One_Error__do_17");
			(new CWE193_Off_by_One_Error__for_01()).RunTest("CWE193_Off_by_One_Error__for_01");
			(new CWE193_Off_by_One_Error__for_02()).RunTest("CWE193_Off_by_One_Error__for_02");
			(new CWE193_Off_by_One_Error__for_03()).RunTest("CWE193_Off_by_One_Error__for_03");
			(new CWE193_Off_by_One_Error__for_04()).RunTest("CWE193_Off_by_One_Error__for_04");
			(new CWE193_Off_by_One_Error__for_05()).RunTest("CWE193_Off_by_One_Error__for_05");
			(new CWE193_Off_by_One_Error__for_06()).RunTest("CWE193_Off_by_One_Error__for_06");
			(new CWE193_Off_by_One_Error__for_07()).RunTest("CWE193_Off_by_One_Error__for_07");
			(new CWE193_Off_by_One_Error__for_08()).RunTest("CWE193_Off_by_One_Error__for_08");
			(new CWE193_Off_by_One_Error__for_09()).RunTest("CWE193_Off_by_One_Error__for_09");
			(new CWE193_Off_by_One_Error__for_10()).RunTest("CWE193_Off_by_One_Error__for_10");
			(new CWE193_Off_by_One_Error__for_11()).RunTest("CWE193_Off_by_One_Error__for_11");
			(new CWE193_Off_by_One_Error__for_12()).RunTest("CWE193_Off_by_One_Error__for_12");
			(new CWE193_Off_by_One_Error__for_13()).RunTest("CWE193_Off_by_One_Error__for_13");
			(new CWE193_Off_by_One_Error__for_14()).RunTest("CWE193_Off_by_One_Error__for_14");
			(new CWE193_Off_by_One_Error__for_15()).RunTest("CWE193_Off_by_One_Error__for_15");
			(new CWE193_Off_by_One_Error__for_16()).RunTest("CWE193_Off_by_One_Error__for_16");
			(new CWE193_Off_by_One_Error__for_17()).RunTest("CWE193_Off_by_One_Error__for_17");
			(new CWE193_Off_by_One_Error__while_01()).RunTest("CWE193_Off_by_One_Error__while_01");
			(new CWE193_Off_by_One_Error__while_02()).RunTest("CWE193_Off_by_One_Error__while_02");
			(new CWE193_Off_by_One_Error__while_03()).RunTest("CWE193_Off_by_One_Error__while_03");
			(new CWE193_Off_by_One_Error__while_04()).RunTest("CWE193_Off_by_One_Error__while_04");
			(new CWE193_Off_by_One_Error__while_05()).RunTest("CWE193_Off_by_One_Error__while_05");
			(new CWE193_Off_by_One_Error__while_06()).RunTest("CWE193_Off_by_One_Error__while_06");
			(new CWE193_Off_by_One_Error__while_07()).RunTest("CWE193_Off_by_One_Error__while_07");
			(new CWE193_Off_by_One_Error__while_08()).RunTest("CWE193_Off_by_One_Error__while_08");
			(new CWE193_Off_by_One_Error__while_09()).RunTest("CWE193_Off_by_One_Error__while_09");
			(new CWE193_Off_by_One_Error__while_10()).RunTest("CWE193_Off_by_One_Error__while_10");
			(new CWE193_Off_by_One_Error__while_11()).RunTest("CWE193_Off_by_One_Error__while_11");
			(new CWE193_Off_by_One_Error__while_12()).RunTest("CWE193_Off_by_One_Error__while_12");
			(new CWE193_Off_by_One_Error__while_13()).RunTest("CWE193_Off_by_One_Error__while_13");
			(new CWE193_Off_by_One_Error__while_14()).RunTest("CWE193_Off_by_One_Error__while_14");
			(new CWE193_Off_by_One_Error__while_15()).RunTest("CWE193_Off_by_One_Error__while_15");
			(new CWE193_Off_by_One_Error__while_16()).RunTest("CWE193_Off_by_One_Error__while_16");
			(new CWE193_Off_by_One_Error__while_17()).RunTest("CWE193_Off_by_One_Error__while_17");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}