using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE197_Numeric_Truncation_Error
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_01()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_01");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_02()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_02");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_03()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_03");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_04()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_04");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_05()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_05");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_06()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_06");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_07()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_07");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_08()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_08");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_09()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_09");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_10()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_10");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_11()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_11");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_12()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_12");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_13()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_13");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_14()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_14");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_15()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_15");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_16()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_16");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_17()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_17");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_21()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_21");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_22a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_31()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_31");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_41()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_41");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_42()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_42");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_45()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_45");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_51a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_52a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_53a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_54a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_61a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_66a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_67a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_68a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_71a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_72a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_73a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_74a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_75a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_float_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_float_81a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_01");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_02");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_03");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_04");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_05");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_06");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_07");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_08");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_09");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_10");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_11");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_12");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_13");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_14");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_15");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_16");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_17");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_21");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_31");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_41");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_42");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_45");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_01()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_01");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_02()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_02");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_03()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_03");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_04()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_04");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_05()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_05");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_06()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_06");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_07()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_07");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_08()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_08");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_09()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_09");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_10()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_10");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_11()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_11");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_12()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_12");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_13()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_13");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_14()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_14");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_15()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_15");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_16()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_16");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_17()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_17");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_21()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_21");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_22a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_31()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_31");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_41()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_41");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_42()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_42");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_45()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_45");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_51a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_52a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_53a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_54a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_61a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_66a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_67a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_68a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_71a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_72a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_73a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_74a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_75a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_long_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_long_81a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_01");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_02");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_03");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_04");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_05");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_06");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_07");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_08");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_09");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_10");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_11");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_12");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_13");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_14");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_15");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_16");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_17");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_21");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_31");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_41");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_42");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_45");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__double_Environment_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_Environment_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_01()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_01");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_02()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_02");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_03()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_03");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_04()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_04");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_05()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_05");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_06()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_06");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_07()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_07");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_08()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_08");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_09()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_09");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_10()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_10");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_11()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_11");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_12()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_12");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_13()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_13");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_14()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_14");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_15()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_15");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_16()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_16");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_17()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_17");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_21()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_21");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_22a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_31()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_31");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_41()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_41");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_42()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_42");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_45()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_45");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_51a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_52a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_53a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_54a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_61a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_66a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_67a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_68a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_71a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_72a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_73a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_74a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_75a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_float_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_float_81a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_01");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_02");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_03");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_04");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_05");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_06");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_07");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_08");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_09");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_10");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_11");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_12");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_13");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_14");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_15");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_16");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_17");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_21");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_31");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_41");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_42");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_45");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_01()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_01");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_02()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_02");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_03()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_03");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_04()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_04");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_05()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_05");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_06()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_06");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_07()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_07");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_08()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_08");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_09()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_09");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_10()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_10");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_11()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_11");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_12()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_12");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_13()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_13");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_14()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_14");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_15()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_15");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_16()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_16");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_17()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_17");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_21()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_21");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_22a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_31()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_31");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_41()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_41");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_42()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_42");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_45()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_45");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_51a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_52a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_53a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_54a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_61a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_66a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_67a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_68a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_71a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_72a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_73a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_74a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_75a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_long_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_long_81a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_01");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_02");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_03");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_04");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_05");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_06");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_07");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_08");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_09");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_10");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_11");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_12");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_13");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_14");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_15");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_16");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_17");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_21");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_31");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_41");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_42");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_45");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__double_File_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_File_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_01()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_01");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_02()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_02");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_03()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_03");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_04()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_04");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_05()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_05");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_06()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_06");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_07()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_07");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_08()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_08");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_09()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_09");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_10()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_10");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_11()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_11");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_12()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_12");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_13()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_13");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_14()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_14");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_15()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_15");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_16()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_16");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_17()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_17");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_21()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_21");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_22a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_31()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_31");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_41()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_41");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_42()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_42");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_45()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_45");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_51a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_52a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_53a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_54a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_61a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_66a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_67a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_68a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_71a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_72a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_73a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_74a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_75a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_float_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_float_81a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_01");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_02");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_03");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_04");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_05");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_06");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_07");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_08");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_09");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_10");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_11");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_12");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_13");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_14");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_15");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_16");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_17");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_21");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_31");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_41");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_42");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_45");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_01()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_01");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_02()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_02");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_03()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_03");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_04()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_04");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_05()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_05");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_06()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_06");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_07()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_07");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_08()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_08");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_09()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_09");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_10()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_10");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_11()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_11");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_12()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_12");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_13()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_13");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_14()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_14");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_15()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_15");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_16()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_16");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_17()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_17");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_21()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_21");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_22a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_31()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_31");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_41()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_41");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_42()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_42");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_45()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_45");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_51a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_52a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_53a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_54a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_61a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_66a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_67a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_68a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_71a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_72a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_73a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_74a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_75a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_long_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_long_81a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_01");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_02");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_03");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_04");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_05");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_06");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_07");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_08");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_09");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_10");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_11");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_12");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_13");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_14");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_15");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_16");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_17");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_21");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_31");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_41");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_42");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_45");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__double_large_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_large_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_01()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_01");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_02()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_02");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_03()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_03");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_04()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_04");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_05()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_05");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_06()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_06");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_07()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_07");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_08()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_08");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_09()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_09");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_10()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_10");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_11()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_11");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_12()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_12");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_13()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_13");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_14()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_14");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_15()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_15");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_16()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_16");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_17()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_17");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_21()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_21");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_22a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_22a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_31()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_31");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_41()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_41");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_42()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_42");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_45()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_45");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_51a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_51a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_52a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_52a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_53a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_53a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_54a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_54a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_61a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_61a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_66a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_66a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_67a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_67a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_68a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_68a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_71a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_71a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_72a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_72a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_73a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_73a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_74a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_74a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_75a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_75a");
			(new CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_81a()).RunTest("CWE197_Numeric_Truncation_Error__double_listen_tcp_to_float_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}