using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE197_Numeric_Truncation_Error
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_01");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_02");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_03");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_04");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_05");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_06");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_07");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_08");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_09");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_10");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_11");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_12");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_13");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_14");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_15");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_16");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_17");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_21");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_31");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_41");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_42");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_45");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__float_random_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__float_random_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Connect_tcp_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_Database_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Database_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_Environment_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Environment_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_File_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_File_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_large_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_large_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Listen_tcp_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_01");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_02");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_03");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_04");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_05");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_06");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_07");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_08");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_09");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_10");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_11");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_12");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_13");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_14");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_15");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_16");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_17");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_21");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_31");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_41");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_42");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_45");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__int_NetClient_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_NetClient_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__int_Random_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__int_Random_to_byte_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}