using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE197_Numeric_Truncation_Error
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_01");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_02");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_03");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_04");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_05");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_06");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_07");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_08");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_09");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_10");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_11");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_12");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_13");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_14");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_15");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_16");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_17");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_21");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_31");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_41");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_42");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_45");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_01");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_02");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_03");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_04");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_05");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_06");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_07");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_08");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_09");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_10");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_11");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_12");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_13");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_14");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_15");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_16");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_17");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_21");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_31");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_41");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_42");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_45");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__long_File_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_File_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_01");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_02");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_03");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_04");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_05");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_06");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_07");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_08");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_09");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_10");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_11");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_12");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_13");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_14");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_15");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_16");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_17");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_21");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_31");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_41");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_42");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_45");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_01");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_02");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_03");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_04");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_05");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_06");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_07");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_08");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_09");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_10");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_11");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_12");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_13");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_14");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_15");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_16");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_17");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_21");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_31");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_41");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_42");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_45");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__long_large_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_large_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_01");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_02");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_03");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_04");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_05");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_06");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_07");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_08");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_09");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_10");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_11");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_12");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_13");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_14");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_15");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_16");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_17");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_21");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_31");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_41");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_42");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_45");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_01");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_02");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_03");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_04");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_05");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_06");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_07");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_08");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_09");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_10");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_11");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_12");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_13");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_14");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_15");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_16");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_17");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_21");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_31");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_41");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_42");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_45");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_listen_tcp_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_01");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_02");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_03");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_04");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_05");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_06");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_07");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_08");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_09");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_10");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_11");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_12");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_13");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_14");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_15");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_16");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_17");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_21");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_31");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_41");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_42");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_45");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_01");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_02");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_03");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_04");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_05");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_06");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_07");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_08");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_09");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_10");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_11");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_12");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_13");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_14");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_15");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_16");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_17");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_21");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_31");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_41");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_42");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_45");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__long_NetClient_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_NetClient_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_01()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_01");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_02()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_02");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_03()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_03");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_04()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_04");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_05()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_05");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_06()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_06");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_07()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_07");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_08()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_08");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_09()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_09");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_10()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_10");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_11()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_11");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_12()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_12");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_13()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_13");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_14()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_14");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_15()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_15");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_16()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_16");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_17()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_17");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_21()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_21");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_22a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_31()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_31");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_41()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_41");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_42()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_42");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_45()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_45");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_51a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_52a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_53a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_54a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_61a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_66a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_67a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_68a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_71a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_72a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_73a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_74a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_75a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_byte_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_byte_81a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_01()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_01");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_02()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_02");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_03()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_03");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_04()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_04");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_05()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_05");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_06()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_06");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_07()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_07");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_08()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_08");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_09()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_09");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_10()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_10");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_11()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_11");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_12()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_12");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_13()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_13");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_14()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_14");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_15()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_15");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_16()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_16");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_17()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_17");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_21()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_21");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_22a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_31()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_31");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_41()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_41");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_42()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_42");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_45()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_45");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_51a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_52a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_53a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_54a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_61a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_66a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_67a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_68a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_71a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_72a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_73a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_74a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_75a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_int_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_int_81a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_01()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_01");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_02()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_02");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_03()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_03");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_04()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_04");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_05()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_05");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_06()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_06");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_07()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_07");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_08()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_08");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_09()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_09");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_10()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_10");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_11()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_11");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_12()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_12");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_13()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_13");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_14()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_14");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_15()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_15");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_16()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_16");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_17()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_17");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_21()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_21");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_22a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_22a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_31()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_31");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_41()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_41");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_42()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_42");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_45()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_45");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_51a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_51a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_52a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_52a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_53a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_53a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_54a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_54a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_61a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_61a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_66a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_66a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_67a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_67a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_68a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_68a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_71a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_71a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_72a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_72a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_73a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_73a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_74a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_74a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_75a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_75a");
			(new CWE197_Numeric_Truncation_Error__long_random_to_short_81a()).RunTest("CWE197_Numeric_Truncation_Error__long_random_to_short_81a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_01()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_01");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_02()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_02");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_03()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_03");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_04()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_04");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_05()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_05");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_06()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_06");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_07()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_07");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_08()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_08");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_09()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_09");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_10()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_10");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_11()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_11");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_12()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_12");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_13()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_13");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_14()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_14");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_15()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_15");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_16()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_16");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_17()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_17");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_21()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_21");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_22a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_31()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_31");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_41()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_41");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_42()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_42");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_45()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_45");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_51a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_52a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_53a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_54a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_61a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_66a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_67a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_68a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_71a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_72a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_73a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_74a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_75a");
			(new CWE197_Numeric_Truncation_Error__short_connect_tcp_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_connect_tcp_81a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_01()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_01");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_02()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_02");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_03()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_03");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_04()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_04");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_05()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_05");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_06()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_06");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_07()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_07");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_08()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_08");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_09()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_09");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_10()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_10");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_11()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_11");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_12()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_12");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_13()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_13");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_14()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_14");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_15()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_15");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_16()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_16");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_17()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_17");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_21()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_21");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_22a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_31()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_31");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_41()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_41");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_42()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_42");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_45()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_45");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_51a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_52a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_53a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_54a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_61a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_66a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_67a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_68a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_71a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_72a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_73a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_74a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_75a");
			(new CWE197_Numeric_Truncation_Error__short_console_ReadLine_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_console_ReadLine_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}