using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE197_Numeric_Truncation_Error
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */
			(new CWE197_Numeric_Truncation_Error__short_database_01()).RunTest("CWE197_Numeric_Truncation_Error__short_database_01");
			(new CWE197_Numeric_Truncation_Error__short_database_02()).RunTest("CWE197_Numeric_Truncation_Error__short_database_02");
			(new CWE197_Numeric_Truncation_Error__short_database_03()).RunTest("CWE197_Numeric_Truncation_Error__short_database_03");
			(new CWE197_Numeric_Truncation_Error__short_database_04()).RunTest("CWE197_Numeric_Truncation_Error__short_database_04");
			(new CWE197_Numeric_Truncation_Error__short_database_05()).RunTest("CWE197_Numeric_Truncation_Error__short_database_05");
			(new CWE197_Numeric_Truncation_Error__short_database_06()).RunTest("CWE197_Numeric_Truncation_Error__short_database_06");
			(new CWE197_Numeric_Truncation_Error__short_database_07()).RunTest("CWE197_Numeric_Truncation_Error__short_database_07");
			(new CWE197_Numeric_Truncation_Error__short_database_08()).RunTest("CWE197_Numeric_Truncation_Error__short_database_08");
			(new CWE197_Numeric_Truncation_Error__short_database_09()).RunTest("CWE197_Numeric_Truncation_Error__short_database_09");
			(new CWE197_Numeric_Truncation_Error__short_database_10()).RunTest("CWE197_Numeric_Truncation_Error__short_database_10");
			(new CWE197_Numeric_Truncation_Error__short_database_11()).RunTest("CWE197_Numeric_Truncation_Error__short_database_11");
			(new CWE197_Numeric_Truncation_Error__short_database_12()).RunTest("CWE197_Numeric_Truncation_Error__short_database_12");
			(new CWE197_Numeric_Truncation_Error__short_database_13()).RunTest("CWE197_Numeric_Truncation_Error__short_database_13");
			(new CWE197_Numeric_Truncation_Error__short_database_14()).RunTest("CWE197_Numeric_Truncation_Error__short_database_14");
			(new CWE197_Numeric_Truncation_Error__short_database_15()).RunTest("CWE197_Numeric_Truncation_Error__short_database_15");
			(new CWE197_Numeric_Truncation_Error__short_database_16()).RunTest("CWE197_Numeric_Truncation_Error__short_database_16");
			(new CWE197_Numeric_Truncation_Error__short_database_17()).RunTest("CWE197_Numeric_Truncation_Error__short_database_17");
			(new CWE197_Numeric_Truncation_Error__short_database_21()).RunTest("CWE197_Numeric_Truncation_Error__short_database_21");
			(new CWE197_Numeric_Truncation_Error__short_database_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_22a");
			(new CWE197_Numeric_Truncation_Error__short_database_31()).RunTest("CWE197_Numeric_Truncation_Error__short_database_31");
			(new CWE197_Numeric_Truncation_Error__short_database_41()).RunTest("CWE197_Numeric_Truncation_Error__short_database_41");
			(new CWE197_Numeric_Truncation_Error__short_database_42()).RunTest("CWE197_Numeric_Truncation_Error__short_database_42");
			(new CWE197_Numeric_Truncation_Error__short_database_45()).RunTest("CWE197_Numeric_Truncation_Error__short_database_45");
			(new CWE197_Numeric_Truncation_Error__short_database_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_51a");
			(new CWE197_Numeric_Truncation_Error__short_database_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_52a");
			(new CWE197_Numeric_Truncation_Error__short_database_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_53a");
			(new CWE197_Numeric_Truncation_Error__short_database_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_54a");
			(new CWE197_Numeric_Truncation_Error__short_database_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_61a");
			(new CWE197_Numeric_Truncation_Error__short_database_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_66a");
			(new CWE197_Numeric_Truncation_Error__short_database_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_67a");
			(new CWE197_Numeric_Truncation_Error__short_database_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_68a");
			(new CWE197_Numeric_Truncation_Error__short_database_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_71a");
			(new CWE197_Numeric_Truncation_Error__short_database_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_72a");
			(new CWE197_Numeric_Truncation_Error__short_database_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_73a");
			(new CWE197_Numeric_Truncation_Error__short_database_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_74a");
			(new CWE197_Numeric_Truncation_Error__short_database_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_75a");
			(new CWE197_Numeric_Truncation_Error__short_database_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_database_81a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_01()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_01");
			(new CWE197_Numeric_Truncation_Error__short_Environment_02()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_02");
			(new CWE197_Numeric_Truncation_Error__short_Environment_03()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_03");
			(new CWE197_Numeric_Truncation_Error__short_Environment_04()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_04");
			(new CWE197_Numeric_Truncation_Error__short_Environment_05()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_05");
			(new CWE197_Numeric_Truncation_Error__short_Environment_06()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_06");
			(new CWE197_Numeric_Truncation_Error__short_Environment_07()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_07");
			(new CWE197_Numeric_Truncation_Error__short_Environment_08()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_08");
			(new CWE197_Numeric_Truncation_Error__short_Environment_09()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_09");
			(new CWE197_Numeric_Truncation_Error__short_Environment_10()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_10");
			(new CWE197_Numeric_Truncation_Error__short_Environment_11()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_11");
			(new CWE197_Numeric_Truncation_Error__short_Environment_12()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_12");
			(new CWE197_Numeric_Truncation_Error__short_Environment_13()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_13");
			(new CWE197_Numeric_Truncation_Error__short_Environment_14()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_14");
			(new CWE197_Numeric_Truncation_Error__short_Environment_15()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_15");
			(new CWE197_Numeric_Truncation_Error__short_Environment_16()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_16");
			(new CWE197_Numeric_Truncation_Error__short_Environment_17()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_17");
			(new CWE197_Numeric_Truncation_Error__short_Environment_21()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_21");
			(new CWE197_Numeric_Truncation_Error__short_Environment_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_22a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_31()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_31");
			(new CWE197_Numeric_Truncation_Error__short_Environment_41()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_41");
			(new CWE197_Numeric_Truncation_Error__short_Environment_42()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_42");
			(new CWE197_Numeric_Truncation_Error__short_Environment_45()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_45");
			(new CWE197_Numeric_Truncation_Error__short_Environment_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_51a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_52a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_53a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_54a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_61a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_66a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_67a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_68a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_71a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_72a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_73a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_74a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_75a");
			(new CWE197_Numeric_Truncation_Error__short_Environment_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_Environment_81a");
			(new CWE197_Numeric_Truncation_Error__short_File_01()).RunTest("CWE197_Numeric_Truncation_Error__short_File_01");
			(new CWE197_Numeric_Truncation_Error__short_File_02()).RunTest("CWE197_Numeric_Truncation_Error__short_File_02");
			(new CWE197_Numeric_Truncation_Error__short_File_03()).RunTest("CWE197_Numeric_Truncation_Error__short_File_03");
			(new CWE197_Numeric_Truncation_Error__short_File_04()).RunTest("CWE197_Numeric_Truncation_Error__short_File_04");
			(new CWE197_Numeric_Truncation_Error__short_File_05()).RunTest("CWE197_Numeric_Truncation_Error__short_File_05");
			(new CWE197_Numeric_Truncation_Error__short_File_06()).RunTest("CWE197_Numeric_Truncation_Error__short_File_06");
			(new CWE197_Numeric_Truncation_Error__short_File_07()).RunTest("CWE197_Numeric_Truncation_Error__short_File_07");
			(new CWE197_Numeric_Truncation_Error__short_File_08()).RunTest("CWE197_Numeric_Truncation_Error__short_File_08");
			(new CWE197_Numeric_Truncation_Error__short_File_09()).RunTest("CWE197_Numeric_Truncation_Error__short_File_09");
			(new CWE197_Numeric_Truncation_Error__short_File_10()).RunTest("CWE197_Numeric_Truncation_Error__short_File_10");
			(new CWE197_Numeric_Truncation_Error__short_File_11()).RunTest("CWE197_Numeric_Truncation_Error__short_File_11");
			(new CWE197_Numeric_Truncation_Error__short_File_12()).RunTest("CWE197_Numeric_Truncation_Error__short_File_12");
			(new CWE197_Numeric_Truncation_Error__short_File_13()).RunTest("CWE197_Numeric_Truncation_Error__short_File_13");
			(new CWE197_Numeric_Truncation_Error__short_File_14()).RunTest("CWE197_Numeric_Truncation_Error__short_File_14");
			(new CWE197_Numeric_Truncation_Error__short_File_15()).RunTest("CWE197_Numeric_Truncation_Error__short_File_15");
			(new CWE197_Numeric_Truncation_Error__short_File_16()).RunTest("CWE197_Numeric_Truncation_Error__short_File_16");
			(new CWE197_Numeric_Truncation_Error__short_File_17()).RunTest("CWE197_Numeric_Truncation_Error__short_File_17");
			(new CWE197_Numeric_Truncation_Error__short_File_21()).RunTest("CWE197_Numeric_Truncation_Error__short_File_21");
			(new CWE197_Numeric_Truncation_Error__short_File_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_22a");
			(new CWE197_Numeric_Truncation_Error__short_File_31()).RunTest("CWE197_Numeric_Truncation_Error__short_File_31");
			(new CWE197_Numeric_Truncation_Error__short_File_41()).RunTest("CWE197_Numeric_Truncation_Error__short_File_41");
			(new CWE197_Numeric_Truncation_Error__short_File_42()).RunTest("CWE197_Numeric_Truncation_Error__short_File_42");
			(new CWE197_Numeric_Truncation_Error__short_File_45()).RunTest("CWE197_Numeric_Truncation_Error__short_File_45");
			(new CWE197_Numeric_Truncation_Error__short_File_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_51a");
			(new CWE197_Numeric_Truncation_Error__short_File_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_52a");
			(new CWE197_Numeric_Truncation_Error__short_File_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_53a");
			(new CWE197_Numeric_Truncation_Error__short_File_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_54a");
			(new CWE197_Numeric_Truncation_Error__short_File_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_61a");
			(new CWE197_Numeric_Truncation_Error__short_File_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_66a");
			(new CWE197_Numeric_Truncation_Error__short_File_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_67a");
			(new CWE197_Numeric_Truncation_Error__short_File_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_68a");
			(new CWE197_Numeric_Truncation_Error__short_File_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_71a");
			(new CWE197_Numeric_Truncation_Error__short_File_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_72a");
			(new CWE197_Numeric_Truncation_Error__short_File_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_73a");
			(new CWE197_Numeric_Truncation_Error__short_File_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_74a");
			(new CWE197_Numeric_Truncation_Error__short_File_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_75a");
			(new CWE197_Numeric_Truncation_Error__short_File_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_File_81a");
			(new CWE197_Numeric_Truncation_Error__short_large_01()).RunTest("CWE197_Numeric_Truncation_Error__short_large_01");
			(new CWE197_Numeric_Truncation_Error__short_large_02()).RunTest("CWE197_Numeric_Truncation_Error__short_large_02");
			(new CWE197_Numeric_Truncation_Error__short_large_03()).RunTest("CWE197_Numeric_Truncation_Error__short_large_03");
			(new CWE197_Numeric_Truncation_Error__short_large_04()).RunTest("CWE197_Numeric_Truncation_Error__short_large_04");
			(new CWE197_Numeric_Truncation_Error__short_large_05()).RunTest("CWE197_Numeric_Truncation_Error__short_large_05");
			(new CWE197_Numeric_Truncation_Error__short_large_06()).RunTest("CWE197_Numeric_Truncation_Error__short_large_06");
			(new CWE197_Numeric_Truncation_Error__short_large_07()).RunTest("CWE197_Numeric_Truncation_Error__short_large_07");
			(new CWE197_Numeric_Truncation_Error__short_large_08()).RunTest("CWE197_Numeric_Truncation_Error__short_large_08");
			(new CWE197_Numeric_Truncation_Error__short_large_09()).RunTest("CWE197_Numeric_Truncation_Error__short_large_09");
			(new CWE197_Numeric_Truncation_Error__short_large_10()).RunTest("CWE197_Numeric_Truncation_Error__short_large_10");
			(new CWE197_Numeric_Truncation_Error__short_large_11()).RunTest("CWE197_Numeric_Truncation_Error__short_large_11");
			(new CWE197_Numeric_Truncation_Error__short_large_12()).RunTest("CWE197_Numeric_Truncation_Error__short_large_12");
			(new CWE197_Numeric_Truncation_Error__short_large_13()).RunTest("CWE197_Numeric_Truncation_Error__short_large_13");
			(new CWE197_Numeric_Truncation_Error__short_large_14()).RunTest("CWE197_Numeric_Truncation_Error__short_large_14");
			(new CWE197_Numeric_Truncation_Error__short_large_15()).RunTest("CWE197_Numeric_Truncation_Error__short_large_15");
			(new CWE197_Numeric_Truncation_Error__short_large_16()).RunTest("CWE197_Numeric_Truncation_Error__short_large_16");
			(new CWE197_Numeric_Truncation_Error__short_large_17()).RunTest("CWE197_Numeric_Truncation_Error__short_large_17");
			(new CWE197_Numeric_Truncation_Error__short_large_21()).RunTest("CWE197_Numeric_Truncation_Error__short_large_21");
			(new CWE197_Numeric_Truncation_Error__short_large_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_22a");
			(new CWE197_Numeric_Truncation_Error__short_large_31()).RunTest("CWE197_Numeric_Truncation_Error__short_large_31");
			(new CWE197_Numeric_Truncation_Error__short_large_41()).RunTest("CWE197_Numeric_Truncation_Error__short_large_41");
			(new CWE197_Numeric_Truncation_Error__short_large_42()).RunTest("CWE197_Numeric_Truncation_Error__short_large_42");
			(new CWE197_Numeric_Truncation_Error__short_large_45()).RunTest("CWE197_Numeric_Truncation_Error__short_large_45");
			(new CWE197_Numeric_Truncation_Error__short_large_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_51a");
			(new CWE197_Numeric_Truncation_Error__short_large_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_52a");
			(new CWE197_Numeric_Truncation_Error__short_large_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_53a");
			(new CWE197_Numeric_Truncation_Error__short_large_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_54a");
			(new CWE197_Numeric_Truncation_Error__short_large_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_61a");
			(new CWE197_Numeric_Truncation_Error__short_large_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_66a");
			(new CWE197_Numeric_Truncation_Error__short_large_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_67a");
			(new CWE197_Numeric_Truncation_Error__short_large_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_68a");
			(new CWE197_Numeric_Truncation_Error__short_large_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_71a");
			(new CWE197_Numeric_Truncation_Error__short_large_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_72a");
			(new CWE197_Numeric_Truncation_Error__short_large_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_73a");
			(new CWE197_Numeric_Truncation_Error__short_large_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_74a");
			(new CWE197_Numeric_Truncation_Error__short_large_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_75a");
			(new CWE197_Numeric_Truncation_Error__short_large_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_large_81a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_01()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_01");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_02()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_02");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_03()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_03");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_04()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_04");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_05()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_05");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_06()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_06");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_07()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_07");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_08()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_08");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_09()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_09");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_10()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_10");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_11()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_11");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_12()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_12");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_13()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_13");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_14()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_14");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_15()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_15");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_16()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_16");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_17()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_17");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_21()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_21");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_22a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_31()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_31");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_41()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_41");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_42()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_42");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_45()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_45");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_51a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_52a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_53a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_54a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_61a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_66a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_67a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_68a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_71a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_72a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_73a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_74a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_75a");
			(new CWE197_Numeric_Truncation_Error__short_listen_tcp_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_listen_tcp_81a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_01()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_01");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_02()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_02");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_03()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_03");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_04()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_04");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_05()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_05");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_06()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_06");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_07()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_07");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_08()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_08");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_09()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_09");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_10()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_10");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_11()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_11");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_12()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_12");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_13()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_13");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_14()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_14");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_15()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_15");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_16()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_16");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_17()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_17");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_21()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_21");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_22a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_31()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_31");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_41()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_41");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_42()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_42");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_45()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_45");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_51a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_52a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_53a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_54a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_61a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_66a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_67a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_68a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_71a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_72a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_73a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_74a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_75a");
			(new CWE197_Numeric_Truncation_Error__short_NetClient_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_NetClient_81a");
			(new CWE197_Numeric_Truncation_Error__short_random_01()).RunTest("CWE197_Numeric_Truncation_Error__short_random_01");
			(new CWE197_Numeric_Truncation_Error__short_random_02()).RunTest("CWE197_Numeric_Truncation_Error__short_random_02");
			(new CWE197_Numeric_Truncation_Error__short_random_03()).RunTest("CWE197_Numeric_Truncation_Error__short_random_03");
			(new CWE197_Numeric_Truncation_Error__short_random_04()).RunTest("CWE197_Numeric_Truncation_Error__short_random_04");
			(new CWE197_Numeric_Truncation_Error__short_random_05()).RunTest("CWE197_Numeric_Truncation_Error__short_random_05");
			(new CWE197_Numeric_Truncation_Error__short_random_06()).RunTest("CWE197_Numeric_Truncation_Error__short_random_06");
			(new CWE197_Numeric_Truncation_Error__short_random_07()).RunTest("CWE197_Numeric_Truncation_Error__short_random_07");
			(new CWE197_Numeric_Truncation_Error__short_random_08()).RunTest("CWE197_Numeric_Truncation_Error__short_random_08");
			(new CWE197_Numeric_Truncation_Error__short_random_09()).RunTest("CWE197_Numeric_Truncation_Error__short_random_09");
			(new CWE197_Numeric_Truncation_Error__short_random_10()).RunTest("CWE197_Numeric_Truncation_Error__short_random_10");
			(new CWE197_Numeric_Truncation_Error__short_random_11()).RunTest("CWE197_Numeric_Truncation_Error__short_random_11");
			(new CWE197_Numeric_Truncation_Error__short_random_12()).RunTest("CWE197_Numeric_Truncation_Error__short_random_12");
			(new CWE197_Numeric_Truncation_Error__short_random_13()).RunTest("CWE197_Numeric_Truncation_Error__short_random_13");
			(new CWE197_Numeric_Truncation_Error__short_random_14()).RunTest("CWE197_Numeric_Truncation_Error__short_random_14");
			(new CWE197_Numeric_Truncation_Error__short_random_15()).RunTest("CWE197_Numeric_Truncation_Error__short_random_15");
			(new CWE197_Numeric_Truncation_Error__short_random_16()).RunTest("CWE197_Numeric_Truncation_Error__short_random_16");
			(new CWE197_Numeric_Truncation_Error__short_random_17()).RunTest("CWE197_Numeric_Truncation_Error__short_random_17");
			(new CWE197_Numeric_Truncation_Error__short_random_21()).RunTest("CWE197_Numeric_Truncation_Error__short_random_21");
			(new CWE197_Numeric_Truncation_Error__short_random_22a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_22a");
			(new CWE197_Numeric_Truncation_Error__short_random_31()).RunTest("CWE197_Numeric_Truncation_Error__short_random_31");
			(new CWE197_Numeric_Truncation_Error__short_random_41()).RunTest("CWE197_Numeric_Truncation_Error__short_random_41");
			(new CWE197_Numeric_Truncation_Error__short_random_42()).RunTest("CWE197_Numeric_Truncation_Error__short_random_42");
			(new CWE197_Numeric_Truncation_Error__short_random_45()).RunTest("CWE197_Numeric_Truncation_Error__short_random_45");
			(new CWE197_Numeric_Truncation_Error__short_random_51a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_51a");
			(new CWE197_Numeric_Truncation_Error__short_random_52a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_52a");
			(new CWE197_Numeric_Truncation_Error__short_random_53a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_53a");
			(new CWE197_Numeric_Truncation_Error__short_random_54a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_54a");
			(new CWE197_Numeric_Truncation_Error__short_random_61a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_61a");
			(new CWE197_Numeric_Truncation_Error__short_random_66a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_66a");
			(new CWE197_Numeric_Truncation_Error__short_random_67a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_67a");
			(new CWE197_Numeric_Truncation_Error__short_random_68a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_68a");
			(new CWE197_Numeric_Truncation_Error__short_random_71a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_71a");
			(new CWE197_Numeric_Truncation_Error__short_random_72a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_72a");
			(new CWE197_Numeric_Truncation_Error__short_random_73a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_73a");
			(new CWE197_Numeric_Truncation_Error__short_random_74a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_74a");
			(new CWE197_Numeric_Truncation_Error__short_random_75a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_75a");
			(new CWE197_Numeric_Truncation_Error__short_random_81a()).RunTest("CWE197_Numeric_Truncation_Error__short_random_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}