using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE259_Hard_Coded_Password
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */
			(new CWE259_Hard_Coded_Password__NetworkCredential_01()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_01");
			(new CWE259_Hard_Coded_Password__NetworkCredential_02()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_02");
			(new CWE259_Hard_Coded_Password__NetworkCredential_03()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_03");
			(new CWE259_Hard_Coded_Password__NetworkCredential_04()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_04");
			(new CWE259_Hard_Coded_Password__NetworkCredential_05()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_05");
			(new CWE259_Hard_Coded_Password__NetworkCredential_06()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_06");
			(new CWE259_Hard_Coded_Password__NetworkCredential_07()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_07");
			(new CWE259_Hard_Coded_Password__NetworkCredential_08()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_08");
			(new CWE259_Hard_Coded_Password__NetworkCredential_09()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_09");
			(new CWE259_Hard_Coded_Password__NetworkCredential_10()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_10");
			(new CWE259_Hard_Coded_Password__NetworkCredential_11()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_11");
			(new CWE259_Hard_Coded_Password__NetworkCredential_12()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_12");
			(new CWE259_Hard_Coded_Password__NetworkCredential_13()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_13");
			(new CWE259_Hard_Coded_Password__NetworkCredential_14()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_14");
			(new CWE259_Hard_Coded_Password__NetworkCredential_15()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_15");
			(new CWE259_Hard_Coded_Password__NetworkCredential_16()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_16");
			(new CWE259_Hard_Coded_Password__NetworkCredential_17()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_17");
			(new CWE259_Hard_Coded_Password__NetworkCredential_21()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_21");
			(new CWE259_Hard_Coded_Password__NetworkCredential_22a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_22a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_31()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_31");
			(new CWE259_Hard_Coded_Password__NetworkCredential_41()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_41");
			(new CWE259_Hard_Coded_Password__NetworkCredential_42()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_42");
			(new CWE259_Hard_Coded_Password__NetworkCredential_45()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_45");
			(new CWE259_Hard_Coded_Password__NetworkCredential_51a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_51a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_52a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_52a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_53a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_53a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_54a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_54a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_61a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_61a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_66a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_66a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_67a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_67a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_68a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_68a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_71a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_71a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_72a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_72a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_73a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_73a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_74a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_74a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_75a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_75a");
			(new CWE259_Hard_Coded_Password__NetworkCredential_81a()).RunTest("CWE259_Hard_Coded_Password__NetworkCredential_81a");
			(new CWE259_Hard_Coded_Password__SqlConnection_01()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_01");
			(new CWE259_Hard_Coded_Password__SqlConnection_02()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_02");
			(new CWE259_Hard_Coded_Password__SqlConnection_03()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_03");
			(new CWE259_Hard_Coded_Password__SqlConnection_04()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_04");
			(new CWE259_Hard_Coded_Password__SqlConnection_05()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_05");
			(new CWE259_Hard_Coded_Password__SqlConnection_06()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_06");
			(new CWE259_Hard_Coded_Password__SqlConnection_07()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_07");
			(new CWE259_Hard_Coded_Password__SqlConnection_08()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_08");
			(new CWE259_Hard_Coded_Password__SqlConnection_09()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_09");
			(new CWE259_Hard_Coded_Password__SqlConnection_10()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_10");
			(new CWE259_Hard_Coded_Password__SqlConnection_11()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_11");
			(new CWE259_Hard_Coded_Password__SqlConnection_12()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_12");
			(new CWE259_Hard_Coded_Password__SqlConnection_13()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_13");
			(new CWE259_Hard_Coded_Password__SqlConnection_14()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_14");
			(new CWE259_Hard_Coded_Password__SqlConnection_15()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_15");
			(new CWE259_Hard_Coded_Password__SqlConnection_16()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_16");
			(new CWE259_Hard_Coded_Password__SqlConnection_17()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_17");
			(new CWE259_Hard_Coded_Password__SqlConnection_21()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_21");
			(new CWE259_Hard_Coded_Password__SqlConnection_22a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_22a");
			(new CWE259_Hard_Coded_Password__SqlConnection_31()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_31");
			(new CWE259_Hard_Coded_Password__SqlConnection_41()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_41");
			(new CWE259_Hard_Coded_Password__SqlConnection_42()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_42");
			(new CWE259_Hard_Coded_Password__SqlConnection_45()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_45");
			(new CWE259_Hard_Coded_Password__SqlConnection_51a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_51a");
			(new CWE259_Hard_Coded_Password__SqlConnection_52a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_52a");
			(new CWE259_Hard_Coded_Password__SqlConnection_53a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_53a");
			(new CWE259_Hard_Coded_Password__SqlConnection_54a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_54a");
			(new CWE259_Hard_Coded_Password__SqlConnection_61a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_61a");
			(new CWE259_Hard_Coded_Password__SqlConnection_66a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_66a");
			(new CWE259_Hard_Coded_Password__SqlConnection_67a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_67a");
			(new CWE259_Hard_Coded_Password__SqlConnection_68a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_68a");
			(new CWE259_Hard_Coded_Password__SqlConnection_71a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_71a");
			(new CWE259_Hard_Coded_Password__SqlConnection_72a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_72a");
			(new CWE259_Hard_Coded_Password__SqlConnection_73a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_73a");
			(new CWE259_Hard_Coded_Password__SqlConnection_74a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_74a");
			(new CWE259_Hard_Coded_Password__SqlConnection_75a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_75a");
			(new CWE259_Hard_Coded_Password__SqlConnection_81a()).RunTest("CWE259_Hard_Coded_Password__SqlConnection_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}