using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE319_Cleartext_Tx_Sensitive_Info
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_01()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_01");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_02()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_02");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_03()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_03");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_04()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_04");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_05()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_05");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_06()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_06");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_07()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_07");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_08()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_08");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_09()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_09");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_10()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_10");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_11()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_11");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_12()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_12");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_13()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_13");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_14()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_14");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_15()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_15");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_16()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_16");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_17()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_17");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_21()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_21");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_22a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_22a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_31()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_31");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_41()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_41");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_42()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_42");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_45()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_45");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_51a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_51a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_52a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_52a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_53a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_53a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_54a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_54a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_61a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_61a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_66a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_66a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_67a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_67a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_68a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_68a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_71a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_71a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_72a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_72a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_73a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_73a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_74a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_74a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_75a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_75a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_81a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__connect_tcp_SqlConnection_81a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_01()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_01");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_02()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_02");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_03()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_03");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_04()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_04");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_05()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_05");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_06()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_06");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_07()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_07");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_08()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_08");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_09()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_09");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_10()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_10");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_11()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_11");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_12()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_12");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_13()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_13");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_14()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_14");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_15()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_15");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_16()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_16");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_17()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_17");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_21()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_21");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_22a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_22a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_31()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_31");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_41()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_41");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_42()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_42");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_45()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_45");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_51a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_51a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_52a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_52a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_53a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_53a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_54a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_54a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_61a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_61a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_66a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_66a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_67a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_67a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_68a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_68a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_71a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_71a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_72a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_72a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_73a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_73a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_74a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_74a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_75a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_75a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_81a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__listen_tcp_SqlConnection_81a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_01()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_01");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_02()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_02");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_03()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_03");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_04()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_04");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_05()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_05");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_06()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_06");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_07()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_07");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_08()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_08");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_09()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_09");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_10()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_10");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_11()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_11");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_12()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_12");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_13()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_13");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_14()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_14");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_15()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_15");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_16()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_16");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_17()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_17");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_21()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_21");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_22a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_22a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_31()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_31");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_41()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_41");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_42()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_42");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_45()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_45");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_51a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_51a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_52a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_52a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_53a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_53a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_54a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_54a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_61a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_61a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_66a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_66a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_67a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_67a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_68a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_68a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_71a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_71a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_72a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_72a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_73a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_73a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_74a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_74a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_75a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_75a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_81a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__NetClient_SqlConnection_81a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_01()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_01");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_02()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_02");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_03()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_03");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_04()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_04");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_05()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_05");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_06()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_06");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_07()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_07");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_08()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_08");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_09()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_09");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_10()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_10");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_11()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_11");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_12()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_12");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_13()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_13");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_14()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_14");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_15()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_15");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_16()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_16");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_17()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_17");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_21()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_21");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_22a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_22a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_31()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_31");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_41()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_41");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_42()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_42");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_45()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_45");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_51a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_51a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_52a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_52a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_53a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_53a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_54a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_54a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_61a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_61a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_66a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_66a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_67a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_67a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_68a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_68a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_71a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_71a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_72a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_72a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_73a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_73a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_74a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_74a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_75a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_75a");
			(new CWE319_Cleartext_Tx_Sensitive_Info__send_81a()).RunTest("CWE319_Cleartext_Tx_Sensitive_Info__send_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}