using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE369_Divide_by_Zero
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */
			(new CWE369_Divide_by_Zero__float_zero_divide_01()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_01");
			(new CWE369_Divide_by_Zero__float_zero_divide_02()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_02");
			(new CWE369_Divide_by_Zero__float_zero_divide_03()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_03");
			(new CWE369_Divide_by_Zero__float_zero_divide_04()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_04");
			(new CWE369_Divide_by_Zero__float_zero_divide_05()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_05");
			(new CWE369_Divide_by_Zero__float_zero_divide_06()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_06");
			(new CWE369_Divide_by_Zero__float_zero_divide_07()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_07");
			(new CWE369_Divide_by_Zero__float_zero_divide_08()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_08");
			(new CWE369_Divide_by_Zero__float_zero_divide_09()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_09");
			(new CWE369_Divide_by_Zero__float_zero_divide_10()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_10");
			(new CWE369_Divide_by_Zero__float_zero_divide_11()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_11");
			(new CWE369_Divide_by_Zero__float_zero_divide_12()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_12");
			(new CWE369_Divide_by_Zero__float_zero_divide_13()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_13");
			(new CWE369_Divide_by_Zero__float_zero_divide_14()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_14");
			(new CWE369_Divide_by_Zero__float_zero_divide_15()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_15");
			(new CWE369_Divide_by_Zero__float_zero_divide_16()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_16");
			(new CWE369_Divide_by_Zero__float_zero_divide_17()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_17");
			(new CWE369_Divide_by_Zero__float_zero_divide_21()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_21");
			(new CWE369_Divide_by_Zero__float_zero_divide_22a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_22a");
			(new CWE369_Divide_by_Zero__float_zero_divide_31()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_31");
			(new CWE369_Divide_by_Zero__float_zero_divide_41()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_41");
			(new CWE369_Divide_by_Zero__float_zero_divide_42()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_42");
			(new CWE369_Divide_by_Zero__float_zero_divide_45()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_45");
			(new CWE369_Divide_by_Zero__float_zero_divide_51a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_51a");
			(new CWE369_Divide_by_Zero__float_zero_divide_52a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_52a");
			(new CWE369_Divide_by_Zero__float_zero_divide_53a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_53a");
			(new CWE369_Divide_by_Zero__float_zero_divide_54a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_54a");
			(new CWE369_Divide_by_Zero__float_zero_divide_61a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_61a");
			(new CWE369_Divide_by_Zero__float_zero_divide_66a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_66a");
			(new CWE369_Divide_by_Zero__float_zero_divide_67a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_67a");
			(new CWE369_Divide_by_Zero__float_zero_divide_68a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_68a");
			(new CWE369_Divide_by_Zero__float_zero_divide_71a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_71a");
			(new CWE369_Divide_by_Zero__float_zero_divide_72a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_72a");
			(new CWE369_Divide_by_Zero__float_zero_divide_73a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_73a");
			(new CWE369_Divide_by_Zero__float_zero_divide_74a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_74a");
			(new CWE369_Divide_by_Zero__float_zero_divide_75a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_75a");
			(new CWE369_Divide_by_Zero__float_zero_divide_81a()).RunTest("CWE369_Divide_by_Zero__float_zero_divide_81a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_01()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_01");
			(new CWE369_Divide_by_Zero__float_zero_modulo_02()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_02");
			(new CWE369_Divide_by_Zero__float_zero_modulo_03()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_03");
			(new CWE369_Divide_by_Zero__float_zero_modulo_04()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_04");
			(new CWE369_Divide_by_Zero__float_zero_modulo_05()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_05");
			(new CWE369_Divide_by_Zero__float_zero_modulo_06()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_06");
			(new CWE369_Divide_by_Zero__float_zero_modulo_07()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_07");
			(new CWE369_Divide_by_Zero__float_zero_modulo_08()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_08");
			(new CWE369_Divide_by_Zero__float_zero_modulo_09()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_09");
			(new CWE369_Divide_by_Zero__float_zero_modulo_10()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_10");
			(new CWE369_Divide_by_Zero__float_zero_modulo_11()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_11");
			(new CWE369_Divide_by_Zero__float_zero_modulo_12()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_12");
			(new CWE369_Divide_by_Zero__float_zero_modulo_13()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_13");
			(new CWE369_Divide_by_Zero__float_zero_modulo_14()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_14");
			(new CWE369_Divide_by_Zero__float_zero_modulo_15()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_15");
			(new CWE369_Divide_by_Zero__float_zero_modulo_16()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_16");
			(new CWE369_Divide_by_Zero__float_zero_modulo_17()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_17");
			(new CWE369_Divide_by_Zero__float_zero_modulo_21()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_21");
			(new CWE369_Divide_by_Zero__float_zero_modulo_22a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_22a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_31()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_31");
			(new CWE369_Divide_by_Zero__float_zero_modulo_41()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_41");
			(new CWE369_Divide_by_Zero__float_zero_modulo_42()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_42");
			(new CWE369_Divide_by_Zero__float_zero_modulo_45()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_45");
			(new CWE369_Divide_by_Zero__float_zero_modulo_51a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_51a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_52a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_52a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_53a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_53a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_54a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_54a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_61a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_61a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_66a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_66a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_67a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_67a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_68a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_68a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_71a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_71a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_72a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_72a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_73a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_73a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_74a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_74a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_75a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_75a");
			(new CWE369_Divide_by_Zero__float_zero_modulo_81a()).RunTest("CWE369_Divide_by_Zero__float_zero_modulo_81a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_01()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_01");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_02()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_02");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_03()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_03");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_04()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_04");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_05()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_05");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_06()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_06");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_07()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_07");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_08()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_08");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_09()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_09");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_10()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_10");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_11()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_11");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_12()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_12");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_13()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_13");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_14()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_14");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_15()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_15");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_16()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_16");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_17()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_17");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_21()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_21");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_22a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_31()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_31");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_41()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_41");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_42()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_42");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_45()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_45");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_51a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_52a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_53a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_54a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_61a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_66a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_67a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_68a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_71a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_72a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_73a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_74a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_75a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_divide_81a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_01");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_02");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_03");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_04");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_05");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_06");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_07");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_08");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_09");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_10");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_11");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_12");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_13");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_14");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_15");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_16");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_17");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_21");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_22a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_31");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_41");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_42");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_45");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_51a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_52a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_53a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_54a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_61a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_66a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_67a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_68a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_71a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_72a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_73a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_74a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_75a");
			(new CWE369_Divide_by_Zero__int_Connect_tcp_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_Connect_tcp_modulo_81a");
			(new CWE369_Divide_by_Zero__int_Database_divide_01()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_01");
			(new CWE369_Divide_by_Zero__int_Database_divide_02()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_02");
			(new CWE369_Divide_by_Zero__int_Database_divide_03()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_03");
			(new CWE369_Divide_by_Zero__int_Database_divide_04()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_04");
			(new CWE369_Divide_by_Zero__int_Database_divide_05()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_05");
			(new CWE369_Divide_by_Zero__int_Database_divide_06()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_06");
			(new CWE369_Divide_by_Zero__int_Database_divide_07()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_07");
			(new CWE369_Divide_by_Zero__int_Database_divide_08()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_08");
			(new CWE369_Divide_by_Zero__int_Database_divide_09()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_09");
			(new CWE369_Divide_by_Zero__int_Database_divide_10()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_10");
			(new CWE369_Divide_by_Zero__int_Database_divide_11()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_11");
			(new CWE369_Divide_by_Zero__int_Database_divide_12()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_12");
			(new CWE369_Divide_by_Zero__int_Database_divide_13()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_13");
			(new CWE369_Divide_by_Zero__int_Database_divide_14()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_14");
			(new CWE369_Divide_by_Zero__int_Database_divide_15()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_15");
			(new CWE369_Divide_by_Zero__int_Database_divide_16()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_16");
			(new CWE369_Divide_by_Zero__int_Database_divide_17()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_17");
			(new CWE369_Divide_by_Zero__int_Database_divide_21()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_21");
			(new CWE369_Divide_by_Zero__int_Database_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_22a");
			(new CWE369_Divide_by_Zero__int_Database_divide_31()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_31");
			(new CWE369_Divide_by_Zero__int_Database_divide_41()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_41");
			(new CWE369_Divide_by_Zero__int_Database_divide_42()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_42");
			(new CWE369_Divide_by_Zero__int_Database_divide_45()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_45");
			(new CWE369_Divide_by_Zero__int_Database_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_51a");
			(new CWE369_Divide_by_Zero__int_Database_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_52a");
			(new CWE369_Divide_by_Zero__int_Database_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_53a");
			(new CWE369_Divide_by_Zero__int_Database_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_54a");
			(new CWE369_Divide_by_Zero__int_Database_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_61a");
			(new CWE369_Divide_by_Zero__int_Database_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_66a");
			(new CWE369_Divide_by_Zero__int_Database_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_67a");
			(new CWE369_Divide_by_Zero__int_Database_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_68a");
			(new CWE369_Divide_by_Zero__int_Database_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_71a");
			(new CWE369_Divide_by_Zero__int_Database_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_72a");
			(new CWE369_Divide_by_Zero__int_Database_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_73a");
			(new CWE369_Divide_by_Zero__int_Database_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_74a");
			(new CWE369_Divide_by_Zero__int_Database_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_75a");
			(new CWE369_Divide_by_Zero__int_Database_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_Database_divide_81a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_01");
			(new CWE369_Divide_by_Zero__int_Database_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_02");
			(new CWE369_Divide_by_Zero__int_Database_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_03");
			(new CWE369_Divide_by_Zero__int_Database_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_04");
			(new CWE369_Divide_by_Zero__int_Database_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_05");
			(new CWE369_Divide_by_Zero__int_Database_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_06");
			(new CWE369_Divide_by_Zero__int_Database_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_07");
			(new CWE369_Divide_by_Zero__int_Database_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_08");
			(new CWE369_Divide_by_Zero__int_Database_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_09");
			(new CWE369_Divide_by_Zero__int_Database_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_10");
			(new CWE369_Divide_by_Zero__int_Database_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_11");
			(new CWE369_Divide_by_Zero__int_Database_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_12");
			(new CWE369_Divide_by_Zero__int_Database_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_13");
			(new CWE369_Divide_by_Zero__int_Database_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_14");
			(new CWE369_Divide_by_Zero__int_Database_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_15");
			(new CWE369_Divide_by_Zero__int_Database_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_16");
			(new CWE369_Divide_by_Zero__int_Database_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_17");
			(new CWE369_Divide_by_Zero__int_Database_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_21");
			(new CWE369_Divide_by_Zero__int_Database_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_22a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_31");
			(new CWE369_Divide_by_Zero__int_Database_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_41");
			(new CWE369_Divide_by_Zero__int_Database_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_42");
			(new CWE369_Divide_by_Zero__int_Database_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_45");
			(new CWE369_Divide_by_Zero__int_Database_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_51a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_52a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_53a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_54a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_61a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_66a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_67a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_68a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_71a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_72a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_73a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_74a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_75a");
			(new CWE369_Divide_by_Zero__int_Database_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_Database_modulo_81a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_01()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_01");
			(new CWE369_Divide_by_Zero__int_Environment_divide_02()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_02");
			(new CWE369_Divide_by_Zero__int_Environment_divide_03()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_03");
			(new CWE369_Divide_by_Zero__int_Environment_divide_04()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_04");
			(new CWE369_Divide_by_Zero__int_Environment_divide_05()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_05");
			(new CWE369_Divide_by_Zero__int_Environment_divide_06()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_06");
			(new CWE369_Divide_by_Zero__int_Environment_divide_07()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_07");
			(new CWE369_Divide_by_Zero__int_Environment_divide_08()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_08");
			(new CWE369_Divide_by_Zero__int_Environment_divide_09()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_09");
			(new CWE369_Divide_by_Zero__int_Environment_divide_10()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_10");
			(new CWE369_Divide_by_Zero__int_Environment_divide_11()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_11");
			(new CWE369_Divide_by_Zero__int_Environment_divide_12()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_12");
			(new CWE369_Divide_by_Zero__int_Environment_divide_13()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_13");
			(new CWE369_Divide_by_Zero__int_Environment_divide_14()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_14");
			(new CWE369_Divide_by_Zero__int_Environment_divide_15()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_15");
			(new CWE369_Divide_by_Zero__int_Environment_divide_16()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_16");
			(new CWE369_Divide_by_Zero__int_Environment_divide_17()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_17");
			(new CWE369_Divide_by_Zero__int_Environment_divide_21()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_21");
			(new CWE369_Divide_by_Zero__int_Environment_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_22a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_31()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_31");
			(new CWE369_Divide_by_Zero__int_Environment_divide_41()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_41");
			(new CWE369_Divide_by_Zero__int_Environment_divide_42()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_42");
			(new CWE369_Divide_by_Zero__int_Environment_divide_45()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_45");
			(new CWE369_Divide_by_Zero__int_Environment_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_51a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_52a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_53a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_54a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_61a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_66a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_67a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_68a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_71a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_72a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_73a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_74a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_75a");
			(new CWE369_Divide_by_Zero__int_Environment_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_Environment_divide_81a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_01");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_02");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_03");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_04");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_05");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_06");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_07");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_08");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_09");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_10");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_11");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_12");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_13");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_14");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_15");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_16");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_17");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_21");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_22a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_31");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_41");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_42");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_45");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_51a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_52a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_53a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_54a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_61a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_66a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_67a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_68a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_71a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_72a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_73a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_74a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_75a");
			(new CWE369_Divide_by_Zero__int_Environment_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_Environment_modulo_81a");
			(new CWE369_Divide_by_Zero__int_File_divide_01()).RunTest("CWE369_Divide_by_Zero__int_File_divide_01");
			(new CWE369_Divide_by_Zero__int_File_divide_02()).RunTest("CWE369_Divide_by_Zero__int_File_divide_02");
			(new CWE369_Divide_by_Zero__int_File_divide_03()).RunTest("CWE369_Divide_by_Zero__int_File_divide_03");
			(new CWE369_Divide_by_Zero__int_File_divide_04()).RunTest("CWE369_Divide_by_Zero__int_File_divide_04");
			(new CWE369_Divide_by_Zero__int_File_divide_05()).RunTest("CWE369_Divide_by_Zero__int_File_divide_05");
			(new CWE369_Divide_by_Zero__int_File_divide_06()).RunTest("CWE369_Divide_by_Zero__int_File_divide_06");
			(new CWE369_Divide_by_Zero__int_File_divide_07()).RunTest("CWE369_Divide_by_Zero__int_File_divide_07");
			(new CWE369_Divide_by_Zero__int_File_divide_08()).RunTest("CWE369_Divide_by_Zero__int_File_divide_08");
			(new CWE369_Divide_by_Zero__int_File_divide_09()).RunTest("CWE369_Divide_by_Zero__int_File_divide_09");
			(new CWE369_Divide_by_Zero__int_File_divide_10()).RunTest("CWE369_Divide_by_Zero__int_File_divide_10");
			(new CWE369_Divide_by_Zero__int_File_divide_11()).RunTest("CWE369_Divide_by_Zero__int_File_divide_11");
			(new CWE369_Divide_by_Zero__int_File_divide_12()).RunTest("CWE369_Divide_by_Zero__int_File_divide_12");
			(new CWE369_Divide_by_Zero__int_File_divide_13()).RunTest("CWE369_Divide_by_Zero__int_File_divide_13");
			(new CWE369_Divide_by_Zero__int_File_divide_14()).RunTest("CWE369_Divide_by_Zero__int_File_divide_14");
			(new CWE369_Divide_by_Zero__int_File_divide_15()).RunTest("CWE369_Divide_by_Zero__int_File_divide_15");
			(new CWE369_Divide_by_Zero__int_File_divide_16()).RunTest("CWE369_Divide_by_Zero__int_File_divide_16");
			(new CWE369_Divide_by_Zero__int_File_divide_17()).RunTest("CWE369_Divide_by_Zero__int_File_divide_17");
			(new CWE369_Divide_by_Zero__int_File_divide_21()).RunTest("CWE369_Divide_by_Zero__int_File_divide_21");
			(new CWE369_Divide_by_Zero__int_File_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_22a");
			(new CWE369_Divide_by_Zero__int_File_divide_31()).RunTest("CWE369_Divide_by_Zero__int_File_divide_31");
			(new CWE369_Divide_by_Zero__int_File_divide_41()).RunTest("CWE369_Divide_by_Zero__int_File_divide_41");
			(new CWE369_Divide_by_Zero__int_File_divide_42()).RunTest("CWE369_Divide_by_Zero__int_File_divide_42");
			(new CWE369_Divide_by_Zero__int_File_divide_45()).RunTest("CWE369_Divide_by_Zero__int_File_divide_45");
			(new CWE369_Divide_by_Zero__int_File_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_51a");
			(new CWE369_Divide_by_Zero__int_File_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_52a");
			(new CWE369_Divide_by_Zero__int_File_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_53a");
			(new CWE369_Divide_by_Zero__int_File_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_54a");
			(new CWE369_Divide_by_Zero__int_File_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_61a");
			(new CWE369_Divide_by_Zero__int_File_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_66a");
			(new CWE369_Divide_by_Zero__int_File_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_67a");
			(new CWE369_Divide_by_Zero__int_File_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_68a");
			(new CWE369_Divide_by_Zero__int_File_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_71a");
			(new CWE369_Divide_by_Zero__int_File_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_72a");
			(new CWE369_Divide_by_Zero__int_File_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_73a");
			(new CWE369_Divide_by_Zero__int_File_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_74a");
			(new CWE369_Divide_by_Zero__int_File_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_75a");
			(new CWE369_Divide_by_Zero__int_File_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_File_divide_81a");
			(new CWE369_Divide_by_Zero__int_File_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_01");
			(new CWE369_Divide_by_Zero__int_File_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_02");
			(new CWE369_Divide_by_Zero__int_File_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_03");
			(new CWE369_Divide_by_Zero__int_File_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_04");
			(new CWE369_Divide_by_Zero__int_File_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_05");
			(new CWE369_Divide_by_Zero__int_File_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_06");
			(new CWE369_Divide_by_Zero__int_File_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_07");
			(new CWE369_Divide_by_Zero__int_File_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_08");
			(new CWE369_Divide_by_Zero__int_File_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_09");
			(new CWE369_Divide_by_Zero__int_File_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_10");
			(new CWE369_Divide_by_Zero__int_File_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_11");
			(new CWE369_Divide_by_Zero__int_File_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_12");
			(new CWE369_Divide_by_Zero__int_File_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_13");
			(new CWE369_Divide_by_Zero__int_File_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_14");
			(new CWE369_Divide_by_Zero__int_File_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_15");
			(new CWE369_Divide_by_Zero__int_File_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_16");
			(new CWE369_Divide_by_Zero__int_File_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_17");
			(new CWE369_Divide_by_Zero__int_File_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_21");
			(new CWE369_Divide_by_Zero__int_File_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_22a");
			(new CWE369_Divide_by_Zero__int_File_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_31");
			(new CWE369_Divide_by_Zero__int_File_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_41");
			(new CWE369_Divide_by_Zero__int_File_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_42");
			(new CWE369_Divide_by_Zero__int_File_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_45");
			(new CWE369_Divide_by_Zero__int_File_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_51a");
			(new CWE369_Divide_by_Zero__int_File_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_52a");
			(new CWE369_Divide_by_Zero__int_File_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_53a");
			(new CWE369_Divide_by_Zero__int_File_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_54a");
			(new CWE369_Divide_by_Zero__int_File_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_61a");
			(new CWE369_Divide_by_Zero__int_File_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_66a");
			(new CWE369_Divide_by_Zero__int_File_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_67a");
			(new CWE369_Divide_by_Zero__int_File_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_68a");
			(new CWE369_Divide_by_Zero__int_File_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_71a");
			(new CWE369_Divide_by_Zero__int_File_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_72a");
			(new CWE369_Divide_by_Zero__int_File_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_73a");
			(new CWE369_Divide_by_Zero__int_File_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_74a");
			(new CWE369_Divide_by_Zero__int_File_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_75a");
			(new CWE369_Divide_by_Zero__int_File_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_File_modulo_81a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_01()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_01");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_02()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_02");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_03()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_03");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_04()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_04");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_05()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_05");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_06()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_06");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_07()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_07");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_08()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_08");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_09()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_09");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_10()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_10");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_11()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_11");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_12()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_12");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_13()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_13");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_14()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_14");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_15()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_15");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_16()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_16");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_17()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_17");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_21()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_21");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_22a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_31()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_31");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_41()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_41");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_42()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_42");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_45()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_45");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_51a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_52a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_53a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_54a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_61a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_66a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_67a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_68a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_71a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_72a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_73a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_74a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_75a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_divide_81a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_01");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_02");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_03");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_04");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_05");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_06");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_07");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_08");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_09");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_10");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_11");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_12");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_13");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_14");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_15");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_16");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_17");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_21");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_22a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_31");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_41");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_42");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_45");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_51a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_52a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_53a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_54a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_61a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_66a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_67a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_68a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_71a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_72a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_73a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_74a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_75a");
			(new CWE369_Divide_by_Zero__int_Listen_tcp_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_Listen_tcp_modulo_81a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_01()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_01");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_02()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_02");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_03()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_03");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_04()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_04");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_05()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_05");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_06()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_06");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_07()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_07");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_08()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_08");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_09()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_09");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_10()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_10");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_11()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_11");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_12()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_12");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_13()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_13");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_14()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_14");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_15()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_15");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_16()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_16");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_17()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_17");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_21()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_21");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_22a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_31()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_31");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_41()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_41");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_42()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_42");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_45()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_45");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_51a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_52a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_53a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_54a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_61a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_66a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_67a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_68a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_71a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_72a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_73a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_74a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_75a");
			(new CWE369_Divide_by_Zero__int_NetClient_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_divide_81a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_01");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_02");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_03");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_04");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_05");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_06");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_07");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_08");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_09");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_10");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_11");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_12");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_13");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_14");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_15");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_16");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_17");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_21");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_22a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_31");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_41");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_42");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_45");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_51a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_52a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_53a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_54a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_61a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_66a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_67a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_68a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_71a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_72a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_73a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_74a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_75a");
			(new CWE369_Divide_by_Zero__int_NetClient_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_NetClient_modulo_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}