using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE369_Divide_by_Zero
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */
			(new CWE369_Divide_by_Zero__int_Random_divide_01()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_01");
			(new CWE369_Divide_by_Zero__int_Random_divide_02()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_02");
			(new CWE369_Divide_by_Zero__int_Random_divide_03()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_03");
			(new CWE369_Divide_by_Zero__int_Random_divide_04()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_04");
			(new CWE369_Divide_by_Zero__int_Random_divide_05()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_05");
			(new CWE369_Divide_by_Zero__int_Random_divide_06()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_06");
			(new CWE369_Divide_by_Zero__int_Random_divide_07()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_07");
			(new CWE369_Divide_by_Zero__int_Random_divide_08()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_08");
			(new CWE369_Divide_by_Zero__int_Random_divide_09()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_09");
			(new CWE369_Divide_by_Zero__int_Random_divide_10()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_10");
			(new CWE369_Divide_by_Zero__int_Random_divide_11()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_11");
			(new CWE369_Divide_by_Zero__int_Random_divide_12()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_12");
			(new CWE369_Divide_by_Zero__int_Random_divide_13()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_13");
			(new CWE369_Divide_by_Zero__int_Random_divide_14()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_14");
			(new CWE369_Divide_by_Zero__int_Random_divide_15()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_15");
			(new CWE369_Divide_by_Zero__int_Random_divide_16()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_16");
			(new CWE369_Divide_by_Zero__int_Random_divide_17()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_17");
			(new CWE369_Divide_by_Zero__int_Random_divide_21()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_21");
			(new CWE369_Divide_by_Zero__int_Random_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_22a");
			(new CWE369_Divide_by_Zero__int_Random_divide_31()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_31");
			(new CWE369_Divide_by_Zero__int_Random_divide_41()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_41");
			(new CWE369_Divide_by_Zero__int_Random_divide_42()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_42");
			(new CWE369_Divide_by_Zero__int_Random_divide_45()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_45");
			(new CWE369_Divide_by_Zero__int_Random_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_51a");
			(new CWE369_Divide_by_Zero__int_Random_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_52a");
			(new CWE369_Divide_by_Zero__int_Random_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_53a");
			(new CWE369_Divide_by_Zero__int_Random_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_54a");
			(new CWE369_Divide_by_Zero__int_Random_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_61a");
			(new CWE369_Divide_by_Zero__int_Random_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_66a");
			(new CWE369_Divide_by_Zero__int_Random_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_67a");
			(new CWE369_Divide_by_Zero__int_Random_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_68a");
			(new CWE369_Divide_by_Zero__int_Random_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_71a");
			(new CWE369_Divide_by_Zero__int_Random_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_72a");
			(new CWE369_Divide_by_Zero__int_Random_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_73a");
			(new CWE369_Divide_by_Zero__int_Random_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_74a");
			(new CWE369_Divide_by_Zero__int_Random_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_75a");
			(new CWE369_Divide_by_Zero__int_Random_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_Random_divide_81a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_01");
			(new CWE369_Divide_by_Zero__int_Random_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_02");
			(new CWE369_Divide_by_Zero__int_Random_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_03");
			(new CWE369_Divide_by_Zero__int_Random_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_04");
			(new CWE369_Divide_by_Zero__int_Random_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_05");
			(new CWE369_Divide_by_Zero__int_Random_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_06");
			(new CWE369_Divide_by_Zero__int_Random_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_07");
			(new CWE369_Divide_by_Zero__int_Random_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_08");
			(new CWE369_Divide_by_Zero__int_Random_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_09");
			(new CWE369_Divide_by_Zero__int_Random_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_10");
			(new CWE369_Divide_by_Zero__int_Random_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_11");
			(new CWE369_Divide_by_Zero__int_Random_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_12");
			(new CWE369_Divide_by_Zero__int_Random_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_13");
			(new CWE369_Divide_by_Zero__int_Random_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_14");
			(new CWE369_Divide_by_Zero__int_Random_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_15");
			(new CWE369_Divide_by_Zero__int_Random_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_16");
			(new CWE369_Divide_by_Zero__int_Random_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_17");
			(new CWE369_Divide_by_Zero__int_Random_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_21");
			(new CWE369_Divide_by_Zero__int_Random_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_22a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_31");
			(new CWE369_Divide_by_Zero__int_Random_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_41");
			(new CWE369_Divide_by_Zero__int_Random_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_42");
			(new CWE369_Divide_by_Zero__int_Random_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_45");
			(new CWE369_Divide_by_Zero__int_Random_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_51a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_52a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_53a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_54a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_61a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_66a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_67a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_68a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_71a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_72a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_73a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_74a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_75a");
			(new CWE369_Divide_by_Zero__int_Random_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_Random_modulo_81a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_01()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_01");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_02()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_02");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_03()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_03");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_04()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_04");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_05()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_05");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_06()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_06");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_07()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_07");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_08()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_08");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_09()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_09");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_10()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_10");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_11()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_11");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_12()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_12");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_13()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_13");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_14()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_14");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_15()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_15");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_16()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_16");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_17()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_17");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_21()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_21");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_22a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_31()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_31");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_41()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_41");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_42()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_42");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_45()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_45");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_51a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_52a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_53a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_54a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_61a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_66a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_67a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_68a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_71a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_72a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_73a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_74a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_75a");
			(new CWE369_Divide_by_Zero__int_ReadLine_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_divide_81a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_01");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_02");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_03");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_04");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_05");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_06");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_07");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_08");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_09");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_10");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_11");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_12");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_13");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_14");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_15");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_16");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_17");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_21");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_22a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_31");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_41");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_42");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_45");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_51a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_52a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_53a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_54a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_61a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_66a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_67a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_68a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_71a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_72a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_73a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_74a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_75a");
			(new CWE369_Divide_by_Zero__int_ReadLine_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_ReadLine_modulo_81a");
			(new CWE369_Divide_by_Zero__int_zero_divide_01()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_01");
			(new CWE369_Divide_by_Zero__int_zero_divide_02()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_02");
			(new CWE369_Divide_by_Zero__int_zero_divide_03()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_03");
			(new CWE369_Divide_by_Zero__int_zero_divide_04()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_04");
			(new CWE369_Divide_by_Zero__int_zero_divide_05()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_05");
			(new CWE369_Divide_by_Zero__int_zero_divide_06()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_06");
			(new CWE369_Divide_by_Zero__int_zero_divide_07()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_07");
			(new CWE369_Divide_by_Zero__int_zero_divide_08()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_08");
			(new CWE369_Divide_by_Zero__int_zero_divide_09()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_09");
			(new CWE369_Divide_by_Zero__int_zero_divide_10()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_10");
			(new CWE369_Divide_by_Zero__int_zero_divide_11()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_11");
			(new CWE369_Divide_by_Zero__int_zero_divide_12()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_12");
			(new CWE369_Divide_by_Zero__int_zero_divide_13()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_13");
			(new CWE369_Divide_by_Zero__int_zero_divide_14()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_14");
			(new CWE369_Divide_by_Zero__int_zero_divide_15()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_15");
			(new CWE369_Divide_by_Zero__int_zero_divide_16()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_16");
			(new CWE369_Divide_by_Zero__int_zero_divide_17()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_17");
			(new CWE369_Divide_by_Zero__int_zero_divide_21()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_21");
			(new CWE369_Divide_by_Zero__int_zero_divide_22a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_22a");
			(new CWE369_Divide_by_Zero__int_zero_divide_31()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_31");
			(new CWE369_Divide_by_Zero__int_zero_divide_41()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_41");
			(new CWE369_Divide_by_Zero__int_zero_divide_42()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_42");
			(new CWE369_Divide_by_Zero__int_zero_divide_45()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_45");
			(new CWE369_Divide_by_Zero__int_zero_divide_51a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_51a");
			(new CWE369_Divide_by_Zero__int_zero_divide_52a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_52a");
			(new CWE369_Divide_by_Zero__int_zero_divide_53a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_53a");
			(new CWE369_Divide_by_Zero__int_zero_divide_54a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_54a");
			(new CWE369_Divide_by_Zero__int_zero_divide_61a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_61a");
			(new CWE369_Divide_by_Zero__int_zero_divide_66a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_66a");
			(new CWE369_Divide_by_Zero__int_zero_divide_67a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_67a");
			(new CWE369_Divide_by_Zero__int_zero_divide_68a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_68a");
			(new CWE369_Divide_by_Zero__int_zero_divide_71a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_71a");
			(new CWE369_Divide_by_Zero__int_zero_divide_72a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_72a");
			(new CWE369_Divide_by_Zero__int_zero_divide_73a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_73a");
			(new CWE369_Divide_by_Zero__int_zero_divide_74a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_74a");
			(new CWE369_Divide_by_Zero__int_zero_divide_75a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_75a");
			(new CWE369_Divide_by_Zero__int_zero_divide_81a()).RunTest("CWE369_Divide_by_Zero__int_zero_divide_81a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_01()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_01");
			(new CWE369_Divide_by_Zero__int_zero_modulo_02()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_02");
			(new CWE369_Divide_by_Zero__int_zero_modulo_03()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_03");
			(new CWE369_Divide_by_Zero__int_zero_modulo_04()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_04");
			(new CWE369_Divide_by_Zero__int_zero_modulo_05()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_05");
			(new CWE369_Divide_by_Zero__int_zero_modulo_06()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_06");
			(new CWE369_Divide_by_Zero__int_zero_modulo_07()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_07");
			(new CWE369_Divide_by_Zero__int_zero_modulo_08()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_08");
			(new CWE369_Divide_by_Zero__int_zero_modulo_09()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_09");
			(new CWE369_Divide_by_Zero__int_zero_modulo_10()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_10");
			(new CWE369_Divide_by_Zero__int_zero_modulo_11()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_11");
			(new CWE369_Divide_by_Zero__int_zero_modulo_12()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_12");
			(new CWE369_Divide_by_Zero__int_zero_modulo_13()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_13");
			(new CWE369_Divide_by_Zero__int_zero_modulo_14()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_14");
			(new CWE369_Divide_by_Zero__int_zero_modulo_15()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_15");
			(new CWE369_Divide_by_Zero__int_zero_modulo_16()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_16");
			(new CWE369_Divide_by_Zero__int_zero_modulo_17()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_17");
			(new CWE369_Divide_by_Zero__int_zero_modulo_21()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_21");
			(new CWE369_Divide_by_Zero__int_zero_modulo_22a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_22a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_31()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_31");
			(new CWE369_Divide_by_Zero__int_zero_modulo_41()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_41");
			(new CWE369_Divide_by_Zero__int_zero_modulo_42()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_42");
			(new CWE369_Divide_by_Zero__int_zero_modulo_45()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_45");
			(new CWE369_Divide_by_Zero__int_zero_modulo_51a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_51a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_52a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_52a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_53a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_53a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_54a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_54a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_61a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_61a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_66a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_66a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_67a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_67a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_68a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_68a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_71a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_71a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_72a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_72a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_73a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_73a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_74a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_74a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_75a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_75a");
			(new CWE369_Divide_by_Zero__int_zero_modulo_81a()).RunTest("CWE369_Divide_by_Zero__int_zero_modulo_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}