using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE400_Uncontrolled_Resource_Consumption
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Connect_tcp_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Database_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Database_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Environment_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Environment_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__File_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__File_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Listen_tcp_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__max_value_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__max_value_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__NetClient_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__NetClient_write_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}