using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE400_Uncontrolled_Resource_Consumption
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__Random_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__Random_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_01");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_02");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_03");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_04");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_05");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_06");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_07");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_08");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_09");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_10");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_11");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_12");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_13");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_14");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_15");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_16");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_17");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_21");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_31");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_41");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_42");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_45");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_for_loop_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_01");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_02");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_03");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_04");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_05");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_06");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_07");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_08");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_09");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_10");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_11");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_12");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_13");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_14");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_15");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_16");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_17");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_21");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_31");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_41");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_42");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_45");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__ReadLine_write_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Connect_tcp_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Database_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Database_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Environment_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_File_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_File_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Listen_tcp_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_max_value_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_NetClient_81a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_01()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_01");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_02()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_02");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_03()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_03");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_04()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_04");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_05()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_05");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_06()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_06");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_07()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_07");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_08()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_08");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_09()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_09");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_10()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_10");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_11()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_11");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_12()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_12");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_13()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_13");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_14()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_14");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_15()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_15");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_16()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_16");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_17()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_17");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_21()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_21");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_22a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_22a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_31()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_31");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_41()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_41");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_42()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_42");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_45()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_45");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_51a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_51a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_52a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_52a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_53a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_53a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_54a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_54a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_61a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_61a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_66a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_66a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_67a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_67a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_68a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_68a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_71a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_71a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_72a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_72a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_73a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_73a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_74a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_74a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_75a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_75a");
			(new CWE400_Uncontrolled_Resource_Consumption__sleep_Random_81a()).RunTest("CWE400_Uncontrolled_Resource_Consumption__sleep_Random_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}