using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE476_NULL_Pointer_Dereference
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */
			(new CWE476_NULL_Pointer_Dereference__binary_if_01()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_01");
			(new CWE476_NULL_Pointer_Dereference__binary_if_02()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_02");
			(new CWE476_NULL_Pointer_Dereference__binary_if_03()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_03");
			(new CWE476_NULL_Pointer_Dereference__binary_if_04()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_04");
			(new CWE476_NULL_Pointer_Dereference__binary_if_05()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_05");
			(new CWE476_NULL_Pointer_Dereference__binary_if_06()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_06");
			(new CWE476_NULL_Pointer_Dereference__binary_if_07()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_07");
			(new CWE476_NULL_Pointer_Dereference__binary_if_08()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_08");
			(new CWE476_NULL_Pointer_Dereference__binary_if_09()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_09");
			(new CWE476_NULL_Pointer_Dereference__binary_if_10()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_10");
			(new CWE476_NULL_Pointer_Dereference__binary_if_11()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_11");
			(new CWE476_NULL_Pointer_Dereference__binary_if_12()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_12");
			(new CWE476_NULL_Pointer_Dereference__binary_if_13()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_13");
			(new CWE476_NULL_Pointer_Dereference__binary_if_14()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_14");
			(new CWE476_NULL_Pointer_Dereference__binary_if_15()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_15");
			(new CWE476_NULL_Pointer_Dereference__binary_if_16()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_16");
			(new CWE476_NULL_Pointer_Dereference__binary_if_17()).RunTest("CWE476_NULL_Pointer_Dereference__binary_if_17");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_01()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_01");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_02()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_02");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_03()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_03");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_04()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_04");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_05()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_05");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_06()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_06");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_07()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_07");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_08()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_08");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_09()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_09");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_10()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_10");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_11()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_11");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_12()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_12");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_13()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_13");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_14()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_14");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_15()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_15");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_16()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_16");
			(new CWE476_NULL_Pointer_Dereference__deref_after_check_17()).RunTest("CWE476_NULL_Pointer_Dereference__deref_after_check_17");
			(new CWE476_NULL_Pointer_Dereference__Integer_01()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_01");
			(new CWE476_NULL_Pointer_Dereference__Integer_02()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_02");
			(new CWE476_NULL_Pointer_Dereference__Integer_03()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_03");
			(new CWE476_NULL_Pointer_Dereference__Integer_04()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_04");
			(new CWE476_NULL_Pointer_Dereference__Integer_05()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_05");
			(new CWE476_NULL_Pointer_Dereference__Integer_06()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_06");
			(new CWE476_NULL_Pointer_Dereference__Integer_07()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_07");
			(new CWE476_NULL_Pointer_Dereference__Integer_08()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_08");
			(new CWE476_NULL_Pointer_Dereference__Integer_09()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_09");
			(new CWE476_NULL_Pointer_Dereference__Integer_10()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_10");
			(new CWE476_NULL_Pointer_Dereference__Integer_11()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_11");
			(new CWE476_NULL_Pointer_Dereference__Integer_12()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_12");
			(new CWE476_NULL_Pointer_Dereference__Integer_13()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_13");
			(new CWE476_NULL_Pointer_Dereference__Integer_14()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_14");
			(new CWE476_NULL_Pointer_Dereference__Integer_15()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_15");
			(new CWE476_NULL_Pointer_Dereference__Integer_16()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_16");
			(new CWE476_NULL_Pointer_Dereference__Integer_17()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_17");
			(new CWE476_NULL_Pointer_Dereference__Integer_21()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_21");
			(new CWE476_NULL_Pointer_Dereference__Integer_22a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_22a");
			(new CWE476_NULL_Pointer_Dereference__Integer_31()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_31");
			(new CWE476_NULL_Pointer_Dereference__Integer_41()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_41");
			(new CWE476_NULL_Pointer_Dereference__Integer_42()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_42");
			(new CWE476_NULL_Pointer_Dereference__Integer_45()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_45");
			(new CWE476_NULL_Pointer_Dereference__Integer_51a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_51a");
			(new CWE476_NULL_Pointer_Dereference__Integer_52a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_52a");
			(new CWE476_NULL_Pointer_Dereference__Integer_53a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_53a");
			(new CWE476_NULL_Pointer_Dereference__Integer_54a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_54a");
			(new CWE476_NULL_Pointer_Dereference__Integer_61a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_61a");
			(new CWE476_NULL_Pointer_Dereference__Integer_66a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_66a");
			(new CWE476_NULL_Pointer_Dereference__Integer_67a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_67a");
			(new CWE476_NULL_Pointer_Dereference__Integer_68a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_68a");
			(new CWE476_NULL_Pointer_Dereference__Integer_71a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_71a");
			(new CWE476_NULL_Pointer_Dereference__Integer_72a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_72a");
			(new CWE476_NULL_Pointer_Dereference__Integer_73a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_73a");
			(new CWE476_NULL_Pointer_Dereference__Integer_74a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_74a");
			(new CWE476_NULL_Pointer_Dereference__Integer_75a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_75a");
			(new CWE476_NULL_Pointer_Dereference__Integer_81a()).RunTest("CWE476_NULL_Pointer_Dereference__Integer_81a");
			(new CWE476_NULL_Pointer_Dereference__int_array_01()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_01");
			(new CWE476_NULL_Pointer_Dereference__int_array_02()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_02");
			(new CWE476_NULL_Pointer_Dereference__int_array_03()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_03");
			(new CWE476_NULL_Pointer_Dereference__int_array_04()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_04");
			(new CWE476_NULL_Pointer_Dereference__int_array_05()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_05");
			(new CWE476_NULL_Pointer_Dereference__int_array_06()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_06");
			(new CWE476_NULL_Pointer_Dereference__int_array_07()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_07");
			(new CWE476_NULL_Pointer_Dereference__int_array_08()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_08");
			(new CWE476_NULL_Pointer_Dereference__int_array_09()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_09");
			(new CWE476_NULL_Pointer_Dereference__int_array_10()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_10");
			(new CWE476_NULL_Pointer_Dereference__int_array_11()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_11");
			(new CWE476_NULL_Pointer_Dereference__int_array_12()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_12");
			(new CWE476_NULL_Pointer_Dereference__int_array_13()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_13");
			(new CWE476_NULL_Pointer_Dereference__int_array_14()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_14");
			(new CWE476_NULL_Pointer_Dereference__int_array_15()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_15");
			(new CWE476_NULL_Pointer_Dereference__int_array_16()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_16");
			(new CWE476_NULL_Pointer_Dereference__int_array_17()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_17");
			(new CWE476_NULL_Pointer_Dereference__int_array_21()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_21");
			(new CWE476_NULL_Pointer_Dereference__int_array_22a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_22a");
			(new CWE476_NULL_Pointer_Dereference__int_array_31()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_31");
			(new CWE476_NULL_Pointer_Dereference__int_array_41()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_41");
			(new CWE476_NULL_Pointer_Dereference__int_array_42()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_42");
			(new CWE476_NULL_Pointer_Dereference__int_array_45()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_45");
			(new CWE476_NULL_Pointer_Dereference__int_array_51a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_51a");
			(new CWE476_NULL_Pointer_Dereference__int_array_52a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_52a");
			(new CWE476_NULL_Pointer_Dereference__int_array_53a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_53a");
			(new CWE476_NULL_Pointer_Dereference__int_array_54a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_54a");
			(new CWE476_NULL_Pointer_Dereference__int_array_61a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_61a");
			(new CWE476_NULL_Pointer_Dereference__int_array_67a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_67a");
			(new CWE476_NULL_Pointer_Dereference__int_array_68a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_68a");
			(new CWE476_NULL_Pointer_Dereference__int_array_71a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_71a");
			(new CWE476_NULL_Pointer_Dereference__int_array_72a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_72a");
			(new CWE476_NULL_Pointer_Dereference__int_array_73a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_73a");
			(new CWE476_NULL_Pointer_Dereference__int_array_74a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_74a");
			(new CWE476_NULL_Pointer_Dereference__int_array_75a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_75a");
			(new CWE476_NULL_Pointer_Dereference__int_array_81a()).RunTest("CWE476_NULL_Pointer_Dereference__int_array_81a");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_01()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_01");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_02()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_02");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_03()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_03");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_04()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_04");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_05()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_05");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_06()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_06");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_07()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_07");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_08()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_08");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_09()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_09");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_10()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_10");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_11()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_11");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_12()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_12");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_13()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_13");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_14()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_14");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_15()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_15");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_16()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_16");
			(new CWE476_NULL_Pointer_Dereference__null_check_after_deref_17()).RunTest("CWE476_NULL_Pointer_Dereference__null_check_after_deref_17");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_01()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_01");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_02()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_02");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_03()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_03");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_04()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_04");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_05()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_05");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_06()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_06");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_07()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_07");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_08()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_08");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_09()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_09");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_10()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_10");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_11()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_11");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_12()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_12");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_13()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_13");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_14()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_14");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_15()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_15");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_16()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_16");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_17()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_17");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_21()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_21");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_22a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_22a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_31()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_31");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_41()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_41");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_42()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_42");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_45()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_45");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_51a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_51a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_52a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_52a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_53a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_53a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_54a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_54a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_61a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_61a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_66a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_66a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_67a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_67a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_68a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_68a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_71a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_71a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_72a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_72a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_73a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_73a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_74a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_74a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_75a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_75a");
			(new CWE476_NULL_Pointer_Dereference__StringBuilder_81a()).RunTest("CWE476_NULL_Pointer_Dereference__StringBuilder_81a");
			(new CWE476_NULL_Pointer_Dereference__String_01()).RunTest("CWE476_NULL_Pointer_Dereference__String_01");
			(new CWE476_NULL_Pointer_Dereference__String_02()).RunTest("CWE476_NULL_Pointer_Dereference__String_02");
			(new CWE476_NULL_Pointer_Dereference__String_03()).RunTest("CWE476_NULL_Pointer_Dereference__String_03");
			(new CWE476_NULL_Pointer_Dereference__String_04()).RunTest("CWE476_NULL_Pointer_Dereference__String_04");
			(new CWE476_NULL_Pointer_Dereference__String_05()).RunTest("CWE476_NULL_Pointer_Dereference__String_05");
			(new CWE476_NULL_Pointer_Dereference__String_06()).RunTest("CWE476_NULL_Pointer_Dereference__String_06");
			(new CWE476_NULL_Pointer_Dereference__String_07()).RunTest("CWE476_NULL_Pointer_Dereference__String_07");
			(new CWE476_NULL_Pointer_Dereference__String_08()).RunTest("CWE476_NULL_Pointer_Dereference__String_08");
			(new CWE476_NULL_Pointer_Dereference__String_09()).RunTest("CWE476_NULL_Pointer_Dereference__String_09");
			(new CWE476_NULL_Pointer_Dereference__String_10()).RunTest("CWE476_NULL_Pointer_Dereference__String_10");
			(new CWE476_NULL_Pointer_Dereference__String_11()).RunTest("CWE476_NULL_Pointer_Dereference__String_11");
			(new CWE476_NULL_Pointer_Dereference__String_12()).RunTest("CWE476_NULL_Pointer_Dereference__String_12");
			(new CWE476_NULL_Pointer_Dereference__String_13()).RunTest("CWE476_NULL_Pointer_Dereference__String_13");
			(new CWE476_NULL_Pointer_Dereference__String_14()).RunTest("CWE476_NULL_Pointer_Dereference__String_14");
			(new CWE476_NULL_Pointer_Dereference__String_15()).RunTest("CWE476_NULL_Pointer_Dereference__String_15");
			(new CWE476_NULL_Pointer_Dereference__String_16()).RunTest("CWE476_NULL_Pointer_Dereference__String_16");
			(new CWE476_NULL_Pointer_Dereference__String_17()).RunTest("CWE476_NULL_Pointer_Dereference__String_17");
			(new CWE476_NULL_Pointer_Dereference__String_21()).RunTest("CWE476_NULL_Pointer_Dereference__String_21");
			(new CWE476_NULL_Pointer_Dereference__String_22a()).RunTest("CWE476_NULL_Pointer_Dereference__String_22a");
			(new CWE476_NULL_Pointer_Dereference__String_31()).RunTest("CWE476_NULL_Pointer_Dereference__String_31");
			(new CWE476_NULL_Pointer_Dereference__String_41()).RunTest("CWE476_NULL_Pointer_Dereference__String_41");
			(new CWE476_NULL_Pointer_Dereference__String_42()).RunTest("CWE476_NULL_Pointer_Dereference__String_42");
			(new CWE476_NULL_Pointer_Dereference__String_45()).RunTest("CWE476_NULL_Pointer_Dereference__String_45");
			(new CWE476_NULL_Pointer_Dereference__String_51a()).RunTest("CWE476_NULL_Pointer_Dereference__String_51a");
			(new CWE476_NULL_Pointer_Dereference__String_52a()).RunTest("CWE476_NULL_Pointer_Dereference__String_52a");
			(new CWE476_NULL_Pointer_Dereference__String_53a()).RunTest("CWE476_NULL_Pointer_Dereference__String_53a");
			(new CWE476_NULL_Pointer_Dereference__String_54a()).RunTest("CWE476_NULL_Pointer_Dereference__String_54a");
			(new CWE476_NULL_Pointer_Dereference__String_61a()).RunTest("CWE476_NULL_Pointer_Dereference__String_61a");
			(new CWE476_NULL_Pointer_Dereference__String_66a()).RunTest("CWE476_NULL_Pointer_Dereference__String_66a");
			(new CWE476_NULL_Pointer_Dereference__String_67a()).RunTest("CWE476_NULL_Pointer_Dereference__String_67a");
			(new CWE476_NULL_Pointer_Dereference__String_68a()).RunTest("CWE476_NULL_Pointer_Dereference__String_68a");
			(new CWE476_NULL_Pointer_Dereference__String_71a()).RunTest("CWE476_NULL_Pointer_Dereference__String_71a");
			(new CWE476_NULL_Pointer_Dereference__String_72a()).RunTest("CWE476_NULL_Pointer_Dereference__String_72a");
			(new CWE476_NULL_Pointer_Dereference__String_73a()).RunTest("CWE476_NULL_Pointer_Dereference__String_73a");
			(new CWE476_NULL_Pointer_Dereference__String_74a()).RunTest("CWE476_NULL_Pointer_Dereference__String_74a");
			(new CWE476_NULL_Pointer_Dereference__String_75a()).RunTest("CWE476_NULL_Pointer_Dereference__String_75a");
			(new CWE476_NULL_Pointer_Dereference__String_81a()).RunTest("CWE476_NULL_Pointer_Dereference__String_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}