using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE477_Obsolete_Functions
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_01()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_01");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_02()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_02");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_03()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_03");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_04()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_04");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_05()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_05");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_06()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_06");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_07()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_07");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_08()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_08");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_09()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_09");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_10()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_10");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_11()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_11");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_12()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_12");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_13()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_13");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_14()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_14");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_15()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_15");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_16()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_16");
			(new CWE477_Obsolete_Functions__Dns_GetHostByAddress_17()).RunTest("CWE477_Obsolete_Functions__Dns_GetHostByAddress_17");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_01()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_01");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_02()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_02");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_03()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_03");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_04()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_04");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_05()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_05");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_06()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_06");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_07()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_07");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_08()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_08");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_09()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_09");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_10()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_10");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_11()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_11");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_12()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_12");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_13()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_13");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_14()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_14");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_15()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_15");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_16()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_16");
			(new CWE477_Obsolete_Functions__Process_VirtualMemorySize_17()).RunTest("CWE477_Obsolete_Functions__Process_VirtualMemorySize_17");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_01()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_01");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_02()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_02");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_03()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_03");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_04()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_04");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_05()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_05");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_06()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_06");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_07()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_07");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_08()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_08");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_09()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_09");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_10()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_10");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_11()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_11");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_12()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_12");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_13()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_13");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_14()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_14");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_15()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_15");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_16()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_16");
			(new CWE477_Obsolete_Functions__Socket_TcpListener_17()).RunTest("CWE477_Obsolete_Functions__Socket_TcpListener_17");
			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}