using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE506_Embedded_Malicious_Code
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_01()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_01");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_02()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_02");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_03()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_03");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_04()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_04");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_05()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_05");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_06()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_06");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_07()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_07");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_08()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_08");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_09()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_09");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_10()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_10");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_11()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_11");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_12()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_12");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_13()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_13");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_14()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_14");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_15()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_15");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_16()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_16");
			(new CWE506_Embedded_Malicious_Code__base64_encoded_payload_17()).RunTest("CWE506_Embedded_Malicious_Code__base64_encoded_payload_17");
			(new CWE506_Embedded_Malicious_Code__file_properties_01()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_01");
			(new CWE506_Embedded_Malicious_Code__file_properties_02()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_02");
			(new CWE506_Embedded_Malicious_Code__file_properties_03()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_03");
			(new CWE506_Embedded_Malicious_Code__file_properties_04()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_04");
			(new CWE506_Embedded_Malicious_Code__file_properties_05()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_05");
			(new CWE506_Embedded_Malicious_Code__file_properties_06()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_06");
			(new CWE506_Embedded_Malicious_Code__file_properties_07()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_07");
			(new CWE506_Embedded_Malicious_Code__file_properties_08()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_08");
			(new CWE506_Embedded_Malicious_Code__file_properties_09()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_09");
			(new CWE506_Embedded_Malicious_Code__file_properties_10()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_10");
			(new CWE506_Embedded_Malicious_Code__file_properties_11()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_11");
			(new CWE506_Embedded_Malicious_Code__file_properties_12()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_12");
			(new CWE506_Embedded_Malicious_Code__file_properties_13()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_13");
			(new CWE506_Embedded_Malicious_Code__file_properties_14()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_14");
			(new CWE506_Embedded_Malicious_Code__file_properties_15()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_15");
			(new CWE506_Embedded_Malicious_Code__file_properties_16()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_16");
			(new CWE506_Embedded_Malicious_Code__file_properties_17()).RunTest("CWE506_Embedded_Malicious_Code__file_properties_17");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_01()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_01");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_02()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_02");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_03()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_03");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_04()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_04");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_05()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_05");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_06()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_06");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_07()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_07");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_08()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_08");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_09()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_09");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_10()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_10");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_11()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_11");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_13()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_13");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_14()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_14");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_15()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_15");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_16()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_16");
			(new CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_17()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_connect_tcp_17");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_01()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_01");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_02()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_02");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_03()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_03");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_04()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_04");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_05()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_05");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_06()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_06");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_07()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_07");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_08()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_08");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_09()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_09");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_10()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_10");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_11()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_11");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_13()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_13");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_14()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_14");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_15()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_15");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_16()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_16");
			(new CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_17()).RunTest("CWE506_Embedded_Malicious_Code__file_transfer_listen_tcp_17");
			(new CWE506_Embedded_Malicious_Code__reflection_01()).RunTest("CWE506_Embedded_Malicious_Code__reflection_01");
			(new CWE506_Embedded_Malicious_Code__screen_capture_01()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_01");
			(new CWE506_Embedded_Malicious_Code__screen_capture_02()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_02");
			(new CWE506_Embedded_Malicious_Code__screen_capture_03()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_03");
			(new CWE506_Embedded_Malicious_Code__screen_capture_04()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_04");
			(new CWE506_Embedded_Malicious_Code__screen_capture_05()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_05");
			(new CWE506_Embedded_Malicious_Code__screen_capture_06()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_06");
			(new CWE506_Embedded_Malicious_Code__screen_capture_07()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_07");
			(new CWE506_Embedded_Malicious_Code__screen_capture_08()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_08");
			(new CWE506_Embedded_Malicious_Code__screen_capture_09()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_09");
			(new CWE506_Embedded_Malicious_Code__screen_capture_10()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_10");
			(new CWE506_Embedded_Malicious_Code__screen_capture_11()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_11");
			(new CWE506_Embedded_Malicious_Code__screen_capture_13()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_13");
			(new CWE506_Embedded_Malicious_Code__screen_capture_14()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_14");
			(new CWE506_Embedded_Malicious_Code__screen_capture_15()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_15");
			(new CWE506_Embedded_Malicious_Code__screen_capture_16()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_16");
			(new CWE506_Embedded_Malicious_Code__screen_capture_17()).RunTest("CWE506_Embedded_Malicious_Code__screen_capture_17");
			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}