using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE511_Logic_Time_Bomb
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */
			(new CWE511_Logic_Time_Bomb__counter_01()).RunTest("CWE511_Logic_Time_Bomb__counter_01");
			(new CWE511_Logic_Time_Bomb__counter_02()).RunTest("CWE511_Logic_Time_Bomb__counter_02");
			(new CWE511_Logic_Time_Bomb__counter_03()).RunTest("CWE511_Logic_Time_Bomb__counter_03");
			(new CWE511_Logic_Time_Bomb__counter_04()).RunTest("CWE511_Logic_Time_Bomb__counter_04");
			(new CWE511_Logic_Time_Bomb__counter_05()).RunTest("CWE511_Logic_Time_Bomb__counter_05");
			(new CWE511_Logic_Time_Bomb__counter_06()).RunTest("CWE511_Logic_Time_Bomb__counter_06");
			(new CWE511_Logic_Time_Bomb__counter_07()).RunTest("CWE511_Logic_Time_Bomb__counter_07");
			(new CWE511_Logic_Time_Bomb__counter_08()).RunTest("CWE511_Logic_Time_Bomb__counter_08");
			(new CWE511_Logic_Time_Bomb__counter_09()).RunTest("CWE511_Logic_Time_Bomb__counter_09");
			(new CWE511_Logic_Time_Bomb__counter_10()).RunTest("CWE511_Logic_Time_Bomb__counter_10");
			(new CWE511_Logic_Time_Bomb__counter_11()).RunTest("CWE511_Logic_Time_Bomb__counter_11");
			(new CWE511_Logic_Time_Bomb__counter_12()).RunTest("CWE511_Logic_Time_Bomb__counter_12");
			(new CWE511_Logic_Time_Bomb__counter_13()).RunTest("CWE511_Logic_Time_Bomb__counter_13");
			(new CWE511_Logic_Time_Bomb__counter_14()).RunTest("CWE511_Logic_Time_Bomb__counter_14");
			(new CWE511_Logic_Time_Bomb__counter_15()).RunTest("CWE511_Logic_Time_Bomb__counter_15");
			(new CWE511_Logic_Time_Bomb__counter_16()).RunTest("CWE511_Logic_Time_Bomb__counter_16");
			(new CWE511_Logic_Time_Bomb__counter_17()).RunTest("CWE511_Logic_Time_Bomb__counter_17");
			(new CWE511_Logic_Time_Bomb__rand_01()).RunTest("CWE511_Logic_Time_Bomb__rand_01");
			(new CWE511_Logic_Time_Bomb__rand_02()).RunTest("CWE511_Logic_Time_Bomb__rand_02");
			(new CWE511_Logic_Time_Bomb__rand_03()).RunTest("CWE511_Logic_Time_Bomb__rand_03");
			(new CWE511_Logic_Time_Bomb__rand_04()).RunTest("CWE511_Logic_Time_Bomb__rand_04");
			(new CWE511_Logic_Time_Bomb__rand_05()).RunTest("CWE511_Logic_Time_Bomb__rand_05");
			(new CWE511_Logic_Time_Bomb__rand_06()).RunTest("CWE511_Logic_Time_Bomb__rand_06");
			(new CWE511_Logic_Time_Bomb__rand_07()).RunTest("CWE511_Logic_Time_Bomb__rand_07");
			(new CWE511_Logic_Time_Bomb__rand_08()).RunTest("CWE511_Logic_Time_Bomb__rand_08");
			(new CWE511_Logic_Time_Bomb__rand_09()).RunTest("CWE511_Logic_Time_Bomb__rand_09");
			(new CWE511_Logic_Time_Bomb__rand_10()).RunTest("CWE511_Logic_Time_Bomb__rand_10");
			(new CWE511_Logic_Time_Bomb__rand_11()).RunTest("CWE511_Logic_Time_Bomb__rand_11");
			(new CWE511_Logic_Time_Bomb__rand_12()).RunTest("CWE511_Logic_Time_Bomb__rand_12");
			(new CWE511_Logic_Time_Bomb__rand_13()).RunTest("CWE511_Logic_Time_Bomb__rand_13");
			(new CWE511_Logic_Time_Bomb__rand_14()).RunTest("CWE511_Logic_Time_Bomb__rand_14");
			(new CWE511_Logic_Time_Bomb__rand_15()).RunTest("CWE511_Logic_Time_Bomb__rand_15");
			(new CWE511_Logic_Time_Bomb__rand_16()).RunTest("CWE511_Logic_Time_Bomb__rand_16");
			(new CWE511_Logic_Time_Bomb__rand_17()).RunTest("CWE511_Logic_Time_Bomb__rand_17");
			(new CWE511_Logic_Time_Bomb__time_01()).RunTest("CWE511_Logic_Time_Bomb__time_01");
			(new CWE511_Logic_Time_Bomb__time_02()).RunTest("CWE511_Logic_Time_Bomb__time_02");
			(new CWE511_Logic_Time_Bomb__time_03()).RunTest("CWE511_Logic_Time_Bomb__time_03");
			(new CWE511_Logic_Time_Bomb__time_04()).RunTest("CWE511_Logic_Time_Bomb__time_04");
			(new CWE511_Logic_Time_Bomb__time_05()).RunTest("CWE511_Logic_Time_Bomb__time_05");
			(new CWE511_Logic_Time_Bomb__time_06()).RunTest("CWE511_Logic_Time_Bomb__time_06");
			(new CWE511_Logic_Time_Bomb__time_07()).RunTest("CWE511_Logic_Time_Bomb__time_07");
			(new CWE511_Logic_Time_Bomb__time_08()).RunTest("CWE511_Logic_Time_Bomb__time_08");
			(new CWE511_Logic_Time_Bomb__time_09()).RunTest("CWE511_Logic_Time_Bomb__time_09");
			(new CWE511_Logic_Time_Bomb__time_10()).RunTest("CWE511_Logic_Time_Bomb__time_10");
			(new CWE511_Logic_Time_Bomb__time_11()).RunTest("CWE511_Logic_Time_Bomb__time_11");
			(new CWE511_Logic_Time_Bomb__time_12()).RunTest("CWE511_Logic_Time_Bomb__time_12");
			(new CWE511_Logic_Time_Bomb__time_13()).RunTest("CWE511_Logic_Time_Bomb__time_13");
			(new CWE511_Logic_Time_Bomb__time_14()).RunTest("CWE511_Logic_Time_Bomb__time_14");
			(new CWE511_Logic_Time_Bomb__time_15()).RunTest("CWE511_Logic_Time_Bomb__time_15");
			(new CWE511_Logic_Time_Bomb__time_16()).RunTest("CWE511_Logic_Time_Bomb__time_16");
			(new CWE511_Logic_Time_Bomb__time_17()).RunTest("CWE511_Logic_Time_Bomb__time_17");
			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}