using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE563_Assign_to_Variable_Without_Use
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_int_81a");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_long_81a");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_StringBuilder_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_init_variable_string_81a");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_int_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_long_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_StringBuilder_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_uninit_variable_string_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_int_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_int_81a");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_long_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_long_81a");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_StringBuilder_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_01()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_01");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_02()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_02");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_03()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_03");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_04()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_04");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_05()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_05");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_06()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_06");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_07()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_07");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_08()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_08");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_09()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_09");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_10()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_10");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_11()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_11");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_12()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_12");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_13()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_13");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_14()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_14");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_15()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_15");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_16()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_16");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_17()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_17");
			(new CWE563_Assign_to_Variable_Without_Use__unused_value_string_81a()).RunTest("CWE563_Assign_to_Variable_Without_Use__unused_value_string_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}