using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE675_Duplicate_Operations_on_Resource
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_01()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_01");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_02()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_02");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_03()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_03");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_04()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_04");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_05()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_05");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_06()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_06");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_07()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_07");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_08()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_08");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_09()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_09");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_10()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_10");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_11()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_11");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_12()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_12");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_13()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_13");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_14()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_14");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_15()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_15");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_16()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_16");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_17()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_17");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_21()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_21");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_22a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_22a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_31()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_31");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_41()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_41");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_42()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_42");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_45()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_45");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_51a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_51a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_52a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_52a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_53a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_53a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_54a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_54a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_61a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_61a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_66a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_66a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_67a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_67a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_68a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_68a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_71a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_71a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_72a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_72a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_73a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_73a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_74a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_74a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_75a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_75a");
			(new CWE675_Duplicate_Operations_on_Resource__OpenText_81a()).RunTest("CWE675_Duplicate_Operations_on_Resource__OpenText_81a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_01()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_01");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_02()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_02");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_03()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_03");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_04()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_04");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_05()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_05");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_06()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_06");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_07()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_07");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_08()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_08");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_09()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_09");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_10()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_10");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_11()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_11");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_12()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_12");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_13()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_13");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_14()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_14");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_15()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_15");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_16()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_16");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_17()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_17");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_21()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_21");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_22a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_22a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_31()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_31");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_41()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_41");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_42()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_42");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_45()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_45");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_51a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_51a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_52a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_52a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_53a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_53a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_54a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_54a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_61a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_61a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_66a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_66a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_67a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_67a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_68a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_68a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_71a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_71a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_72a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_72a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_73a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_73a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_74a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_74a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_75a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_75a");
			(new CWE675_Duplicate_Operations_on_Resource__StreamReader_81a()).RunTest("CWE675_Duplicate_Operations_on_Resource__StreamReader_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}