using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE681_Incorrect_Conversion_Between_Numeric_Types
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_01()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_01");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_02()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_02");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_03()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_03");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_04()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_04");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_05()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_05");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_06()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_06");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_07()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_07");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_08()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_08");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_09()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_09");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_10()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_10");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_11()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_11");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_12()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_12");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_13()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_13");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_14()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_14");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_15()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_15");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_16()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_16");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_17()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__double2float_17");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_01()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_01");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_02()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_02");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_03()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_03");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_04()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_04");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_05()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_05");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_06()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_06");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_07()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_07");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_08()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_08");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_09()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_09");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_10()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_10");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_11()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_11");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_12()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_12");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_13()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_13");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_14()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_14");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_15()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_15");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_16()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_16");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_17()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__float2int_17");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_01()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_01");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_02()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_02");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_03()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_03");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_04()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_04");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_05()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_05");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_06()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_06");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_07()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_07");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_08()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_08");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_09()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_09");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_10()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_10");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_11()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_11");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_12()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_12");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_13()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_13");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_14()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_14");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_15()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_15");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_16()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_16");
			(new CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_17()).RunTest("CWE681_Incorrect_Conversion_Between_Numeric_Types__floatNaN2int_17");
			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}