using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE690_NULL_Deref_From_Return
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_01()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_01");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_02()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_02");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_03()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_03");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_04()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_04");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_05()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_05");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_06()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_06");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_07()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_07");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_08()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_08");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_09()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_09");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_10()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_10");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_11()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_11");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_12()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_12");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_13()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_13");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_14()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_14");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_15()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_15");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_16()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_16");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_17()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_17");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_21()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_21");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_22a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_22a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_31()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_31");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_41()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_41");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_42()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_42");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_45()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_45");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_51a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_51a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_52a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_52a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_53a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_53a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_54a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_54a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_61a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_61a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_66a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_66a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_67a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_67a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_68a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_68a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_71a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_71a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_72a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_72a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_73a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_73a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_74a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_74a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_75a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_75a");
			(new CWE690_NULL_Deref_From_Return__Class_StringBuilder_81a()).RunTest("CWE690_NULL_Deref_From_Return__Class_StringBuilder_81a");
			(new CWE690_NULL_Deref_From_Return__Class_string_01()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_01");
			(new CWE690_NULL_Deref_From_Return__Class_string_02()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_02");
			(new CWE690_NULL_Deref_From_Return__Class_string_03()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_03");
			(new CWE690_NULL_Deref_From_Return__Class_string_04()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_04");
			(new CWE690_NULL_Deref_From_Return__Class_string_05()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_05");
			(new CWE690_NULL_Deref_From_Return__Class_string_06()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_06");
			(new CWE690_NULL_Deref_From_Return__Class_string_07()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_07");
			(new CWE690_NULL_Deref_From_Return__Class_string_08()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_08");
			(new CWE690_NULL_Deref_From_Return__Class_string_09()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_09");
			(new CWE690_NULL_Deref_From_Return__Class_string_10()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_10");
			(new CWE690_NULL_Deref_From_Return__Class_string_11()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_11");
			(new CWE690_NULL_Deref_From_Return__Class_string_12()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_12");
			(new CWE690_NULL_Deref_From_Return__Class_string_13()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_13");
			(new CWE690_NULL_Deref_From_Return__Class_string_14()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_14");
			(new CWE690_NULL_Deref_From_Return__Class_string_15()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_15");
			(new CWE690_NULL_Deref_From_Return__Class_string_16()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_16");
			(new CWE690_NULL_Deref_From_Return__Class_string_17()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_17");
			(new CWE690_NULL_Deref_From_Return__Class_string_21()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_21");
			(new CWE690_NULL_Deref_From_Return__Class_string_22a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_22a");
			(new CWE690_NULL_Deref_From_Return__Class_string_31()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_31");
			(new CWE690_NULL_Deref_From_Return__Class_string_41()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_41");
			(new CWE690_NULL_Deref_From_Return__Class_string_42()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_42");
			(new CWE690_NULL_Deref_From_Return__Class_string_45()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_45");
			(new CWE690_NULL_Deref_From_Return__Class_string_51a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_51a");
			(new CWE690_NULL_Deref_From_Return__Class_string_52a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_52a");
			(new CWE690_NULL_Deref_From_Return__Class_string_53a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_53a");
			(new CWE690_NULL_Deref_From_Return__Class_string_54a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_54a");
			(new CWE690_NULL_Deref_From_Return__Class_string_61a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_61a");
			(new CWE690_NULL_Deref_From_Return__Class_string_66a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_66a");
			(new CWE690_NULL_Deref_From_Return__Class_string_67a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_67a");
			(new CWE690_NULL_Deref_From_Return__Class_string_68a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_68a");
			(new CWE690_NULL_Deref_From_Return__Class_string_71a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_71a");
			(new CWE690_NULL_Deref_From_Return__Class_string_72a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_72a");
			(new CWE690_NULL_Deref_From_Return__Class_string_73a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_73a");
			(new CWE690_NULL_Deref_From_Return__Class_string_74a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_74a");
			(new CWE690_NULL_Deref_From_Return__Class_string_75a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_75a");
			(new CWE690_NULL_Deref_From_Return__Class_string_81a()).RunTest("CWE690_NULL_Deref_From_Return__Class_string_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */

			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}