using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE789_Uncontrolled_Mem_Alloc
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Connect_tcp_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Database_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Environment_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__File_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__File_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_01");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_02");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_03");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_04");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_05");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_06");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_07");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_08");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_09");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_10");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_11");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_12");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_13");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_14");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_15");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_16");
			(new CWE789_Uncontrolled_Mem_Alloc__heap_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__heap_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_ArrayList_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}