using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE789_Uncontrolled_Mem_Alloc
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Listen_tcp_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__MaxValue_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__NetClient_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_Dictionary_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}