using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;

namespace testcases.CWE789_Uncontrolled_Mem_Alloc
{
	class Program {

		static void Main(string[] args) {
			
			if(args.Any()) {
			
				if(args[0].Equals("-h", StringComparison.OrdinalIgnoreCase) || 
                   args[0].Equals("--help", StringComparison.OrdinalIgnoreCase)) {
			
					Console.WriteLine("To use this main, you can either run the program with no " +
					"command line arguments to run all test cases or you can specify one or more classes to test");
					System.Environment.Exit(1);
				}
				
				/* User supplied some class names on the command line, just use those with introspection
				 *
				 * string classNames[] = { "CWE481_Assigning_instead_of_Comparing__boolean_01",
				 *		"CWE476_Null_Pointer_Dereference__getProperty_01" };
				 * could read class names from command line or use
				 * http://sadun-util.sourceforge.net/api/org/sadun/util/
				 * ClassPackageExplorer.html
				 */

				foreach (string className in args) {

					try {
						
						/* String classNameWithPackage = "testcases." + className; */
						
						/* Console.WriteLine("classNameWithPackage = " + classNameWithPackage); */

						Type myClass = Type.GetType(className);
						object myObject = Activator.CreateInstance(myClass);
						myClass.InvokeMember("runTest", 
							BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public, 
							null, 
							myObject, 
							new object[] { className });

					} catch (Exception ex) {

						Console.WriteLine("Could not run test for class " + className);
						Console.WriteLine(ex.StackTrace);

					}
					
					Console.WriteLine(""); /* leave a blank line between classes */

				}

			} else {
			
				/* No command line args were used, we want to run every testcase */
				
				/* needed to separate these calls into other methods because
				   we were running into the size limit Java has for a single method */
				RunTestCWE1();
				RunTestCWE2();
				RunTestCWE3();
				RunTestCWE4();
				RunTestCWE5();
				RunTestCWE6();
				RunTestCWE7();
				RunTestCWE8();
				RunTestCWE9();
			}			
		}

	private static void RunTestCWE1() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-1 */

			/* END-AUTOGENERATED-CSHARP-TESTS-1 */
	}

	private static void RunTestCWE2() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-2 */

			/* END-AUTOGENERATED-CSHARP-TESTS-2 */
	}

	private static void RunTestCWE3() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-3 */

			/* END-AUTOGENERATED-CSHARP-TESTS-3 */
	}

	private static void RunTestCWE4() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-4 */

			/* END-AUTOGENERATED-CSHARP-TESTS-4 */
	}

	private static void RunTestCWE5() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-5 */

			/* END-AUTOGENERATED-CSHARP-TESTS-5 */
	}

	private static void RunTestCWE6() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-6 */

			/* END-AUTOGENERATED-CSHARP-TESTS-6 */
	}

	private static void RunTestCWE7() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-7 */
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__Random_HashSet_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_01");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_02");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_03");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_04");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_05");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_06");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_07");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_08");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_09");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_10");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_11");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_12");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_13");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_14");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_15");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_16");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_17");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_21");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_31");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_41");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_42");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_45");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_ArrayList_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_01");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_02");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_03");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_04");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_05");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_06");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_07");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_08");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_09");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_10");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_11");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_12");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_13");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_14");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_15");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_16");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_17");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_21");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_31");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_41");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_42");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_45");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_Dictionary_81a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_01()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_01");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_02()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_02");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_03()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_03");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_04()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_04");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_05()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_05");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_06()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_06");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_07()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_07");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_08()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_08");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_09()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_09");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_10()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_10");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_11()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_11");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_12()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_12");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_13()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_13");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_14()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_14");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_15()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_15");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_16()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_16");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_17()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_17");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_21()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_21");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_22a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_22a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_31()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_31");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_41()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_41");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_42()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_42");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_45()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_45");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_51a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_51a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_52a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_52a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_53a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_53a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_54a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_54a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_61a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_61a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_66a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_66a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_67a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_67a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_68a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_68a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_71a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_71a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_72a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_72a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_73a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_73a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_74a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_74a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_75a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_75a");
			(new CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_81a()).RunTest("CWE789_Uncontrolled_Mem_Alloc__ReadLine_HashSet_81a");
			/* END-AUTOGENERATED-CSHARP-TESTS-7 */
	}

	private static void RunTestCWE8() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-8 */

			/* END-AUTOGENERATED-CSHARP-TESTS-8 */
	}

	private static void RunTestCWE9() {
	/* BEGIN-AUTOGENERATED-CSHARP-TESTS-9 */

			/* END-AUTOGENERATED-CSHARP-TESTS-9 */
	}
}
}